     Quick and dirty instruction list to build GPAMELA executable
     ------------------------------------------------------------

		   (F. Cafagna, Bari 11 July 2002)


1. INTRODUCTION

  In this directory you will find all the sources and auxiliary files needed 
  to build GPAMELA.

  GPAMELA sources are distributed in several subdirectories along with 
  the GARFIELD car files needed to build the GARFIELD library. 

  To build GPAMELA you need the Makefile in the top directory along with 
  the file: makefile_linux, stored in the garfield/src directory.

2. BUILD GPAMELA EXECUTABLE FOR INPATIENTS

Here is the list of action for the inpatients:

- Create the directory you want to store executables and run the program, 
  in this example I wil create my_gpamela in my home directory:

  > mkdir  $HOME/my_gpamela

- Define the environment variable GPAMELA_BIN pointing the the created directory:

  > GPAMELA_BIN = $HOME/my_gpamela; export GPAMELA_BIN (for [ba]sh )
  > setenv GPAMELA_BIN $HOME/my_gpamela (for [t]csh)

- Make it: 

  > make distclean; make gpamelax11.exe; make gpamela.exe
  > make gpamelax11_deb.exe; make gpamela_deb.exe
  
- Install it:

  > make install

3. DIRECTORY TREE

Here follows the gpamela directory tree:
.
|-- Makefile
|-- aux
|   |-- Auxiliary files needed by GPAMELA, i.e. field map, data cards, 
|       garfield definitions etc. etc. 
|-- cmz
|   `-- Versions
|       |-- History of the previous CMZ releases
|-- garfield
|   `-- src
|       |-- GARFIELD sources and makefile
|-- gcdes
|   |-- GEANT 3.21 include files
|-- gpamela
|   |-- general purpose routine, for example GUSTEP, GPDAT etc. etc. 
|-- gpcal
|   |-- CALorimeter related routines 
|-- gpcas
|   |-- CAS related soubroutine
|-- gpcat
|   |-- CAT related soubroutine
|-- gpcdes
|   |-- GPAMELA include files
|-- gpfield
|   |-- magnetic field related subroutines
|-- gpgar
|   |-- GPAMELA- GARFIELD interface related subroutines
|-- gphys
|   |-- obsolete routines to integrate dE/dx fluctuations 
|        in the GEANT physics bank
|-- gpmain
|   `-- GPAMELA main routine
|-- gpobsolete
|   |-- obsolete code for tracker digitization
|-- gpspe
|   |-- SPEctrometer related subroutine
|-- gptof
|   |-- TOF related subroutine
|-- gptrd
|   |-- TOF related subroutine 
|-- gpxint
|   |-- GPAMELA main routine for the interactive version
|-- history
|   `-- history file (GPAMELA logbook)
`-- inform
    `-- list and usage of GPAMELA data cards

Please note that no lib and bin directories are presents in the distribution. 
They will be created by make. 

Please note that all the source files have the .F extensions, they must be preprocessed. 

4. BUILD GPAMELA EXECUTABLE, LONG VERSION

You can create GPAMELA executables using gmake. For sake of simplicity I am 
using just one Makefile located in the top directory: gpamela. 

The Makefile will create the executables locally in the bin directory
of the top directory gpamela and will install them into the any user
created directory along with the auxiliaries files need. You can pass
the used directory via the GPAMELA_BIN environment variable.

Please note that the Makefile does use GNUmake: gmake,
extension. Usually in the RedHat Linux distributions make points to
gmake so the usage is equivalent.

The Makefile contains the following targets:

-gpamelax11.exe     : builds the interactive version of GPAMELA
-gpamela.exe        : builds the batch version of GPAMELA
-gpamelax11_deb.exe : builds the interactive version of GPAMELA with debug flags
-gpamela_deb.exe    : builds the batch version of GPAMELA with debug flags
-depend             : creates dependency files for each source file
-install            : install GPAMELA executables and auxiliary files in GPAMELA_BIN
-${GPLIBDIR}/libgarfield-7.a: builds the GARFIELD library in garfield/src directory
-createdir          : creates the ./bin directory in the top directory
-distclean          : deletes all the objects, dependency files, executables, 
                      GARFIELD library, bin and lib directories
-clean              : deletes all the objects and dependency files

The Makefile contains the following implicit rule:

%.d: %.F  : builds dependency files from the .F files

Please note that no rule has been included to build dependencies for .f files. 
To avoid confusion all the GPAMELA fortran sources must have the .F extension. 

The Makefiles does use the g77 capability of creating dependencies suitable for
usage in makefile. Once the dependency files have been created Makefiles does include
them and use them as targets to build the objects from the sources. 
Because I am using a single Makefile in the top directory the rule does create the 
dependency files in the subdirectories. 

Please note tha gmake scans the Makefile before executing it. If no
files are available for the include directive gmake will try to build
them. For this reason you will get the "Creating dependency files"
message also when you try to delete them .......

Please note that all the object files are deleted after executable
creation. Because the GPAMELA code relies on the preprocessor
directives codes must be preprocessed for each case, i.e. interactive
or not interactive version. Deleting them in each executable target
will force the object creation next time you build any target.  To be
sure you are using the right objects you should issue a "make clean"
command before any executable creation.

Please note that the dependency files are note recreated. This means
that they should not depend on preprocessor directives, i.e. #if
#define etc. etc. 

GPAMELA depends on GARFIELD libraries. In case libgarfield-7.a is not
present in the lib subdirectory it will be created from scratch. This
is a long procedure that may take several minutes.

Here is the list of action to build GPAMELA executables:

- Create the directory you want to store executables and run the program, 
  in this example I wil create my_gpamela in my home directory:

  > mkdir  $HOME/my_gpamela

- Define the environment variable GPAMELA_BIN pointing the the created directory:

  > GPAMELA_BIN = $HOME/my_gpamela; export GPAMELA_BIN (for [ba]sh )
  > setenv GPAMELA_BIN $HOME/my_gpamela (for [t]csh)

- Delete all the objects, dependency files and GARFIELD library (you never know): 
  > make distclean 

- Create interactive executable (it will create the libgarfield-7.a also):
  > make gpamelax11.exe; 

- Create batch executable: 
  > make gpamela.exe

- Create debug versions
  > make gpamelax11_deb.exe; make gpamela_deb.exe
  
- Install all executables, along with GPAMELA.FFR, gpfield.rz,
  TRD_ATT.DAT, PROVA.GAR, in GPAMELA_BIN directory:
  > make install

5. OUTPUT MESSAGES

To maintain backward compatibility with the previous g77 version, I am
still using the debug-kludge flag to access fortran COMMONs in
debug. This is obsolete in the new release: 2.96. For this reason if
you are running a RedHat 7.x you will receive the message:

f771:warning: -fdebug-kludge disabled, use normal debugging flags

During gpamelax11(_deb).exe building you will get the message:

/cern/pro/lib/libpawlib.a(bugrep.o): In function `br_create_template':
bugrep.o(.text+0x113): the use of `tmpnam' is dangerous, better use `mkstemp'

It is a warning related to the pawlib in the cern release that is still not RH7.x certified. 

*
* $Id$
*
* $Log$
*
* This directory was created from gpamela.car patch _inform
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  3.00/00 08/02/2002  17.33.00  by  Unknown
*CMZ :  2.03/00 06/11/2000  01.40.19  by  Francesco Cafagna
*CMZ :  2.02/00 12/10/2000  16.03.56  by  Francesco Cafagna
*CMZU:  2.01/00 05/04/2000  09.51.03  by  Unknown
*CMZ :  2.00/00 03/03/2000  15.33.44  by  Francesco Cafagna
*CMZ :  1.02/00 25/01/2000  18.22.29  by  Francesco Cafagna
*CMZ :  1.01/01 23/05/96  17.11.59  by  Francesco Cafagna
*CMZ :  1.01/00 22/05/96  09.46.03  by  Francesco Cafagna
*CMZ :  1.00/03 30/04/96  17.40.07  by  Francesco Cafagna
*CMZ :  1.00/02 03/04/96  18.23.50  by  Francesco Cafagna
*CMZ :  1.00/01 28/11/95  18.54.38  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   28/11/95

 GPAMELA: A GEANT based montecarlo of PAMELA

   This CMZ file contains:
     A.patchy $VERSION  , with the version in use
     B.patchy $HISTORY  , general comments on changes and implementations
     C.patchy $INFORM   , infos on patchy and flag to be used in the program
     D.patchy $KUMACS   , collection of CMZ kumacs
     E.patchy $MANUAL   , LaTeX version of the program user guide
     E.patchy *GPAMELA  , pilot patchy with the +USE directives
     F.patchy GPCDES    , patchy with common definitions
     G.patchy GPAMELA   , main patchy with the general routines
     H.patchy GPTOF     , patchy with specific TOF routines
     I.patchy GPTRD     , patchy with specific TRD routines
     L.patchy GPCALO    , patchy with specific CALO routines
     M.patchy GPSPEC    , patchy with specific SPECTROMETER routines
     N.patchy GPFIELD   , patchy with specific MAGNETIC FIELD routines
     O.patchy GPHYS     , patchy with specific PHYSics routines
     P.patchy GPOBSOLETE, patchy with routines declared obsolete
     Q.patchy GPGAR     , patchy with GARFIELD interface routines

   Flags used:
     INTER   , To select interactive version option.
     DEB     , To select the same option of INTER in GUKINE without the full
               interactive version options.
     HIGZ    , To select HIGZ related code.
     X11     , To select X11 version
     PP      , To select ++ version
     MAGNET  , To select magnetic field correction in spectrometer digits.

     TYPE    , Used in GEANT GCDES to explicit declare the variable type.
     SINGLE  , Used in GEANT GCDES to select single precision
     INCLUDE , Used in GEANT GCDES
     NOGFLUCT, To select Gaussian straggling calculation inside the GPUCAL
               and GPUSPE routines instead that the GFLUCT one.
     GARFIELD, To select GARFIELD interface
     MANYWIRE, LONGLIST, BIGMAP, To be used with GARFIELD

   For the use of fluka as hadronic process simulation program the file
   FLUKAAF.DAT is necessary. For this reason the CERN_ROOT environment
   variable has to be added in the file .login with the value /cern/pro.


   DATA CARDS definition and usage. If not specified you can use DATA CARDS
   options in any order.

+--------------+----------------------+---------------------------------------+
| DATA CARD    | USAGE                | ACTION                                |
+--------------+----------------------+---------------------------------------+
| MAGN         | 1 or 2 or 3          | Select magnetic field type. 1 is the  |
|              |                      | strongly inhomogeneus case,           |
|              |                      | GPFIELD.MAP is required               |
|              |                      |                                       |
| NDET         |        'TOF ' 'TRD ' | Do not simulate the selected          |
|              | 'SPE ' 'CAL ' 'CAT ' | detectors                             |
|              | 'CAS ' 'SPHE'        |                                       |
|              |                      |                                       |
| CAS          | 'NVOL' 'NPHY' 'NHBK' | Disable CAS volume simulation, as NDET|
|              |                      | or physics, i.e. SET DET or hits, or  |
|              |                      | n-tple definition.                    |
|              |                      |                                       |
| CAT          | 'NVOL' 'NPHY' 'NHBK' | Disable CAT volume simulation, as NDET|
|              |                      | or physics, i.e. SET DET or hits, or  |
|              |                      | n-tple definition.                    |
|              |                      |                                       |
| TOF          | 'NVOL' 'NPHY' 'NHBK' | Disable TOF volume simulation, as NDET|
|              |                      | or physics, i.e. SET DET or hits, or  |
|              |                      | n-tple definition.                    |
|              |                      |                                       |
| TRD          | 'NVOL' 'NPHY' 'NHBK' | Disable TRD volume simulation, as NDET|
|              |                      | or physics, i.e. SET DET or hits, or  |
|              |                      | n-tple definition.                    |
|              |                      |                                       |
| SPE          | 'NVOL' 'NPHY' 'NHBK' | Disable SPE volume simulation, as NDET|
|              |                      | or physics, i.e. SET DET or hits, or  |
|              |                      | n-tple definition.                    |
|              |                      |                                       |
| CAL          | 'NVOL' 'NPHY' 'NHBK' | Disable CAL volume simulation, as NDET|
|              |                      | or physics, i.e. SET DET or hits, or  |
|              |                      | n-tple definition.                    |
|              |                      |                                       |
| S4           | 'NVOL' 'NPHY' 'NHBK' | Disable S4  volume simulation, as NDET|
|              |                      | or physics, i.e. SET DET or hits, or  |
|              |                      | n-tple definition.                    |
|              |                      |                                       |
| HCWN         | 1                    | Enable CWN-tple                       |
|              |                      |                                       |
| HLON         | 1                    | Select CWN long format                |
|              |                      |                                       |
| NCPL         | 44 integers 1<=n<=44 | Exclude the listed calorimeter silicon|
|              | Ex.: 1 33 6 12 31=10 | plane from the simulation             |
|              |                      |                                       |
| NCSI         |  9 integers 1<=n<=9  | Exclude the listed calorimeter silicon|
|              | Ex.: 1 3=9 6 5=4     | detectors from any calorimeter plane  |
|              |                      |                                       |
|              |                      |                                       |
| NCAB         | 22 integers 1<=n<=22 | Exclude the listed calorimeter        |
|              | Ex.: 4=22 20 7 11=2  | absorber planes from the simulation   |
|              |                      |                                       |
| CALO         | 'NOWn'               | Use 'n' planes without tungsten       |
|              |                      |                                       |
| SPTM         | 'SICA' 'W   ' 'SITR' | Enable Special Tracking Parameter for |
|              | 'SITR' 'XE  ' 'SCIN' | selected tracking media               |
|              | 'TRAD' 'FE  ' 'KAP ' | To obtain the correct energy value for|
|              | 'N2G ' 'G10 ' 'AL  ' | the calorimeter, "SICA","G10C","W2  ' |
|              | 'AER ' 'ROA ' 'CE  ' | and "CE  " MUST be enabled.           |
|              | 'W2  ' 'G10C'        |                                       |
|              |                      |                                       |
| HPAK         | 'FLUK'               | To select FLUKA as hadronic process   |
|              |                      | simulation programn.                  |
|              |                      |                                       |
| AUTM         | 'TMAX' 'STMA' 'DEEM' | Force AUTO calculation for specified  |
|              | 'EPSI' 'STMI'        | parameters, regardless of AUTO data   |
|              |                      | card value                            |
|              |                      |                                       |
| TMAX         | Any real number      | Pass TMAXFD tracking parameter value  |
|              |                      |                                       |
| STMA         | Any real number      | Pass STEMAX tracking parameter value  |
|              |                      |                                       |
| DEEM         | Any real number      | Pass DEEMAX tracking parameter value  |
|              |                      |                                       |
| EPSI         | Any real number      | Pass EPSIL  tracking parameter value  |
|              |                      |                                       |
| STMI         | Any real number      | Pass STMIN  tracking parameter value  |
|              |                      |                                       |
| TPAL         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for aluminum                    |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TG10         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for G10                         |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| T10C         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for calorimeter G10C            |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TPN2         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for nitrogen gas                |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TPW          | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for tungsten                    |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TPW2         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for calorimeter tungsten mix    |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TPKA         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for kapton                      |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TPFE         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for iron                        |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TRAD         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for TRD radiator                |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TPRO         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for roacell                     |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TPCF         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for carbon fibers               |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TPSC         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for scintillator                |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TSCA         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for silicon (calorimeter)       |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TSTR         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for silicon (tracker)           |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TPXE         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for Xenon                       |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TPAE         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for aerogel                     |
|              | 5=STMIN              |                                       |
|              |                      |                                       |
| TPCE         | 1=TMAXFD 2=STEMAX    | Pass TMAXFD, STEMAX,DEEMAX, EPSIL and |
|              | 3=DEEMAX 4=EPSIL     | STMIN for kaolinite (calorimeter      |
|              | 5=STMIN              | insulator)                            |
|              |                      |                                       |
| *HBFI        | 11 'HB$REF:GP.HIS'   | To define user LUNIT and name         |
|              |                      | HBOOK file. (Max 80 characters )      |
|              |                      |                                       |
| *GAFI        | 12 'FILENAME.GAR'    | To define user LUNIT and name         |
|              |                      | for GARFIELD file.(Max 80 characters) |
|              |                      |                                       |
| STTR         | 1=1 2=D2SICA 3=D2SITR| Force gussian straggling just for     |
|              |                      | silicon in GFLUCT. D2SICA & D2SITR are|
|              |                      | the parameter to be passed to the     |
|              |                      | gaussian generator.                   |
|              |                      |                                       |
| DZSH         | Any real number with | Height adjustment for external shell  |
|              | Sign                 |                                       |
|              |                      |                                       |
| GEN          | XGEN, YGEN, ZGEN,    | Pass the coordinates of the origin and|
|              | XDGEN, YDGEN         | the dimensions of the generation      |
|              |                      | surface.                              |
|              |                      |                                       |
| PHI          | PHGEN(1), PHGEN(2)   | Define the minimum and the maximum    |
|              |                      | azimuth. Default values are:          |
|              |                      | 0., 360.                              |
|              |                      |                                       |
| THET         | THGEN(1), THGEN(2)   | Define the minimum and the maximum    |
|              |                      | zenith. Default values are:           |
|              |                      | 0., 90.                               |
+--------------+----------------------+---------------------------------------+

NOTE: To process a large number of events in batch mode, on Linux
   system, the Geant data card TIME must be used. It is necessary to set
   ITIME < 0.  This will force no check on the CPU time left to end the
   program. For some reason it terminates the program also if no TIME
   card is used.

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 21/10/99  16.30.25  by  Francesco Cafagna
*CMZ :  1.00/02 18/03/96  17.18.03  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   05/12/95
      SUBROUTINE GPTOFV
************************************************************************
*                                                                      *
* Volumes definition for the scintillators counters                    *
* Called by: GPGEO                                                     *
* Author: Francesco Cafagna, 05/12/95 13.39.41                         *
*                                                                      *
************************************************************************
#include "gpgeo.inc"
#include "gpmed.inc"
*
      INTEGER IROT,IVOLU,N,NMED,NUM
      REAL X,Y,Z
*
      NMED=MN2
*
*  Define the S11     volume
*
      CALL GSVOLU('S11 ','BOX ',NMED,S11, 3,IVOLU)
*
*  Define the S12     volume
*
      CALL GSVOLU('S12 ','BOX ',NMED,S12, 3,IVOLU)
*
*  Define the S21     volume
*
      CALL GSVOLU('S21 ','BOX ',NMED,S21, 3,IVOLU)
*
*  Define the S22     volume
*
      CALL GSVOLU('S22 ','BOX ',NMED,S22, 3,IVOLU)
*
*  Define the S31     volume
*
      CALL GSVOLU('S31 ','BOX ',NMED,S31, 3,IVOLU)
*
*  Define the S32     volume
*
      CALL GSVOLU('S32 ','BOX ',NMED,S32, 3,IVOLU)
*
*  Change medium just for S4.
*
      NMED=MSCIN
*
*  Define the S4     volume
*
      CALL GSVOLU('S4  ','BOX ',NMED,S4, 3,IVOLU)
*
*  Start subvolume definition.
*
*
*  Define the S11X     volume
*
      CALL GSVOLU('S11X','BOX ',NMED,S11X, 3,IVOLU)
*
*  Define the S12Y     volume
*
      CALL GSVOLU('S12Y','BOX ',NMED,S12Y, 3,IVOLU)
*
*  Define the S21X     volume
*
      CALL GSVOLU('S21X','BOX ',NMED,S21X, 3,IVOLU)
*
*  Define the S22Y     volume
*
      CALL GSVOLU('S22Y','BOX ',NMED,S22Y, 3,IVOLU)
*
*  Define the S31Y     volume
*
      CALL GSVOLU('S31Y','BOX ',NMED,S31Y, 3,IVOLU)
*
*  Define the S32X     volume
*
      CALL GSVOLU('S32X','BOX ',NMED,S32X, 3,IVOLU)

      NMED=MCF
*
*  Define the SC11     volume
*
      CALL GSVOLU('SC11','BOX ',NMED,SC11, 3,IVOLU)
*
*  Define the SC12     volume
*
      CALL GSVOLU('SC12','BOX ',NMED,SC12, 3,IVOLU)
*
*  Define the SC21     volume
*
      CALL GSVOLU('SC21','BOX ',NMED,SC21, 3,IVOLU)
*
*  Define the SC22     volume
*
      CALL GSVOLU('SC22','BOX ',NMED,SC22, 3,IVOLU)

*
*  Define the SC31     volume
*
      CALL GSVOLU('SC31','BOX ',NMED,SC31, 3,IVOLU)
*
*  Define the SC32     volume
*
      CALL GSVOLU('SC32','BOX ',NMED,SC32, 3,IVOLU)

*
* Positioning volumes
*
      Y= 0
      Z= 0
      DO I=1,NS11X
         N= I
         X= -S11(1) + (2*I-1)*S11X(1)
         CALL GSPOS('S11X',N,'S11 ',X,Y,Z,0,'ONLY')
      ENDDO
      X= 0.
      Y= 0.
      DO I=1,2
         N= I
         Z= (-1.)**I*S11(3) + (-1.)**(I+1)*SC11(3)
         CALL GSPOS('SC11',N,'S11 ',X,Y,Z,0,'ONLY')
      ENDDO
*
      X= 0
      Z= 0
      DO I=1,NS12Y
         N= I
         Y= -S12(2) + (2*I-1)*S12Y(2)
         CALL GSPOS('S12Y',N,'S12 ',X,Y,Z,0,'ONLY')
      ENDDO
      X= 0.
      Y= 0.
      DO I=1,2
         N= I
         Z= (-1.)**I*S12(3) + (-1.)**(I+1)*SC12(3)
         CALL GSPOS('SC12',N,'S12 ',X,Y,Z,0,'ONLY')
      ENDDO
*
      Y= 0
      Z= 0
      DO I=1,NS21X
         N= I
         X= -S21(1) + (2*I-1)*S21X(1)
         CALL GSPOS('S21X',N,'S21 ',X,Y,Z,0,'ONLY')
      ENDDO
      X= 0.
      Y= 0.
      DO I=1,2
         N= I
         Z= (-1.)**I*S21(3) + (-1.)**(I+1)*SC21(3)
         CALL GSPOS('SC21',N,'S21 ',X,Y,Z,0,'ONLY')
      ENDDO
*
      X= 0
      Z= 0
      DO I=1,NS22Y
         N= I
         Y= -S22(2) + (2*I-1)*S22Y(2)
         CALL GSPOS('S22Y',N,'S22 ',X,Y,Z,0,'ONLY')
      ENDDO
      X= 0.
      Y= 0.
      DO I=1,2
         N= I
         Z= (-1.)**I*S22(3) + (-1.)**(I+1)*SC22(3)
         CALL GSPOS('SC22',N,'S22 ',X,Y,Z,0,'ONLY')
      ENDDO
*
      X= 0
      Z= 0
      DO I=1,NS31Y
         N= I
         Y= -S31(2) + (2*I-1)*S31Y(2)
         CALL GSPOS('S31Y',N,'S31 ',X,Y,Z,0,'ONLY')
      ENDDO
      X= 0.
      Y= 0.
      DO I=1,2
         N= I
         Z= (-1.)**I*S31(3) + (-1.)**(I+1)*SC31(3)
         CALL GSPOS('SC31',N,'S31 ',X,Y,Z,0,'ONLY')
      ENDDO
*
      Y= 0
      Z= 0
      DO I=1,NS32X
         N= I
         X= -S32(1) + (2*I-1)*S32X(1)
         CALL GSPOS('S32X',N,'S32 ',X,Y,Z,0,'ONLY')
      ENDDO
      X= 0.
      Y= 0.
      DO I=1,2
         N= I
         Z= (-1.)**I*S32(3) + (-1.)**(I+1)*SC32(3)
         CALL GSPOS('SC32',N,'S32 ',X,Y,Z,0,'ONLY')
      ENDDO
*
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 28/09/2001  22.33.28  by  Unknown
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.01/00 30/04/96  18.28.33  by  Francesco Cafagna
*CMZ :  1.00/03 29/04/96  17.05.38  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   29/04/96
      SUBROUTINE GPUTRE(IFLAG)
************************************************************************
*                                                                      *
* User action in GUTREV                                                *
*                                                                      *
* Variables definition:                                                *
* IN:                                                                  *
*  IFLAG = 1, before GTREVE call in GUTREV                             *
*  IFLAG = 2, after  GTREVE call in GUTREV                             *
*                                                                      *
* Called by: GUTREV                                                    *
* Author: Francesco Cafagna, 29/04/96 17.05.38                         *
*                                                                      *
************************************************************************
#include "gptotr.inc"
      INTEGER IFLAG
*
      IF(IFLAG.EQ.1) THEN
C #
C # Reset Transition radiation related quantities
C #
         ENTRTOT=0
         CALL VZERO(ENLAY,18)
         NPHTOTR=0
         CALL VZERO(NPHLAY,18)
         CALL VZERO(ENTRSTRAW,32*32)
         CALL VZERO(NTRSTRAW,32*32)
      ENDIF
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 25/01/2002  19.00.30  by  Marialuigia Ambriola
*CMZ :  2.01/00 08/03/2000  18.32.08  by  Unknown
*CMZ :  2.00/00 29/02/2000  14.18.34  by  Francesco Cafagna
*CMZ :  1.02/00 07/11/99  17.40.38  by  Francesco Cafagna
*CMZ :  1.01/00 22/05/96  12.52.18  by  Francesco Cafagna
*CMZ :  1.00/03 19/04/96  14.07.01  by  Francesco Cafagna
*CMZ :  1.00/02 05/04/96  15.19.07  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE GPHBK
************************************************************************
*                                                                      *
*                                                                      *
*             To book the user's histograms                            *
*                                                                      *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 30/11/95 16.20.45                         *
*                                                                      *
************************************************************************
#include "gppntp.inc"
#include "gpgene.inc"
#include "gpphit.inc"
#include "gppdigi.inc"
#include "gptof.inc"
#include "gptrd.inc"
#include "gpcat.inc"
#include "gpcas.inc"
#include "gpspe.inc"
#include "gpcal.inc"
#include "gptotr.inc"
*
#include "gpkey.inc"
      INTEGER ISTAT,IERR
*ML:
      CHARACTER*50 CHFORM
*END ML.
*
*     ------------------------------------------------------------------
C
C You need all the previous commons to declare the CWN-tpla blocks to HBOOK
C
      CALL HCDIR('//GPAMELA',' ')
      CALL HBNT(NCWN,'GPAMELA','D')
      CALL HBNAME(NCWN,'GENERAL',IRUN,'IRUN:I,IEVNT:I,IPA:I,X0,Y0,'
     +//'Z0,THETA,PHI,P0')
C
C TOF
C
      IF(HTOF) THEN
         IF(HLONG) THEN
            CALL HBNAME(NCWN,'TOF',NTHTOF,'NTHTOF:I::[0,100],'
     +           //'IPLTOF(NTHTOF):I::[0,7],IPADDLE(NTHTOF):I::[0,16],'
     +           //'IPARTOF(NTHTOF):I::[0,100],XINTOF(NTHTOF),'
     +           //'YINTOF(NTHTOF),'
     +           //'ZINTOF(NTHTOF),XOUTTOF(NTHTOF),YOUTTOF(NTHTOF),'
     +           //'ZOUTTOF(NTHTOF),'
     +           //'ERELTOF(NTHTOF),TIMETOF(NTHTOF),PATHTOF(NTHTOF),'
     +           //'P0TOF(NTHTOF)')
         ELSE
            CALL HBNAME(NCWN,'TOF',NTHTOF,'NTHTOF:I::[0,100],'
     +           //'IPLTOF(NTHTOF):I::[0,7],IPADDLE(NTHTOF):I::[0,16],'
     +           //'IPARTOF(NTHTOF):I::[0,100]')
            CALL HBNAME(NCWN,'TOF',XAVTOF,'XAVTOF(NTHTOF),'
     +           //'YAVTOF(NTHTOF),ZAVTOF(NTHTOF)')
            CALL HBNAME(NCWN,'TOF',ERELTOF,'ERELTOF(NTHTOF),'
     +           //'TIMETOF(NTHTOF)')
            CALL HBNAME(NCWN,'TOF',P0TOF,'P0TOF(NTHTOF)')
         ENDIF
      ENDIF
C
C TRD
C
      IF(HTRD) THEN
*ML:
         WRITE(CHFORM,10000)NHMTRD+1
10000    FORMAT('NTHTRD:I::[0,',I4,']')
*END ML.
         IF(HLONG) THEN
*ML:
            CALL HBNAME(NCWN,'TRD',NTHTRD,CHFORM)
*END ML.
*            CALL HBNAME(NCWN,'TRD',NTHTRD,'NTHTRD:I::[0,100]')
            CALL HBNAME(NCWN,'TRD',IPARTRD,'IPARTRD(NTHTRD):I::[0,120]')
            CALL HBNAME(NCWN,'TRD',ITRBS,'ITRBS(NTHTRD):I::[0,100]')
*ML:
*            CALL HBNAME(NCWN,'TRD',ITRSO,'ITRSO(NTHTRD):I::[0,32]')
            CALL HBNAME(NCWN,'TRD',ITRSI,'ITRSI(NTHTRD):I::[0,32]')
*END ML.
            CALL HBNAME(NCWN,'TRD',XINTRD,'XINTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',YINTRD,'YINTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',ZINTRD,'ZINTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',XOUTTRD,'XOUTTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',YOUTTRD,'YOUTTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',ZOUTTRD,'ZOUTTRD(NTHTRD)')
c            CALL HBNAME(NCWN,'TRD',ERELTRD,'ERELTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',ELOSTRD,'ELOSTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',PATHTRD,'PATHTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',P0TRD,'P0TRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',ETRTRD,'ETRTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',NTRTRD,'NTRTRD(NTHTRD):I')
C ML:
#if defined(GPAMELA_GARFIELD)
            CALL HBNAME(NCWN,'TRD',EGARTRD,'EGARTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',NGARTRD,'NGARTRD(NTHTRD):I')
            CALL HBNAME(NCWN,'TRD',ERELTRD,'ERELTRD(NTHTRD)')
#endif
C END ML.
C #
C # This is just for the Transition radiation production
C #
c            CALL HBNAME(NCWN,'TR',ENTRTOT,'ENTRTOT,ENLAY(18):R')
c            CALL HBNAME(NCWN,'TR',NPHTOTR,'NPHTOTR:I,NPHLAY(18):I')
c            CALL HBNAME(NCWN,'TR',ENTRSTRAW,'ENTRSTRAW(32,32):R')
c            CALL HBNAME(NCWN,'TR',NTRSTRAW,'NTRSTRAW(32,32):I')
         ELSE
*ML:
            CALL HBNAME(NCWN,'TRD',NTHTRD,CHFORM)
*END ML.
*            CALL HBNAME(NCWN,'TRD',NTHTRD,'NTHTRD:I::[0,100]')
            CALL HBNAME(NCWN,'TRD',IPARTRD,'IPARTRD(NTHTRD):I::[0,120]')
            CALL HBNAME(NCWN,'TRD',ITRBS,'ITRBS(NTHTRD):I::[0,100]')
*ML:
*            CALL HBNAME(NCWN,'TRD',ITRSO,'ITRSO(NTHTRD):I::[0,32]')
            CALL HBNAME(NCWN,'TRD',ITRSI,'ITRSI(NTHTRD):I::[0,32]')
*END ML.
            CALL HBNAME(NCWN,'TRD',XAVTRD,'XAVTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',YAVTRD,'YAVTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',ZAVTRD,'ZAVTRD(NTHTRD)')
C            CALL HBNAME(NCWN,'TRD',ERELTRD,'ERELTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',P0TRD,'P0TRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',ETRTRD,'ETRTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',NTRTRD,'NTRTRD(NTHTRD):I')
C ML:
#if defined(GPAMELA_GARFIELD)
            CALL HBNAME(NCWN,'TRD',EGARTRD,'EGARTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',NGARTRD,'NGARTRD(NTHTRD)')
            CALL HBNAME(NCWN,'TRD',ERELTRD,'ERELTRD(NTHTRD)')
#endif
C END ML.
C #
C # This is just for the Transition radiation production
C #
c            CALL HBNAME(NCWN,'TR',ENTRTOT,'ENTRTOT,ENLAY(18):R')
c            CALL HBNAME(NCWN,'TR',NPHTOTR,'NPHTOTR:I,NPHLAY(18):I')
c            CALL HBNAME(NCWN,'TR',ENTRSTRAW,'ENTRSTRAW(32,32):R')
c            CALL HBNAME(NCWN,'TR',NTRSTRAW,'NTRSTRAW(32,32):I')
         ENDIF
      ENDIF
C
C CAT
C
      IF(HCAT) THEN
         IF(HLONG) THEN
            CALL HBNAME(NCWN,'CAT',NTHCAT,'NTHCAT:I::[0,50]')
            CALL HBNAME(NCWN,'CAT',IPARCAT,'IPARCAT(NTHCAT):I::[0,120]')
            CALL HBNAME(NCWN,'CAT',ICAT,'ICAT(NTHCAT):I::[0,4]')
            CALL HBNAME(NCWN,'CAT',XINCAT,'XINCAT(NTHCAT)')
            CALL HBNAME(NCWN,'CAT',YINCAT,'YINCAT(NTHCAT)')
            CALL HBNAME(NCWN,'CAT',ZINCAT,'ZINCAT(NTHCAT)')
            CALL HBNAME(NCWN,'CAT',XOUTCAT,'XOUTCAT(NTHCAT)')
            CALL HBNAME(NCWN,'CAT',YOUTCAT,'YOUTCAT(NTHCAT)')
            CALL HBNAME(NCWN,'CAT',ZOUTCAT,'ZOUTCAT(NTHCAT)')
            CALL HBNAME(NCWN,'CAT',ERELCAT,'ERELCAT(NTHCAT)')
            CALL HBNAME(NCWN,'CAT',TIMECAT,'TIMECAT(NTHCAT)')
            CALL HBNAME(NCWN,'CAT',PATHCAT,'PATHCAT(NTHCAT)')
            CALL HBNAME(NCWN,'CAT',P0CAT,'P0CAT(NTHCAT)')
         ELSE
            CALL HBNAME(NCWN,'CAT',NTHCAT,'NTHCAT:I::[0,50]')
            CALL HBNAME(NCWN,'CAT',IPARCAT,'IPARCAT(NTHCAT):I::[0,120]')
            CALL HBNAME(NCWN,'CAT',ICAT,'ICAT(NTHCAT):I::[0,4]')
            CALL HBNAME(NCWN,'CAT',P0CAT,'P0CAT(NTHCAT)')
         ENDIF
      ENDIF
C
C CAS
C
      IF(HCAS) THEN
         IF(HLONG) THEN
            CALL HBNAME(NCWN,'CAS',NTHCAS,'NTHCAS:I::[0,50]')
            CALL HBNAME(NCWN,'CAS',IPARCAS,'IPARCAS(NTHCAS):I::[0,120]')
            CALL HBNAME(NCWN,'CAS',ICAS,'ICAS(NTHCAS):I::[0,4]')
            CALL HBNAME(NCWN,'CAS',XINCAS,'XINCAS(NTHCAS)')
            CALL HBNAME(NCWN,'CAS',YINCAS,'YINCAS(NTHCAS)')
            CALL HBNAME(NCWN,'CAS',ZINCAS,'ZINCAS(NTHCAS)')
            CALL HBNAME(NCWN,'CAS',XOUTCAS,'XOUTCAS(NTHCAS)')
            CALL HBNAME(NCWN,'CAS',YOUTCAS,'YOUTCAS(NTHCAS)')
            CALL HBNAME(NCWN,'CAS',ZOUTCAS,'ZOUTCAS(NTHCAS)')
            CALL HBNAME(NCWN,'CAS',ERELCAS,'ERELCAS(NTHCAS)')
            CALL HBNAME(NCWN,'CAS',TIMECAS,'TIMECAS(NTHCAS)')
            CALL HBNAME(NCWN,'CAS',PATHCAS,'PATHCAS(NTHCAS)')
            CALL HBNAME(NCWN,'CAS',P0CAS,'P0CAS(NTHCAS)')
         ELSE
            CALL HBNAME(NCWN,'CAS',NTHCAS,'NTHCAS:I::[0,50]')
            CALL HBNAME(NCWN,'CAS',IPARCAS,'IPARCAS(NTHCAS):I::[0,120]')
            CALL HBNAME(NCWN,'CAS',ICAS,'ICAS(NTHCAS):I::[0,4]')
            CALL HBNAME(NCWN,'CAS',P0CAS,'P0CAS(NTHCAS)')
         ENDIF
      ENDIF
C
C SPE
C
      IF(HSPE) THEN
         IF(HLONG) THEN
            CALL HBNAME(NCWN,'SPE',NTHSPE,'NTHSPE:I::[0,100]')
            CALL HBNAME(NCWN,'SPE',IPARSPE,'IPARSPE(NTHSPE):I::[0,120]')
            CALL HBNAME(NCWN,'SPE',ITRPB,'ITRPB(NTHSPE):I::[0,6]')
            CALL HBNAME(NCWN,'SPE',ITRSL,'ITRSL(NTHSPE):I::[0,6]')
            CALL HBNAME(NCWN,'SPE',ITSPA,'ITSPA(NTHSPE):I::[0,2]')
            CALL HBNAME(NCWN,'SPE',XINSPE,'XINSPE(NTHSPE)')
            CALL HBNAME(NCWN,'SPE',YINSPE,'YINSPE(NTHSPE)')
            CALL HBNAME(NCWN,'SPE',ZINSPE,'ZINSPE(NTHSPE)')
            CALL HBNAME(NCWN,'SPE',XOUTSPE,'XOUTSPE(NTHSPE)')
            CALL HBNAME(NCWN,'SPE',YOUTSPE,'YOUTSPE(NTHSPE)')
            CALL HBNAME(NCWN,'SPE',ZOUTSPE,'ZOUTSPE(NTHSPE)')
            CALL HBNAME(NCWN,'SPE',ERELSPE,'ERELSPE(NTHSPE)')
            CALL HBNAME(NCWN,'SPE',PATHSPE,'PATHSPE(NTHSPE)')
            CALL HBNAME(NCWN,'SPE',P0SPE,'P0SPE(NTHSPE)')
         ELSE
            CALL HBNAME(NCWN,'SPE',NTHSPE,'NTHSPE:I::[0,100]')
            CALL HBNAME(NCWN,'SPE',IPARSPE,'IPARSPE(NTHSPE):I::[0,120]')
            CALL HBNAME(NCWN,'SPE',ITRPB,'ITRPB(NTHSPE):I::[0,6]')
            CALL HBNAME(NCWN,'SPE',ITRSL,'ITRSL(NTHSPE):I::[0,6]')
            CALL HBNAME(NCWN,'SPE',ITSPA,'ITSPA(NTHSPE):I::[0,2]')
            CALL HBNAME(NCWN,'SPE',XAVSPE,'XAVSPE(NTHSPE)')
            CALL HBNAME(NCWN,'SPE',YAVSPE,'YAVSPE(NTHSPE)')
            CALL HBNAME(NCWN,'SPE',ZAVSPE,'ZAVSPE(NTHSPE)')
            CALL HBNAME(NCWN,'SPE',ERELSPE,'ERELSPE(NTHSPE)')
            CALL HBNAME(NCWN,'SPE',P0SPE,'P0SPE(NTHSPE)')
         ENDIF
      ENDIF
C
C CAL
C
      IF(HCAL) THEN
*ML:
         WRITE(CHFORM,10100)NHMCAL
10100    FORMAT('NTHCAL:I::[0,',I4,']')
*END ML.
         IF(HLONG) THEN
*ML:
            CALL HBNAME(NCWN,'CAL',NTHCAL,CHFORM)
*END ML.
*            CALL HBNAME(NCWN,'CAL',NTHCAL,'NTHCAL:I::[0,1000]')
            CALL HBNAME(NCWN,'CAL',ICAPL,'ICAPL(NTHCAL):I::[0,48]')
            CALL HBNAME(NCWN,'CAL',ICASI,'ICASI(NTHCAL):I::[0,40]')
            CALL HBNAME(NCWN,'CAL',ICAST,'ICAST(NTHCAL):I::[0,32]')
            CALL HBNAME(NCWN,'CAL',XINCAL,'XINCAL(NTHCAL)')
            CALL HBNAME(NCWN,'CAL',YINCAL,'YINCAL(NTHCAL)')
            CALL HBNAME(NCWN,'CAL',ZINCAL,'ZINCAL(NTHCAL)')
            CALL HBNAME(NCWN,'CAL',ERELCAL,'ERELCAL(NTHCAL)')
         ELSE
*ML:
            CALL HBNAME(NCWN,'CAL',NTHCAL,CHFORM)
*END ML.
*            CALL HBNAME(NCWN,'CAL',NTHCAL,'NTHCAL:I::[0,1000]')
            CALL HBNAME(NCWN,'CAL',ICAPL,'ICAPL(NTHCAL):I::[0,48]')
            CALL HBNAME(NCWN,'CAL',ICASI,'ICASI(NTHCAL):I::[0,40]')
            CALL HBNAME(NCWN,'CAL',ICAST,'ICAST(NTHCAL):I::[0,32]')
            CALL HBNAME(NCWN,'CAL',ERELCAL,'ERELCAL(NTHCAL)')
         ENDIF
      ENDIF
C
C User action
C
      CALL GPUHBK
C
      CALL HBSET('BSIZE',NBSIZE,IERR)
      IF(IERR.NE.0) PRINT*,' Error changing N-tple buffer size'
      CALL HPRNT(NCWN)
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 01/03/2000  21.22.50  by  Francesco Cafagna
*CMZ :  1.02/00 20/03/97  16.40.46  by  Francesco Cafagna
*CMZ :  1.01/00 22/05/96  18.41.43  by  Francesco Cafagna
*CMZ :  1.00/03 30/04/96  18.14.54  by  Francesco Cafagna
*CMZ :  1.00/02 05/04/96  11.31.55  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE GUKINE
************************************************************************
*                                                                      *
*             Read or Generates Kinematics for primary tracks          *
*                                                                      *
* Called by: GTRIG                                                     *
* Author: Francesco Cafagna, 30/11/95 17.50.45                         *
*                                                                      *
************************************************************************
#include "gcflag.inc"
#include "gckine.inc"
#include "gconst.inc"
#include "gpkine.inc"
#include "gpgene.inc"
#include "gpkey.inc"
#include "gpgeo.inc"
      REAL COSX,COSY,COSZ
*
*     -----------------------------------------------------------------
*
*     Generates random number between 0<X<1
*
      CALL VZERO(POS,5)
      CALL GRNDM(POS,5)
*    =========> Angles
*       POS(4) = TWOPI*POS(4)
*       POS(5) = PIBY2*POS(5)
* ---------->>>>>>> Max 90 degree in teta, 360 degree in phi; PIATTA IN COS^2
*ML:
*      PHI  = 360.*POS(4)*DEGRAD
*      THETA= ACOS(SQRT(1-POS(5)))
      PHI = ( PHMIN+POS(4)*(PHMAX-PHMIN) )*DEGRAD
      THETA = ( THMIN+POS(5)*(THMAX-THMIN) )*DEGRAD
*END ML.
      COSX = COS(PHI)*SIN(THETA)
      COSY = SIN(PHI)*SIN(THETA)
      COSZ = COS(THETA)
*    =========> Coordinates
#if defined(GPAMELA_INTER)||defined(GPAMELA_DEB)
* Case with interactive or debug version.
* You can choose a position inside PAMELA
      DO I=1,3
         VERTEX(I)=PKINE(I)
      END DO
#endif
#if !defined(GPAMELA_INTER)&&!defined(GPAMELA_DEB)
*
* Generation surface is 2 cm over the TOP TOF
* It is centered on PAMELA and 2.cm larger than TOF on each side
*
      VERTEX(1) = XDGEN*POS(1) + XGEN
      VERTEX(2) = YDGEN*POS(2) + YGEN
      VERTEX(3) = ZGEN
#endif
*    =========> Momentum (1GeV default )
#if defined(GPAMELA_INTER)||defined(GPAMELA_DEB)
      PTOT=0.
      DO I=1,3
         PXYZ(I)=PKINE(I+3)
         PTOT=PTOT+PXYZ(I)**2
      END DO
      IF(PTOT.EQ.0.) THEN
         PTOT=1.
      ELSE
         PTOT=SQRT(PTOT)
      ENDIF
#endif
#if !defined(GPAMELA_INTER)&!defined(GPAMELA_DEB)
      PTOT=PKINE(1)
      IF(PTOT.EQ.0.)PTOT=1.
      PXYZ(1) = PTOT*COSX
      PXYZ(2) = PTOT*COSY
      PXYZ(3) = - PTOT*COSZ
#endif
      P0 = PTOT
*    =========> Particle (User defined )
      IPA = IKINE
*
* Call USER routine
*
      CALL GPUKIN (1)
      X0 = VERTEX(1)
      Y0 = VERTEX(2)
      Z0 = VERTEX(3)
      CALL GSVERT (VERTEX, 0, 0, 0, 0, NVTX)
      CALL GSKINE (PXYZ,IPA, NVTX, 0, 0, NTRAK)
      CALL GPUKIN (2)
      IF(IDEBUG.EQ.1.AND.ISWIT(1).EQ.1) THEN
         CALL GPRINT('VERT',0)
         CALL GPRINT('KINE',0)
      ENDIF
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 28/01/2002  20.40.04  by  Unknown
*-- Author :    Marialuigia Ambriola   05/04/2001
      REAL FUNCTION XTRINTEG(X,Y,SS,N)
*********************************************
* Integrates the spectrum absorbed in Xe-CO2
* called by GPUSTEP
*********************************************
      INTEGER N,I
      REAL X(N),Y(N),SS(N),S
C
      S=0.
      SS(1)=0.
      XTRINTEG=0.
      DO I=2,N
         S=S+(X(I)-X(I-1))*(Y(I)+Y(I-1))/2.
         SS(I)=S
      ENDDO
      XTRINTEG=S
c      PRINT*,'XTRINTEG=',XTRINTEG
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 04/02/2002  20.35.50  by  Unknown
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 21/10/99  16.30.25  by  Francesco Cafagna
*CMZ :  1.01/00 02/05/96  09.27.53  by  Francesco Cafagna
*CMZ :  1.00/03 15/04/96  17.01.32  by  Francesco Cafagna
*CMZ :  1.00/02 04/04/96  16.51.20  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE GUSTEP
************************************************************************
*                                                                      *
*                                                                      *
*                                                                      *
*             User routine called at the end of each tracking step     *
*             MEC   is the mechanism origin of the step                *
*             INWVOL is different from 0 when the track has reached    *
*                    a volume boundary                                 *
*             ISTOP is different from 0 if the track has stopped       *
*                                                                      *
*                                                                      *
* Called by: GTRACK                                                     *
* Author: Francesco Cafagna, 30/11/95 17.40.20                         *
*                                                                      *
************************************************************************
*
#include "gpques.inc"
#include "gctmed.inc"
#include "gckine.inc"
#include "gcking.inc"
#include "gcflag.inc"
#include "gctrak.inc"
#include "gcvolu.inc"
#include "gcsets.inc"
#include "gpkey.inc"
#include "gpsed.inc"
*
      INTEGER IFL,IN,MECNAM(MAXMEC)
      LOGICAL GPLOOK,DELT,IONIZ,STOPP
*
* User action
*
      CALL GPUSTEP(1)
*
* Store the mechanisms active for the current step
*
      IF(NMEC.EQ.0)THEN
         MECNAM(1)=NAMEC(29)
      ELSE
         DO I=1,NMEC
            MEC=LMEC(I)
            IF(MEC.LE.MAXMEC) THEN
               MECNAM(I)=NAMEC(MEC)
            ELSEIF(MEC-100.LE.MAXME1.AND.MEC-100.GT.0) THEN
               MECNAM(I)=NAMEC1(MEC-100)
            ENDIF
         ENDDO
      ENDIF
*
      IN = INWVOL
*
* Look for ionization
*
      IONIZ = GPLOOK('LOSS',MECNAM,NMEC)
*
* Look for stopped particles
*
      STOPP = GPLOOK('STOP',MECNAM,NMEC)
*
* Look for Delta
*
      IF( (IPART.EQ.3.OR.IPART.EQ.2) ) THEN
         DELT = .TRUE.
      ELSE
         DELT = .FALSE.
      ENDIF
*
* Set the flag for action on detector
*
* IFL = 1 Ionization present
* IFL = 2 Particle stopped for Electrons (Delta)
* IFL = 3 Ionization present and particle stopped for Electrons (Delta)
* IFL = 4 Ionization not present in Xe by GEANT and particle charge
*         different from zero <--> ionization by GARFIELD
* IN  = 2 Forced in case the particle is stopped and is an electron
*
      IFL = -1
      IF (IONIZ) IFL = 1
      IF (STOPP.AND.DELT) THEN
         IFL = 2
         IN = 2
      ENDIF
      IF (IONIZ.AND.STOPP.AND.DELT) THEN
         IFL = 3
         IN = 2
      ENDIF
*
* Acts on a detector if there is an Ionization
*
C      IFL = -1
C      CALL GLOOK('LOSS',MECNAM,NMEC,IFL)
*
* Special patch for delta rays. Check if is an electron and have been stopped
* If is stopped then put IFL = 1 and INWVOL = 2
*
C      IF( (IPART.EQ.3.OR.IPART.EQ.2).AND.(IFL.LE.0) ) THEN
C         IFL = -1
C         CALL GLOOK('STOP',MECNAM,NMEC,IFL)
C         IF(IFL.GT.0) THEN
* This particle has been stoped. Force INWVOL to 2 to store the hit
C            IN =2
C         ENDIF
C      ENDIF
*
* Look for each detector and pass control to the related routine
*
      IF( (ISET.EQ.ISS11) .OR. (ISET.EQ.ISS12) .OR. (ISET.EQ.ISS21) .OR.
     +    (ISET.EQ.ISS22) .OR. (ISET.EQ.ISS31) .OR. (ISET.EQ.ISS32) .OR.
     +    (ISET.EQ.ISS4)
     +) THEN
         CALL GPUTOF(IN,ISET,IDET,IPART,ITRA,DESTEP,TOFG,SLENG,VECT,
     +               NUMBV,IFL)
      ENDIF
*
* generate and absorb the transition radiation in TRD
*
      CALL GPXTR
      IF(IN.EQ.2.AND.ISET.EQ.ISTRD.AND.IDET.EQ.IDTRSI) THEN
      ENDIF
      IF (ISET.EQ.ISTRD.AND.IDET.EQ.IDTRSI) THEN
#if defined(GPAMELA_GARFIELD)
C # Force IFL to one in case we are in the Xenon gas with no ionization
         IF( .NOT.IONIZ.AND.(CHARGE.NE.0) ) THEN
C # OK looks like we are in the Xenon without the ionization
            IFL = 4
         ENDIF
#endif
         CALL GPUTRD(IN,ISET,IDET,IPART,ITRA,DESTEP,SLENG,VECT,
     +               NUMBV,IFL)
      ENDIF
      IF (ISET.EQ.ISCAT) THEN
         CALL GPUCAT(IN,ISET,IDET,IPART,ITRA,DESTEP,TOFG,SLENG,VECT,
     +               NUMBV,IFL)
      ENDIF
      IF (ISET.EQ.ISCAS) THEN
         CALL GPUCAS(IN,ISET,IDET,IPART,ITRA,DESTEP,TOFG,SLENG,VECT,
     +               NUMBV,IFL)
      ENDIF
      IF (ISET.EQ.ISSPE) THEN
         CALL GPUSPE(IN,ISET,IDET,IPART,ITRA,DESTEP,SLENG,VECT,
     +               NUMBV,IFL)
      ENDIF
      IF (ISET.EQ.ISCAL) THEN
         CALL GPUCAL(IN,ISET,IDET,IPART,ITRA,DESTEP,SLENG,VECT,
     +               NUMBV,IFL)
      ENDIF
*
*             Something generated ? Store it as a new track.
*
   10 IF(NGKINE.GT.0) THEN
         DO 20 I=1,NGKINE
c Ml: 4/2/2002
c            IFLGK(I)=1
            IFLGK(I)=0
c end Ml.
            ITYPA = GKIN(5,I)
            IF(ITYPA.NE.4) CALL GSKING(I)
   20    CONTINUE
      ENDIF
*
* User action
*
      CALL GPUSTEP(2)
*
*             Debug/plot event
*
      CALL GDEBUG
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 09/04/2001  15.38.41  by  Marialuigia Ambriola
*-- Author :    Marialuigia Ambriola   05/04/2001
      REAL FUNCTION XTRINTER(S,Y,X,N)
****************************************
* makes a linear interpolation
* called by GPUSTEP
****************************************
      REAL X(N),Y(N),S,XX
      INTEGER N
      XTRINTER=0.
      XX=0.
c      PRINT*,'N,S',N,S
c      PRINT*,'Y=',Y
      DO I=2,N
         IF(S.EQ.Y(I-1)) THEN
            XX=X(I-1)
            GOTO 100
         ENDIF
         IF(S.LT.Y(I).AND.S.GT.Y(I-1)) THEN
            XX=X(I-1)+(X(I)-X(I-1))*(S-Y(I-1))/(Y(I)-Y(I-1))
	    GOTO 100
         ENDIF
      ENDDO
 100  XTRINTER=XX
c      PRINT*,'EXTRACTED ENERGY',XX
      RETURN
      END

*
* $Id$
*
* $Log$
*
#if defined(GPAMELA_GARFIELD)
*CMZ :  3.00/00 02/05/2001  07.50.14  by  Unknown
*-- Author :    Unknown   02/05/2001
      SUBROUTINE GRINIT
C #
C # Just a dummy routine to ovveride the GARFIELD one and avoid HIGZ init
C #
      RETURN
      END
#endif

*
* $Id$
*
* $Log$
*
*CMZ :  2.03/00 30/10/2000  10.52.18  by  Francesco Cafagna
*CMZ :  2.02/00 10/10/2000  15.03.40  by  Francesco Cafagna
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.00/03 17/04/96  17.35.58  by  Francesco Cafagna
*CMZ :  1.00/02 15/03/96  17.37.19  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   14/03/96
      SUBROUTINE GPSPTM
************************************************************************
*                                                                      *
* To define special tracking media parameters                          *
*                                                                      *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 14/03/96  11.11.51                        *
*                                                                      *
************************************************************************
#include "gpal.inc"
#include "gpg10.inc"
#include "gpn2g.inc"
#include "gpw.inc"
#include "gpfe.inc"
#include "gpkap.inc"
#include "gptrad.inc"
#include "gproa.inc"
#include "gpcp.inc"
#include "gpscint.inc"
#include "gpsica.inc"
#include "gpsitr.inc"
#include "gpxe.inc"
#include "gpaer.inc"
*EM:
#include "gpce.inc"
#include "gpw2.inc"
#include "gpg10c.inc"
C
#include "gpmed.inc"
C
*END EM.
      INTEGER ITM
C
C Special tracking parameters for tracking media AL
C
c      ITM = 1
      ITM = MAL
      IF(CUTGAMAL.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMAL)
      IF(CUTELEAL.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELEAL)
      IF(CUTNEUAL.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUAL)
      IF(CUTHADAL.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADAL)
      IF(CUTMUOAL.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOAL)
      IF(BCUTEAL.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTEAL)
      IF(BCUTMAL.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMAL)
      IF(DCUTMAL.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMAL)
      IF(PPCUTMAL.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMAL)
      IF(PAIRAL.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRAL)
      IF(COMPAL.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPAL)
      IF(PHOTAL.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTAL)
      IF(PFISAL.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISAL)
      IF(DRAYAL.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYAL)
      IF(ANNIAL.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNIAL)
      IF(BREMAL.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMAL)
      IF(HADRAL.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRAL)
      IF(MUNUAL.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUAL)
      IF(DCAYAL.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYAL)
      IF(LOSSAL.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSAL)
      IF(MULSAL.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSAL)
      IF(BIRK1AL.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1AL)
      IF(BIRK2AL.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2AL)
      IF(BIRK3AL.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3AL)
      IF(LABSAL.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSAL)
      IF(SYNCAL.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCAL)
      IF(STRAAL.NE.-111.) CALL GSTPAR(ITM,'STRA',STRAAL)
C
C Special tracking parameters for tracking media G10
C
c      ITM = 2
      ITM = MG10
      IF(CUTGAMG10.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMG10)
      IF(CUTELEG10.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELEG10)
      IF(CUTNEUG10.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUG10)
      IF(CUTHADG10.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADG10)
      IF(CUTMUOG10.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOG10)
      IF(BCUTEG10.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTEG10)
      IF(BCUTMG10.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMG10)
      IF(DCUTMG10.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMG10)
      IF(PPCUTMG10.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMG10)
      IF(PAIRG10.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRG10)
      IF(COMPG10.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPG10)
      IF(PHOTG10.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTG10)
      IF(PFISG10.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISG10)
      IF(DRAYG10.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYG10)
      IF(ANNIG10.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNIG10)
      IF(BREMG10.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMG10)
      IF(HADRG10.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRG10)
      IF(MUNUG10.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUG10)
      IF(DCAYG10.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYG10)
      IF(LOSSG10.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSG10)
      IF(MULSG10.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSG10)
      IF(BIRK1G10.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1G10)
      IF(BIRK2G10.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2G10)
      IF(BIRK3G10.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3G10)
      IF(LABSG10.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSG10)
      IF(SYNCG10.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCG10)
      IF(STRAG10.NE.-111.) CALL GSTPAR(ITM,'STRA',STRAG10)
C
C Special tracking parameters for tracking media N2G
C
c      ITM = 3
      ITM = MN2
      IF(CUTGAMN2G.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMN2G)
      IF(CUTELEN2G.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELEN2G)
      IF(CUTNEUN2G.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUN2G)
      IF(CUTHADN2G.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADN2G)
      IF(CUTMUON2G.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUON2G)
      IF(BCUTEN2G.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTEN2G)
      IF(BCUTMN2G.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMN2G)
      IF(DCUTMN2G.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMN2G)
      IF(PPCUTMN2G.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMN2G)
      IF(PAIRN2G.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRN2G)
      IF(COMPN2G.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPN2G)
      IF(PHOTN2G.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTN2G)
      IF(PFISN2G.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISN2G)
      IF(DRAYN2G.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYN2G)
      IF(ANNIN2G.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNIN2G)
      IF(BREMN2G.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMN2G)
      IF(HADRN2G.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRN2G)
      IF(MUNUN2G.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUN2G)
      IF(DCAYN2G.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYN2G)
      IF(LOSSN2G.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSN2G)
      IF(MULSN2G.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSN2G)
      IF(BIRK1N2G.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1N2G)
      IF(BIRK2N2G.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2N2G)
      IF(BIRK3N2G.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3N2G)
      IF(LABSN2G.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSN2G)
      IF(SYNCN2G.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCN2G)
      IF(STRAN2G.NE.-111.) CALL GSTPAR(ITM,'STRA',STRAN2G)
C
C Special tracking parameters for tracking media W
C
c      ITM = 4
      ITM = MW
      IF(CUTGAMW.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMW)
      IF(CUTELEW.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELEW)
      IF(CUTNEUW.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUW)
      IF(CUTHADW.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADW)
      IF(CUTMUOW.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOW)
      IF(BCUTEW.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTEW)
      IF(BCUTMW.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMW)
      IF(DCUTMW.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMW)
      IF(PPCUTMW.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMW)
      IF(PAIRW.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRW)
      IF(COMPW.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPW)
      IF(PHOTW.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTW)
      IF(PFISW.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISW)
      IF(DRAYW.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYW)
      IF(ANNIW.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNIW)
      IF(BREMW.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMW)
      IF(HADRW.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRW)
      IF(MUNUW.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUW)
      IF(DCAYW.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYW)
      IF(LOSSW.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSW)
      IF(MULSW.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSW)
      IF(BIRK1W.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1W)
      IF(BIRK2W.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2W)
      IF(BIRK3W.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3W)
      IF(LABSW.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSW)
      IF(SYNCW.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCW)
      IF(STRAW.NE.-111.) CALL GSTPAR(ITM,'STRA',STRAW)
C
C Special tracking parameters for tracking media FE
C
c      ITM = 5
      ITM = MMAG
      IF(CUTGAMFE.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMFE)
      IF(CUTELEFE.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELEFE)
      IF(CUTNEUFE.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUFE)
      IF(CUTHADFE.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADFE)
      IF(CUTMUOFE.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOFE)
      IF(BCUTEFE.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTEFE)
      IF(BCUTMFE.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMFE)
      IF(DCUTMFE.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMFE)
      IF(PPCUTMFE.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMFE)
      IF(PAIRFE.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRFE)
      IF(COMPFE.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPFE)
      IF(PHOTFE.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTFE)
      IF(PFISFE.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISFE)
      IF(DRAYFE.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYFE)
      IF(ANNIFE.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNIFE)
      IF(BREMFE.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMFE)
      IF(HADRFE.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRFE)
      IF(MUNUFE.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUFE)
      IF(DCAYFE.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYFE)
      IF(LOSSFE.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSFE)
      IF(MULSFE.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSFE)
      IF(BIRK1FE.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1FE)
      IF(BIRK2FE.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2FE)
      IF(BIRK3FE.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3FE)
      IF(LABSFE.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSFE)
      IF(SYNCFE.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCFE)
      IF(STRAFE.NE.-111.) CALL GSTPAR(ITM,'STRA',STRAFE)
C
C Special tracking parameters for tracking media KAP
C
c      ITM = 6
      ITM = MKAP
      IF(CUTGAMKAP.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMKAP)
      IF(CUTELEKAP.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELEKAP)
      IF(CUTNEUKAP.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUKAP)
      IF(CUTHADKAP.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADKAP)
      IF(CUTMUOKAP.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOKAP)
      IF(BCUTEKAP.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTEKAP)
      IF(BCUTMKAP.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMKAP)
      IF(DCUTMKAP.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMKAP)
      IF(PPCUTMKAP.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMKAP)
      IF(PAIRKAP.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRKAP)
      IF(COMPKAP.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPKAP)
      IF(PHOTKAP.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTKAP)
      IF(PFISKAP.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISKAP)
      IF(DRAYKAP.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYKAP)
      IF(ANNIKAP.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNIKAP)
      IF(BREMKAP.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMKAP)
      IF(HADRKAP.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRKAP)
      IF(MUNUKAP.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUKAP)
      IF(DCAYKAP.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYKAP)
      IF(LOSSKAP.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSKAP)
      IF(MULSKAP.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSKAP)
      IF(BIRK1KAP.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1KAP)
      IF(BIRK2KAP.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2KAP)
      IF(BIRK3KAP.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3KAP)
      IF(LABSKAP.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSKAP)
      IF(SYNCKAP.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCKAP)
      IF(STRAKAP.NE.-111.) CALL GSTPAR(ITM,'STRA',STRAKAP)
C
C Special tracking parameters for tracking media TRAD
C
c      ITM = 7
      ITM = MTRAD
      IF(CUTGAMTRAD.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMTRAD)
      IF(CUTELETRAD.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELETRAD)
      IF(CUTNEUTRAD.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUTRAD)
      IF(CUTHADTRAD.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADTRAD)
      IF(CUTMUOTRAD.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOTRAD)
      IF(BCUTETRAD.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTETRAD)
      IF(BCUTMTRAD.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMTRAD)
      IF(DCUTMTRAD.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMTRAD)
      IF(PPCUTMTRAD.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMTRAD)
      IF(PAIRTRAD.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRTRAD)
      IF(COMPTRAD.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPTRAD)
      IF(PHOTTRAD.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTTRAD)
      IF(PFISTRAD.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISTRAD)
      IF(DRAYTRAD.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYTRAD)
      IF(ANNITRAD.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNITRAD)
      IF(BREMTRAD.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMTRAD)
      IF(HADRTRAD.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRTRAD)
      IF(MUNUTRAD.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUTRAD)
      IF(DCAYTRAD.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYTRAD)
      IF(LOSSTRAD.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSTRAD)
      IF(MULSTRAD.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSTRAD)
      IF(BIRK1TRAD.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1TRAD)
      IF(BIRK2TRAD.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2TRAD)
      IF(BIRK3TRAD.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3TRAD)
      IF(LABSTRAD.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSTRAD)
      IF(SYNCTRAD.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCTRAD)
      IF(STRATRAD.NE.-111.) CALL GSTPAR(ITM,'STRA',STRATRAD)
C
C Special tracking parameters for tracking media ROA
C
c      ITM = 8
      ITM = MROA
      IF(CUTGAMROA.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMROA)
      IF(CUTELEROA.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELEROA)
      IF(CUTNEUROA.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUROA)
      IF(CUTHADROA.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADROA)
      IF(CUTMUOROA.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOROA)
      IF(BCUTEROA.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTEROA)
      IF(BCUTMROA.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMROA)
      IF(DCUTMROA.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMROA)
      IF(PPCUTMROA.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMROA)
      IF(PAIRROA.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRROA)
      IF(COMPROA.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPROA)
      IF(PHOTROA.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTROA)
      IF(PFISROA.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISROA)
      IF(DRAYROA.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYROA)
      IF(ANNIROA.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNIROA)
      IF(BREMROA.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMROA)
      IF(HADRROA.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRROA)
      IF(MUNUROA.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUROA)
      IF(DCAYROA.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYROA)
      IF(LOSSROA.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSROA)
      IF(MULSROA.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSROA)
      IF(BIRK1ROA.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1ROA)
      IF(BIRK2ROA.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2ROA)
      IF(BIRK3ROA.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3ROA)
      IF(LABSROA.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSROA)
      IF(SYNCROA.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCROA)
      IF(STRAROA.NE.-111.) CALL GSTPAR(ITM,'STRA',STRAROA)
C
C Special tracking parameters for tracking media CP
C
c      ITM = 9
      ITM = MCF
      IF(CUTGAMCP.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMCP)
      IF(CUTELECP.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELECP)
      IF(CUTNEUCP.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUCP)
      IF(CUTHADCP.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADCP)
      IF(CUTMUOCP.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOCP)
      IF(BCUTECP.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTECP)
      IF(BCUTMCP.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMCP)
      IF(DCUTMCP.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMCP)
      IF(PPCUTMCP.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMCP)
      IF(PAIRCP.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRCP)
      IF(COMPCP.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPCP)
      IF(PHOTCP.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTCP)
      IF(PFISCP.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISCP)
      IF(DRAYCP.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYCP)
      IF(ANNICP.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNICP)
      IF(BREMCP.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMCP)
      IF(HADRCP.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRCP)
      IF(MUNUCP.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUCP)
      IF(DCAYCP.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYCP)
      IF(LOSSCP.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSCP)
      IF(MULSCP.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSCP)
      IF(BIRK1CP.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1CP)
      IF(BIRK2CP.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2CP)
      IF(BIRK3CP.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3CP)
      IF(LABSCP.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSCP)
      IF(SYNCCP.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCCP)
      IF(STRACP.NE.-111.) CALL GSTPAR(ITM,'STRA',STRACP)
C
C Special tracking parameters for tracking media SCIN
C
c      ITM = 10
      ITM = MSCIN
      IF(CUTGAMSCIN.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMSCIN)
      IF(CUTELESCIN.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELESCIN)
      IF(CUTNEUSCIN.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUSCIN)
      IF(CUTHADSCIN.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADSCIN)
      IF(CUTMUOSCIN.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOSCIN)
      IF(BCUTESCIN.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTESCIN)
      IF(BCUTMSCIN.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMSCIN)
      IF(DCUTMSCIN.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMSCIN)
      IF(PPCUTMSCIN.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMSCIN)
      IF(PAIRSCIN.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRSCIN)
      IF(COMPSCIN.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPSCIN)
      IF(PHOTSCIN.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTSCIN)
      IF(PFISSCIN.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISSCIN)
      IF(DRAYSCIN.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYSCIN)
      IF(ANNISCIN.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNISCIN)
      IF(BREMSCIN.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMSCIN)
      IF(HADRSCIN.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRSCIN)
      IF(MUNUSCIN.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUSCIN)
      IF(DCAYSCIN.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYSCIN)
      IF(LOSSSCIN.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSSCIN)
      IF(MULSSCIN.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSSCIN)
      IF(BIRK1SCIN.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1SCIN)
      IF(BIRK2SCIN.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2SCIN)
      IF(BIRK3SCIN.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3SCIN)
      IF(LABSSCIN.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSSCIN)
      IF(SYNCSCIN.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCSCIN)
      IF(STRASCIN.NE.-111.) CALL GSTPAR(ITM,'STRA',STRASCIN)
C
C Special tracking parameters for tracking media SICA
C
c      ITM = 11
      ITM = MSIC
      IF(CUTGAMSICA.NE.-111.)
     +   CALL GSTPAR(ITM,'CUTGAM',CUTGAMSICA)
      IF(CUTELESICA.NE.-111.)
     +   CALL GSTPAR(ITM,'CUTELE',CUTELESICA)
      IF(CUTNEUSICA.NE.-111.)
     +   CALL GSTPAR(ITM,'CUTNEU',CUTNEUSICA)
      IF(CUTHADSICA.NE.-111.)
     +   CALL GSTPAR(ITM,'CUTHAD',CUTHADSICA)
      IF(CUTMUOSICA.NE.-111.)
     +   CALL GSTPAR(ITM,'CUTMUO',CUTMUOSICA)
      IF(BCUTESICA.NE.-111.)
     + CALL GSTPAR(ITM,'BCUTE',BCUTESICA)
      IF(BCUTMSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'BCUTM',BCUTMSICA)
      IF(DCUTMSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'DCUTM',DCUTMSICA)
      IF(PPCUTMSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'PPCUTM',PPCUTMSICA)
      IF(PAIRSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'PAIR',PAIRSICA)
      IF(COMPSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'COMP',COMPSICA)
      IF(PHOTSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'PHOT',PHOTSICA)
      IF(PFISSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'PFIS',PFISSICA)
      IF(DRAYSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'DRAY',DRAYSICA)
      IF(ANNISICA.NE.-111.)
     +  CALL GSTPAR(ITM,'ANNI',ANNISICA)
      IF(BREMSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'BREM',BREMSICA)
      IF(HADRSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'HADR',HADRSICA)
      IF(MUNUSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'MUNU',MUNUSICA)
      IF(DCAYSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'DCAY',DCAYSICA)
      IF(LOSSSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'LOSS',LOSSSICA)
      IF(MULSSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'MULS',MULSSICA)
      IF(BIRK1SICA.NE.-111.)
     +  CALL GSTPAR(ITM,'BIRK1',BIRK1SICA)
      IF(BIRK2SICA.NE.-111.)
     +  CALL GSTPAR(ITM,'BIRK2',BIRK2SICA)
      IF(BIRK3SICA.NE.-111.)
     +  CALL GSTPAR(ITM,'BIRK3',BIRK3SICA)
      IF(LABSSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'LABS',LABSSICA)
      IF(SYNCSICA.NE.-111.)
     +  CALL GSTPAR(ITM,'SYNC',SYNCSICA)
      IF(STRASICA.NE.-111.)
     +  CALL GSTPAR(ITM,'STRA',STRASICA)
C
C Special tracking parameters for tracking media SITR
C
c      ITM = 12
      ITM = MSIT
      IF(CUTGAMSITR.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMSITR)
      IF(CUTELESITR.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELESITR)
      IF(CUTNEUSITR.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUSITR)
      IF(CUTHADSITR.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADSITR)
      IF(CUTMUOSITR.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOSITR)
      IF(BCUTESITR.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTESITR)
      IF(BCUTMSITR.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMSITR)
      IF(DCUTMSITR.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMSITR)
      IF(PPCUTMSITR.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMSITR)
      IF(PAIRSITR.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRSITR)
      IF(COMPSITR.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPSITR)
      IF(PHOTSITR.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTSITR)
      IF(PFISSITR.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISSITR)
      IF(DRAYSITR.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYSITR)
      IF(ANNISITR.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNISITR)
      IF(BREMSITR.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMSITR)
      IF(HADRSITR.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRSITR)
      IF(MUNUSITR.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUSITR)
      IF(DCAYSITR.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYSITR)
      IF(LOSSSITR.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSSITR)
      IF(MULSSITR.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSSITR)
      IF(BIRK1SITR.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1SITR)
      IF(BIRK2SITR.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2SITR)
      IF(BIRK3SITR.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3SITR)
      IF(LABSSITR.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSSITR)
      IF(SYNCSITR.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCSITR)
      IF(STRASITR.NE.-111.) CALL GSTPAR(ITM,'STRA',STRASITR)
C
C Special tracking parameters for tracking media XE
C
C      ITM = 13
      ITM = MXE
      IF(CUTGAMXE.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMXE)
      IF(CUTELEXE.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELEXE)
      IF(CUTNEUXE.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUXE)
      IF(CUTHADXE.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADXE)
      IF(CUTMUOXE.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOXE)
      IF(BCUTEXE.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTEXE)
      IF(BCUTMXE.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMXE)
      IF(DCUTMXE.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMXE)
      IF(PPCUTMXE.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMXE)
      IF(PAIRXE.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRXE)
      IF(COMPXE.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPXE)
      IF(PHOTXE.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTXE)
      IF(PFISXE.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISXE)
      IF(DRAYXE.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYXE)
      IF(ANNIXE.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNIXE)
      IF(BREMXE.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMXE)
      IF(HADRXE.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRXE)
      IF(MUNUXE.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUXE)
      IF(DCAYXE.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYXE)
      IF(LOSSXE.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSXE)
      IF(MULSXE.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSXE)
      IF(BIRK1XE.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1XE)
      IF(BIRK2XE.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2XE)
      IF(BIRK3XE.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3XE)
      IF(LABSXE.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSXE)
      IF(SYNCXE.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCXE)
      IF(STRAXE.NE.-111.) CALL GSTPAR(ITM,'STRA',STRAXE)
C
C Special tracking parameters for tracking media AER
C
c      ITM = 14
      ITM = MAER
      IF(CUTGAMAER.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMAER)
      IF(CUTELEAER.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELEAER)
      IF(CUTNEUAER.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUAER)
      IF(CUTHADAER.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADAER)
      IF(CUTMUOAER.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOAER)
      IF(BCUTEAER.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTEAER)
      IF(BCUTMAER.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMAER)
      IF(DCUTMAER.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMAER)
      IF(PPCUTMAER.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMAER)
      IF(PAIRAER.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRAER)
      IF(COMPAER.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPAER)
      IF(PHOTAER.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTAER)
      IF(PFISAER.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISAER)
      IF(DRAYAER.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYAER)
      IF(ANNIAER.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNIAER)
      IF(BREMAER.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMAER)
      IF(HADRAER.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRAER)
      IF(MUNUAER.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUAER)
      IF(DCAYAER.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYAER)
      IF(LOSSAER.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSAER)
      IF(MULSAER.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSAER)
      IF(BIRK1AER.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1AER)
      IF(BIRK2AER.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2AER)
      IF(BIRK3AER.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3AER)
      IF(LABSAER.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSAER)
      IF(SYNCAER.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCAER)
      IF(STRAAER.NE.-111.) CALL GSTPAR(ITM,'STRA',STRAAER)
C
C Special tracking parameters for tracking media W mix
C
c      ITM = 15
      ITM = MW2
      IF(CUTGAMW2.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMW2)
      IF(CUTELEW2.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELEW2)
      IF(CUTNEUW2.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUW2)
      IF(CUTHADW2.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADW2)
      IF(CUTMUOW2.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOW2)
      IF(BCUTEW2.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTEW2)
      IF(BCUTMW2.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMW2)
      IF(DCUTMW2.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMW2)
      IF(PPCUTMW2.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMW2)
      IF(PAIRW2.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRW2)
      IF(COMPW2.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPW2)
      IF(PHOTW2.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTW2)
      IF(PFISW2.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISW2)
      IF(DRAYW2.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYW2)
      IF(ANNIW2.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNIW2)
      IF(BREMW2.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMW2)
      IF(HADRW2.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRW2)
      IF(MUNUW2.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUW2)
      IF(DCAYW2.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYW2)
      IF(LOSSW2.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSW2)
      IF(MULSW2.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSW2)
      IF(BIRK1W2.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1W2)
      IF(BIRK2W2.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2W2)
      IF(BIRK3W2.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3W2)
      IF(LABSW2.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSW2)
      IF(SYNCW2.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCW2)
      IF(STRAW2.NE.-111.) CALL GSTPAR(ITM,'STRA',STRAW2)
C
C Special tracking parameters for tracking media Cera
C
c      ITM = 16
      ITM = MCER
      IF(CUTGAMCE.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMCE)
      IF(CUTELECE.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELECE)
      IF(CUTNEUCE.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUCE)
      IF(CUTHADCE.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADCE)
      IF(CUTMUOCE.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOCE)
      IF(BCUTECE.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTECE)
      IF(BCUTMCE.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMCE)
      IF(DCUTMCE.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMCE)
      IF(PPCUTMCE.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMCE)
      IF(PAIRCE.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRCE)
      IF(COMPCE.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPCE)
      IF(PHOTCE.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTCE)
      IF(PFISCE.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISCE)
      IF(DRAYCE.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYCE)
      IF(ANNICE.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNICE)
      IF(BREMCE.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMCE)
      IF(HADRCE.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRCE)
      IF(MUNUCE.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUCE)
      IF(DCAYCE.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYCE)
      IF(LOSSCE.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSCE)
      IF(MULSCE.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSCE)
      IF(BIRK1CE.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1CE)
      IF(BIRK2CE.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2CE)
      IF(BIRK3CE.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3CE)
      IF(LABSCE.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSCE)
      IF(SYNCCE.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCCE)
      IF(STRACE.NE.-111.) CALL GSTPAR(ITM,'STRA',STRACE)
C
C Special tracking parameters for tracking media G10C
C
      ITM = MG10C
c      ITM = 17
      IF(CUTGAMG10C.NE.-111.) CALL GSTPAR(ITM,'CUTGAM',CUTGAMG10C)
      IF(CUTELEG10C.NE.-111.) CALL GSTPAR(ITM,'CUTELE',CUTELEG10C)
      IF(CUTNEUG10C.NE.-111.) CALL GSTPAR(ITM,'CUTNEU',CUTNEUG10C)
      IF(CUTHADG10C.NE.-111.) CALL GSTPAR(ITM,'CUTHAD',CUTHADG10C)
      IF(CUTMUOG10C.NE.-111.) CALL GSTPAR(ITM,'CUTMUO',CUTMUOG10C)
      IF(BCUTEG10C.NE.-111.) CALL GSTPAR(ITM,'BCUTE',BCUTEG10C)
      IF(BCUTMG10C.NE.-111.) CALL GSTPAR(ITM,'BCUTM',BCUTMG10C)
      IF(DCUTMG10C.NE.-111.) CALL GSTPAR(ITM,'DCUTM',DCUTMG10C)
      IF(PPCUTMG10C.NE.-111.) CALL GSTPAR(ITM,'PPCUTM',PPCUTMG10C)
      IF(PAIRG10C.NE.-111.) CALL GSTPAR(ITM,'PAIR',PAIRG10C)
      IF(COMPG10C.NE.-111.) CALL GSTPAR(ITM,'COMP',COMPG10C)
      IF(PHOTG10C.NE.-111.) CALL GSTPAR(ITM,'PHOT',PHOTG10C)
      IF(PFISG10C.NE.-111.) CALL GSTPAR(ITM,'PFIS',PFISG10C)
      IF(DRAYG10C.NE.-111.) CALL GSTPAR(ITM,'DRAY',DRAYG10C)
      IF(ANNIG10C.NE.-111.) CALL GSTPAR(ITM,'ANNI',ANNIG10C)
      IF(BREMG10C.NE.-111.) CALL GSTPAR(ITM,'BREM',BREMG10C)
      IF(HADRG10C.NE.-111.) CALL GSTPAR(ITM,'HADR',HADRG10C)
      IF(MUNUG10C.NE.-111.) CALL GSTPAR(ITM,'MUNU',MUNUG10C)
      IF(DCAYG10C.NE.-111.) CALL GSTPAR(ITM,'DCAY',DCAYG10C)
      IF(LOSSG10C.NE.-111.) CALL GSTPAR(ITM,'LOSS',LOSSG10C)
      IF(MULSG10C.NE.-111.) CALL GSTPAR(ITM,'MULS',MULSG10C)
      IF(BIRK1G10C.NE.-111.) CALL GSTPAR(ITM,'BIRK1',BIRK1G10C)
      IF(BIRK2G10C.NE.-111.) CALL GSTPAR(ITM,'BIRK2',BIRK2G10C)
      IF(BIRK3G10C.NE.-111.) CALL GSTPAR(ITM,'BIRK3',BIRK3G10C)
      IF(LABSG10C.NE.-111.) CALL GSTPAR(ITM,'LABS',LABSG10C)
      IF(SYNCG10C.NE.-111.) CALL GSTPAR(ITM,'SYNC',SYNCG10C)
      IF(STRAG10C.NE.-111.) CALL GSTPAR(ITM,'STRA',STRAG10C)
c
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 30/03/2001  14.16.15  by  Marialuigia Ambriola
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.00/02 12/03/96  16.29.41  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE UGLAST
************************************************************************
*                                                                      *
*            Termination routine to print histograms and statistics    *
*                                                                      *
* Called by: MAIN                                                      *
* Author: Francesco Cafagna, 30/11/95 16.32.17                         *
*                                                                      *
************************************************************************
#include "gpkey.inc"
#include "gpunit.inc"
C
C User action
C
      CALL GPULAS
C
      CALL GLAST
C
C             Save histograms
C
      IF (HBK) THEN
         CALL HROUT(0,ICYCLE,' ')
         CALL HREND('GPAMELA')
         CALL HPRINT(0)
      ENDIF
      CLOSE (LUHBK)
*.
#if defined(GPAMELA_HIGZ)
*
*             Close GKS display file
*
      CALL IGEND
#endif
C
C Close magnetic field map
C
      CLOSE (LUFMAP)
*
*ML:
C
C Close the file which contains the attuenuation lengths for TRD
C
      CLOSE (LUTR)
*END ML.
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.06  by  Francesco Cafagna
*CMZ :  1.01/00 16/05/96  17.19.05  by  Francesco Cafagna
*CMZ :  1.00/02 04/04/96  17.54.02  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   04/04/96
      SUBROUTINE GPSITR
************************************************************************
*                                                                      *
* To define special tracking parameters for tracker silicon            *
*                                                                      *
* Called by: GPDAT                                                     *
* Author: Francesco Cafagna, 04/04/96 17.41.17                         *
*                                                                      *
************************************************************************
#include "gpsitr.inc"
* Spectromiter silicon parameters from Paolo papini
      LOSSSITR=1.
      DRAYTSITR=1.
      DCUTESITR=0.00001
      DCUTMSITR=0.00001
      CUTELESITR=0.00001
      CUTMUOSITR=0.00001
      STRASITR=0.
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.00/03 15/04/96  17.01.33  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   15/04/96
      SUBROUTINE GPUKIN(IFLAG)
************************************************************************
*                                                                      *
* User routine called in GUKINE to pass the control to GPAMELA user    *
* before and after VERTEX and KINE definitions                         *
*                                                                      *
* Variables definition:                                                *
* IN:                                                                  *
*  IFLAG = 1, before GSVERT and GSKINE calls in GUKINE                 *
*  IFLAG = 2, after  GSVERT and GSKINE calls in GUKINE                 *
*                                                                      *
* Called by: GUKINE                                                    *
* Author: Francesco Cafagna, 15/04/96 15.26.03                         *
*                                                                      *
************************************************************************
      INTEGER IFLAG
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 22/10/99  12.58.32  by  Francesco Cafagna
*CMZ :  1.01/00 09/05/96  16.58.59  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   03/05/96
      SUBROUTINE GPADIGI
************************************************************************
*                                                                      *
* DIGI definition                                                      *
*                                                                      *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 03/05/96 17.52.43                         *
*                                                                      *
************************************************************************
#include "gpdigi.inc"
#include "gpsed.inc"
#include "gpkey.inc"
*
* Tof
*
C      IF(TOF) THEN
C      ENDIF
*
* TRD
*
C      IF(TRD) THEN
C      ENDIF
*
* CAT
*
C      IF(CAT) THEN
C      ENDIF
*
* CAS
*
C      IF(CAS) THEN
C      ENDIF
*
* SPE, store DIGI structure and initialize user parameters
*
      IF(SPE) THEN
c         CALL GSDETD ('SPE ',CNSED(ISSPE,IDTSPA),NDSPE,CDSPE,NBDSPE)
c         CALL GPSDINI
      ENDIF
*
* CAL
*
C      IF(CAL) THEN
C      ENDIF
*
* User action
*
      CALL GPUDIG
*
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 14/11/2000  10.17.50  by  Emiliano Mocchiutti
*CMZ :  2.02/00 12/10/2000  18.19.42  by  Francesco Cafagna
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.06  by  Francesco Cafagna
*CMZ :  1.02/00 21/10/99  14.46.25  by  Francesco Cafagna
*CMZ :  1.00/02 13/03/96  18.39.55  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   09/12/95
      SUBROUTINE GPCALV
************************************************************************
*                                                                      *
* Volumes definition for the silicon calorimeter                       *
* Called by: GPGEM                                                     *
* Author: Francesco Cafagna, 05/12/95 13.39.41                         *
*                                                                      *
************************************************************************
#include "gpgeo.inc"
#include "gpmed.inc"
#include "gpkey.inc"
*
      INTEGER IROT,IVOLU,N,NMED
      REAL X,Y,Z
*
*  Define the CALB     volume
*
      NMED= MN2
      CALL GSVOLU('CALB','BOX ',NMED,CALB, 3,IVOLU)
*
*  Define the CALS     volume
*
      NMED= MAL
      CALL GSVOLU('CALS','BOX ',NMED,CALS, 3,IVOLU)
*
*  Define the CAPL     volume
*
      NMED= MN2
      CALL GSVOLU('CAPL','BOX ',NMED,CAPL, 3,IVOLU)
*
*  Define the CAPD     volume
*
      NMED= MN2
      CALL GSVOLU('CAPD','BOX ',NMED,CAPD, 3,IVOLU)
*
*  Define the CASI     volume
*
      NMED= MSIC
      CALL GSVOLU('CASI','BOX ',NMED,CASI, 3,IVOLU)
*
*  Division in CASI
*
      CALL GSDVN ('CAST','CASI',NCASTR,1)
*
*  Define the CG10     volume
*
      NMED= MG10C
      CALL GSVOLU('C10C','BOX ',NMED,C10C, 3,IVOLU)
*
*  Define the CAAB     volume
*
      NMED= MW2
      CALL GSVOLU('CAAB','BOX ',NMED,CAAB, 3,IVOLU)
*EM:
*
*  Define the CAAD     volume
*
      NMED= MAL
      CALL GSVOLU('CAAD','BOX ',NMED,CAAD, 3,IVOLU)
*
*  Define the CAKA     volume
*
      NMED= MCER
      CALL GSVOLU('CAKA','BOX ',NMED,CAKA, 3,IVOLU)
*
*  Define the CAKP     volume
*
      NMED= MKAP
      CALL GSVOLU('CAKP','BOX ',NMED,CAKP, 3,IVOLU)
*
*  Define the CAGL     volume (Silicon glue)
*
      NMED= MSIC
      CALL GSVOLU('CAGL','BOX ',NMED,CAGL, 3,IVOLU)
*END EM.
*
* Positioning volumes CAKA, C10C, CAGL, CAKP into the mother CAPL and CAPD
* (Kaolite and G10 only for CAPD)
*
      N = 1
      X = 0.
      Y = 0.
*EM:
      Z = -CAPL(3) + CAKA(3)
      CALL GSPOS('CAKA',N,'CAPL',X,Y,Z,0,'ONLY')
      CALL GSPOS('CAKA',N,'CAPD',X,Y,Z,0,'ONLY')
      Z = Z + CAKA(3) + C10C(3)
      CALL GSPOS('C10C',N,'CAPL',X,Y,Z,0,'ONLY')
      CALL GSPOS('C10C',N,'CAPD',X,Y,Z,0,'ONLY')
      Z = Z + C10C(3) + CAGL(3)
      CALL GSPOS('CAGL',N,'CAPL',X,Y,Z,0,'ONLY')
      Z = Z + CAGL(3) + CAKP(3)
      CALL GSPOS('CAKP',N,'CAPL',X,Y,Z,0,'ONLY')
*
* Positioning volume CASI into the mother CAPL
*
      N = 0
      Z = Z + CAKP(3) + CASI(3)
      DO I=-1,1
         Y = I*(2.*CASI(2)+ DCASIY)
         DO II=-1,1
            N= N + 1
            X = II*(2.*CASI(1)+ DCASIX)
*
* Check if detector is excluded
*
            IF(.NOT.NOCASI(N))
     +           CALL GSPOS('CASI',N,'CAPL',X,Y,Z,0,'ONLY')
         ENDDO
      ENDDO
*END EM.
*
* Positioning volume CAPL and CAAB into the mother CALB
*
      X= 0.
      Y= 0.
C      Z= CALB(3) + CAPL(3)
*EM:
      Z= CALB(3) + CAPL(3) - DCASIZ/2.
*END EM. (we have 0.15 cm from the top to the first Si)
      N= 0
      DO I=1,NCAPL
*
* X view, absorber and Y view on the other
*
         Z= Z - 2*CAPL(3)
         N= N + 1
*
* Check if this plane is excluded
*
         IF(.NOT.NOCAPL(N))
     +        CALL GSPOS('CAPL',N,'CALB',X,Y,Z,0,'ONLY')
         Z= Z - CAPL(3) - CAAB(3)
*
* Check if this absorber is excluded
*
         IF(.NOT.NOCAAB(I))
     +        CALL GSPOS('CAAB',(I-1),'CALB',X,Y,Z,0,'ONLY')
         Z= Z - CAAB(3) - CAPL(3)
         N= N + 1
*
* Check if this detector is excluded
*
         IF(.NOT.NOCAPL(N))
     +        CALL GSPOS('CAPL',N,'CALB',X,Y,Z,3,'ONLY')
      ENDDO
*
* Positioning volume CAPD and CAAD into the mother CALB
*
      N= 0
      DO I=1,NCAPLD
         IF(I.EQ.1) THEN
            Z= Z - CAPD(3) - CAPL(3)
         ELSE
            Z= Z - 2*CAPD(3)
         ENDIF
         N= N + 1
         CALL GSPOS('CAPD',N,'CALB',X,Y,Z,0,'ONLY')
         Z= Z - CAPD(3) - CAAD(3)
         CALL GSPOS('CAAD',(I-1),'CALB',X,Y,Z,0,'ONLY')
         Z= Z - CAAD(3) - CAPD(3)
         N= N + 1
         CALL GSPOS('CAPD',N,'CALB',X,Y,Z,3,'ONLY')
      ENDDO
*
* Put the shell around it
*
      X= 0.
      Y= 0.
      Z= CALS(3)-CALB(3)
      N= 1
      CALL GSPOS('CALB',N,'CALS',X,Y,Z,0,'ONLY')
*
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 13/11/2000  09.08.20  by  Emiliano Mocchiutti
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.06  by  Francesco Cafagna
*CMZ :  1.02/00 07/03/97  21.47.47  by  Francesco Cafagna
*CMZ :  1.00/02 08/02/96  17.18.05  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   08/02/96
      SUBROUTINE GPCASV
************************************************************************
*                                                                      *
* Volumes definition for the side anticoincidence counters             *
* Called by: GPGEO                                                     *
*                                                                      *
* Author: Francesco Cafagna, 08/02/96 16.58.49                         *
*                                                                      *
************************************************************************
#include "gpgeo.inc"
#include "gpmed.inc"
*
      INTEGER IROT,IVOLU,N,NMED,NUM
      REAL X,Y,Z
*
      NMED=MAL
*
*  Define the CAS cradle volume
*
      CALL GSVOLU('CSSX','BOX ',NMED,CSSX, 3,IVOLU)
      CALL GSVOLU('CSSY','BOX ',NMED,CSSY, 3,IVOLU)
*EM:
* Define the CAS scintillator volume
*
      NMED=MSCIN
      CALL GSVOLU('CASX','BOX ',NMED,CASX,3,IVOLU)
      CALL GSVOLU('CASY','BOX ',NMED,CASY,3,IVOLU)
*
* Positioning Scintillators in cradles
*
      N = 1
      X = 0.
      Y = 0.
      Z = 0.
      CALL GSPOS('CASX',N,'CSSX',X,Y,Z,0,'ONLY')
      CALL GSPOS('CASY',N,'CSSY',X,Y,Z,0,'ONLY')
*END: EM.
*
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.17  by  Marialuigia Ambriola
*CMZ :  2.00/00 28/02/2000  13.36.53  by  Francesco Cafagna
*CMZ :  1.01/00 13/05/96  14.41.05  by  Francesco Cafagna
*CMZ :  1.00/02 19/03/96  17.11.16  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   23/02/96
      SUBROUTINE GPRHIT(CS,CD,IS,ID,NVOL,NH,NHM,NHS,IT,NDV,
     +                  ITA,NUM,VHIT,NHITS)
************************************************************************
*                                                                      *
* Generic routine to retrive hit structure                             *
* Variables definition:                                                *
* IN:                                                                  *
*                                                                      *
*  CD   , detector name;                                               *
*  IS   , set number;                                                  *
*  ID   , detector number;                                             *
*  NVOL , number of volumes;                                           *
*  NH   , number of hit;                                               *
*  NHM  , maximum number of hits to be retrived                        *
*  NHS  , hit number to start with to be retrived                      *
*  IT   , track number to be retrived. IT=-1, means all the tracks     *
*  NDV  , copy number identify the detector                            *
*                                                                      *
* OUT:                                                                 *
*                                                                      *
*  ITA  , 1D array of track number wich has produced the hit           *
*  NUM  , 2D array of copy number to identify the detector             *
*  VHIT , 2D array of hits                                             *
*  NHITS, number of hits retrived. Negative value if is greater than   *
*         NHITMAX                                                      *
*                                                                      *
* Called by: <USER>                                                    *
* Author: Francesco Cafagna, 23/02/96 14.14.38                         *
*                                                                      *
************************************************************************
#include "gcunit.inc"
#include "gcflag.inc"
*
      CHARACTER*4 CS,CD
      INTEGER IS,ID,NVOL,NH,NHM,NHS,IT,NDV,ITA,NUM,NHITS
      REAL VHIT
      DIMENSION ITA(NHM),NDV(NVOL),NUM(NVOL,NHM),VHIT(NH,NHM)
*
      IF (IT.EQ.-1) IT=0
      CALL VZERO(VHIT,NH*NHM)
      CALL VZERO(ITA ,NHM)
      CALL VZERO(NUM ,NVOL*NHM)
      NHITS = 0
      CALL GFHITS(CS,CD,NVOL,NH,NHM,IT,NDV,ITA,NUM,VHIT,NHITS)
*      CALL GPRSHT(CS,CD,NVOL,NH,NHM,NHS,IT,NDV,ITA,NUM,VHIT,NHITS)
*
* Check on the number of hits
*
      IF(NHITS.GT.NHM) THEN
         WRITE(CHMAIL,10000) CS,CD,NHITS,NHM,IDRUN,IDEVT
         CALL GMAIL(1,0)
         NHITS = - NHITS
      ENDIF
10000 FORMAT(' GPRHIT: More than NHMAX hits: SET=',A4,', DET=',A4,
     +       ',NHITS=',I5,', NHMAX=',I5,', RUN=',I5,', EVT=',I8)
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.00/02 05/04/96  09.33.54  by  Francesco Cafagna
*CMZ :  3.21/03 07/10/94  18.38.33  by  S.Giani
*-- Author :
      SUBROUTINE GUPHAD
C.
C.    ******************************************************************
C.    *                                                                *
C.    *       User routine to compute Hadron. inter. probabilities     *
C.    *                                                                *
C.    *    ==>Called by : GTHADR,GTNEUT                                *
C.    *                                                                *
C.    ******************************************************************
C.
*======================================================================*
*                                                                      *
*   An interface with a part of the FLUKA shower code is available in  *
*   GEANT 3.21. The following conditions and warnings must be taken    *
*   into account when using the FLUKA routines.                        *
*                                                                      *
*======================================================================*
*======================================================================*
*                                                                      *
*                   FFFF   L      U  U  K  K   AA                      *
*                   F      L      U  U  K K   A  A                     *
*                   FFF    L      U  U  KK    AAAA                     *
*                   F      L      U  U  K K   A  A                     *
*                   F      LLLL    UU   K  K  A  A                     *
*                                                                      *
*                   (C) Copyright of the authors                       *
*                                                                      *
*             A. Fasso'*, A. Ferrari#, J. Ranft$, P.R. Sala#           *
*                                                                      *
*               *: CERN, #: INFN -Milan, $: CERN/Frascati              *
*                                                                      *
*                (e-mail: FERRARIA@CERNVM.CERN.CH)                     *
*                                                                      *
*======================================================================*
*                                                                      *
*   - All the rights concerning FLUKA or parts of it are only of the   *
*     authors and are independent from those of the GEANT code         *
*                                                                      *
*   - FLUKA [1-6] is a standalone code capable of simulating the inter-*
*     action and transport of all components of EM and hadronic cas-   *
*     cades up to several TeV. However, only cross sections and        *
*     models for hadronic elastic and inelastic interactions (end 1992 *
*     status) are included in this GEANT version.                      *
*                                                                      *
*   - The most recent FLUKA model [4,6] for nucleon and pion interac-  *
*     tions in the intermediate energy range is not fully implemented  *
*     in GEANT. Only a simplified version, limited to p and n below    *
*     250 MeV, is available in GEANT 3.21. A coarser model is used for *
*     other projectiles in this energy range. However the implemented  *
*     parts should be adequate for most detector simulations and sim-  *
*     ilar applications for which GEANT is generally used. Their accu- *
*     racy could be insufficient for some nuclear physics studies or   *
*     demanding simulations at low energies, where the more sophistic- *
*     ated models [4,6] could be required.                             *
*                                                                      *
*   - The performances of GEANT-FLUKA are therefore not representative *
*     of those of FLUKA standalone and should be referenced as such    *
*     rather than simply GEANT or FLUKA.                               *
*                                                                      *
*   - The authors reserve the right of publishing about the physical   *
*     models developed for FLUKA. Running the FLUKA routines in isol-  *
*     ation for benchmarks (or equivalent use) is not permitted,       *
*     except after consultations or in collaboration with the authors. *
*                                                                      *
*   - The FLUKA routines are supposed to be included and used in       *
*     GEANT only. Any other use must be authorized by the authors.     *
*                                                                      *
*   - References: at least reference [5] should be always quoted when  *
*                 reporting results obtained with GEANT-FLUKA          *
*                                                                      *
* [1] A. Fasso', A. Ferrari, J. Ranft, P. R. Sala, G. R. Stevenson and *
*     J. M. Zazula, "FLUKA92", presented at the workshop on "Simulat-  *
*     ing Accelerator Radiation Environment", SARE, Santa Fe, 11-15    *
*     january (1993), Proceedings in press.                            *
*                                                                      *
* [2] P.A. Aarnio, A. Fasso', A. Ferrari, J.-H. Moehring, J. Ranft,    *
*     P.R. Sala, G.R. Stevenson and J.M. Zazula, Proc. MC93 Int. Conf. *
*     on Monte-Carlo Simulation in High-Energy and Nuclear Physics,    *
*     Tallahassee, Florida, 22-26 february (1993), World Scientific,   *
*     p. 88 (1994).                                                    *
*                                                                      *
* [3] P.A. Aarnio, A. Fasso', A. Ferrari, J.-H. Moehring, J. Ranft,    *
*     P.R. Sala, G.R. Stevenson and J.M. Zazula, ibidem, p. 100 (1994) *
*                                                                      *
* [4] A. Ferrari and P.R. Sala, ibidem, p. 277 (1994).                 *
*                                                                      *
* [5] A. Fasso', A. Ferrari, J. Ranft and P.R. Sala, "FLUKA: present   *
*     status and future developments", presented at the IV Int. Conf.  *
*     on Calorimetry in High Energy Physics, La Biodola (Elba),        *
*     September 19-25 1993, Proceedings in press.                      *
*                                                                      *
* [6] A. Fasso', A. Ferrari, J. Ranft, and P.R. Sala, "FLUKA: Perf-    *
*     ormances and Applications in the Intermediate Energy Range",     *
*     presented at the "Specialists' Meeting on Shielding Aspects of   *
*     Accelerators, Targets & Irradiation Facilities", Arlington,      *
*     April 28-29 1994, Proceedings in press.                          *
*                                                                      *
*======================================================================*
#include "gpkey.inc"
C.
C.    ------------------------------------------------------------------
C.
C             FLDIST for FLUKA
C
      IF(FLUKA) THEN
         CALL FLDIST
      ELSE
C.
C.    ------------------------------------------------------------------
C.
C             GPGHEI for GHEISHA
C
         CALL GPGHEI
      ENDIF
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 13/11/2000  09.03.11  by  Emiliano Mocchiutti
*CMZ :  2.01/00 05/04/2000  14.35.17  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 08/11/99  18.44.50  by  Francesco Cafagna
*CMZ :  1.01/00 13/05/96  09.16.26  by  Francesco Cafagna
*CMZ :  1.00/02 04/04/96  12.00.53  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   05/12/95
      SUBROUTINE GPGEO
************************************************************************
*                                                                      *
* Volumes definition for PAMELA                                        *
*                                                                      *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 05/12/95 13.21.27                         *
*                                                                      *
************************************************************************
#include "gpgeo.inc"
#include "gpmed.inc"
#include "gpkey.inc"
*
      INTEGER IROT,IVOLU,N,NMED,NUM
      REAL X,Y,Z
*
*  Define 90 degree rotation around Z axis
*
      IROT=1
      CALL GSROTM(IROT,90.,90.,90.,180.,0.,0.)
*
*  Define 90 degree rotation around X axis
*
      IROT=2
      CALL GSROTM(IROT,90.,0.,180.,90.,90.,90.)
*
*  Define 90 degree rotation around Z axis and 180 along X
*
      IROT=3
      CALL GSROTM(IROT,90.,90.,90.,360.,180.,0.)
*
*  Define 180 degree rotation around Z axis
*
      IROT=4
      CALL GSROTM(IROT,90.,180.,90.,270.,0.,0.)
*
*  Define the PAMELA   volume
*
      NMED=MN2
      CALL GSVOLU('PAME','TUBE',NMED,PAME, 3,IVOLU)
*
*  Define the Aluminium shell volumes
*
      NMED=MAL
      CALL GSVOLU('SHEL','TUBE',NMED,SHEL, 3,IVOLU)
*
*  Define the Aluminium inner shell volumes
*
      IF(SPH) THEN
         NMED=MAL
         CALL GSVOLU('TSPH','SPHE',NMED,TSPH, 6,IVOLU)
      ELSE
         NMED=MAL
         CALL GSVOLU('TFLA','TUBE',NMED,TFLA, 3,IVOLU)
      ENDIF
*
* Volume definition for scintillators, TOF and anticoincidence counter
*
      IF(TOF) CALL GPTOFV
      IF(CAT) CALL GPCATV
      IF(CAS) CALL GPCASV
*
* Volume definition for TRD
*
      IF(TRD) CALL GPTRDV
*
* Volume definition for Spectrometer
*
      IF(SPE) CALL GPSPEV
*
* Volume definition for Calorimeter
*
      IF(CAL) CALL GPCALV
*
*  Volume positioning starting from the TOP
*
      X= 0.
      Y= 0.
*
* Positioning volume SHEL     into the mother PAME
*
      N= 1
      Z= ZSHEL
      CALL GSPOS('SHEL',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume SHEI     into the mother PAME
*
C         N= 1
C         Z= ZSHEI
c         CALL GSPOS('SHEI',N,'PAME',X,Y,Z,0,'ONLY')
      IF(SPH) THEN
*
* Positioning volume TSPH     into the mother PAME
*
         N= 1
         Z= ZTSPH
         CALL GSPOS('TSPH',N,'PAME',X,Y,Z,0,'ONLY')
      ELSE
*
* Positioning volume TFLA     into the mother PAME
*
         N= 1
         Z= ZTFLA
         CALL GSPOS('TFLA',N,'PAME',X,Y,Z,0,'ONLY')
      ENDIF
*
* Positioning volume S11     into the mother PAME
*
      N= 1
      Z= ZS11
      IF(TOF) CALL GSPOS('S11 ',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume S12     into the mother PAME
*
      N= 1
      Z= ZS12
      IF(TOF) CALL GSPOS('S12 ',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume TRDB     into the mother PAME
*
      N= 1
      Z= ZTRD
      IF(TRD) THEN
         CALL GSPOS('TRDB',N,'PAME',X,Y,Z,0,'ONLY')
C FC commented out on 21-10-1999 by caf
c         CALL GSPOS('TRDS',N,'PAME',X,Y,Z,0,'ONLY')
c         Z= ZTRD - TRDS(3) - TRDT(3)
c         CALL GSPOS('TRDT',N,'PAME',X,Y,Z,0,'ONLY')
c         N= 2
c         Z= ZTRD + TRDS(3) + TRDT(3)
c         CALL GSPOS('TRDT',N,'PAME',X,Y,Z,0,'ONLY')
C FC end of comment on 21-10-1999
      ENDIF
*
* Positioning volume S21     into the mother PAME
*
      N= 1
      Z= ZS21
      IF(TOF) CALL GSPOS('S21 ',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume S22     into the mother PAME
*
      N= 1
      Z= ZS22
      IF(TOF) CALL GSPOS('S22 ',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume CATB     into the mother PAME
*
      N= 1
      Z= ZCAT
      IF(CAT) CALL GSPOS('CATB',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume CAS      into the mother PAME
*
*EM:
      Z= ZCAS
      IF(CAS) THEN
C         X = 0
         N = 0
         DO I = 1,2
            X = ((-1)**(I+1))*CASXD
C            Y = ((-1)**I)*( CASY(2) + CASX(2) )
            Y = ((-1)**I)*CASY(2)
c fc mod by caf on 21-10-1999
c            DO II=1, 5
c               Z = ZCAS - 4.*CASX(3) + (II-1) * 2*CASX(3)
c               N = N + 1
c               CALL GSPOS('CASX',N,'PAME',X,Y,Z,0,'ONLY')
c            ENDDO
c fc end mod
            Z = ZCAS
            N = N + 1
*
            CALL GSPOS('CSSX',N,'PAME',X,Y,Z,0,'ONLY')
         ENDDO
*
C         Y = 0
         N = 0
         DO I = 1,2
            X = ((-1)**I)*(CASX(1)+0.1)
C            X = ((-1)**I)*(CASX(1)+CASY(1))
            Y = ((-1)**I)*CASYD
c fc mod by caf on 21-10-1999
c            DO II=1, 5
c               Z = ZCAS - 4.*CASY(3) + (II-1) * 2*CASY(3)
c               N = N + 1
c               CALL GSPOS('CASY',N,'PAME',X,Y,Z,0,'ONLY')
c            ENDDO
c fc end mod
            Z = ZCAS
            N = N + 1
            CALL GSPOS('CSSY',N,'PAME',X,Y,Z,0,'ONLY')
         ENDDO
      ENDIF
*END: EM.
*
* Positioning volume SPEB     into the mother PAME
*
      N= 1
      X= 0.
      Y= 0.
      Z= ZSPEC
      IF(SPE) CALL GSPOS('SPEB',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume S31     into the mother PAME
*
      N= 1
      X= 0.
      Y= 0.
      Z= ZS31
      IF(TOF) CALL GSPOS('S31 ',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume S32     into the mother PAME
*
      N= 1
      X= 0.
      Y= 0.
      Z= ZS32
      IF(TOF) CALL GSPOS('S32 ',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume CALB     into the mother PAME
*
      N= 1
      X= 0.
      Y= 0.
      Z= ZCAL
      IF(CAL) CALL GSPOS('CALS',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume S4     into the mother PAME
*
      N= 1
      Z= ZS4
      IF(TOF) CALL GSPOS('S4  ',N,'PAME',X,Y,Z,0,'ONLY')
*
* User action
*
      CALL GPUGEO
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 01/05/2001  18.30.37  by  Marialuigia Ambriola
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 10/03/97  17.55.00  by  Francesco Cafagna
*CMZ :  1.01/00 13/05/96  09.16.26  by  Francesco Cafagna
*CMZ :  1.00/02 14/03/96  12.01.32  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE UGINIT
************************************************************************
*                                                                      *
* GEANT user initialization routine                                    *
*                                                                      *
* Author: Francesco Cafagna, 30/11/95 01.59.13                         *
*                                                                      *
************************************************************************
#include "gclist.inc"
#include "gcunit.inc"
#include "gpunit.inc"
#include "gpkey.inc"
*
      CHARACTER*8 VERSQQ
      INTEGER IDATQQ,ITIMQQ,IVERSQ
*
#include "gpdunit.inc"
*
* Put version and date creation
*
C #       IDATQQ = CPP_DATE
C #       ITIMQQ = CPP_TIME
C #       VERSQQ = CPP_VERS
*
*     -----------------------------------------------------------------
*
*             Initialize GEANT
*
      CALL GINIT
*
*             Prints version number
*
C #       WRITE(LOUT,10000)
*
*             Define additional data cards
*
      CALL GPFFR
*
*             Read data cards with FFREAD
*
*
      OPEN(UNIT=LUFFR,FILE=CHFFR,STATUS='UNKNOWN',FORM='FORMATTED')
      CALL GFFGO
      CLOSE(LUFFR)
*
*             Open user files
*
      CALL GPFIL
*
*             Initialize GEANT/ZEBRA data structures
*
      CALL GZINIT
*.
#if defined(GPAMELA_HIGZ)
*
*             Initialize graphics package
*
      CALL GDINIT
#endif
*
*             Set default values for PAMELA
*
      CALL GPDAT
*
*             GEANT standard material data
*             User's geometry and materials description.
*             Special tracking media material
*             Sets, detectors, hits and digi definition
*
      CALL GMATE
      CALL GPMAT
      CALL GPMED
      CALL GPSPTM
      CALL GPGEO
      CALL GPSED
      CALL GPHIT
      CALL GPADIGI
*
* Close the geometry definition
*
      CALL GGCLOS
*
*             Particle table definition and energy loss initialization.
*
      CALL GPART
      CALL GPIONS
      CALL GPHYSI
*.
#if defined(GPAMELA_HIGZ)
*
*             Create a view bank
*
      CALL GVIEWYZ(1)
#endif
*
*              Geant standards hitos, if requested
*              User histos
*
      IF(NHSTA.GT.0) CALL GBHSTA
      IF(HBK) CALL GPHBK
#if defined(GPAMELA_GARFIELD)
*
* 	GARFIELD init
*
      CALL GPGARIN
#endif
*
*
*              User action
*
      CALL GPUINI
*
C # 10000 FORMAT(/,2X,'This program history:',/,
C #      + CPP_TITLE_CH
C #      + // '                              '
C #      +       )
      END
*#include "TITLE.gpamela"

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.01/00 17/05/96  23.19.39  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   06/05/96
      INTEGER FUNCTION GPNHIT(CHSET,CHDET)
************************************************************************
*                                                                      *
* Return the total number of hits stored for set and detector CHSET&CHDET *
*                                                                      *
* Variables definition:                                                *
* IN:                                                                  *
*  CHSET, set name                                                     *
*  CHDET, detector name                                                *
*                                                                      *
* Called by:<USER>                                                     *
* Author: Francesco Cafagna, 06/05/96 10.23.50                         *
*                                                                      *
************************************************************************
#include "gcbank.inc"
      CHARACTER*4 CHSET,CHDET
      INTEGER NDET,NSET,ILAST,JS,JH,JD,JHD,JDH
C
C             Find if selected set, detector exists
C
      IF(JHITS.LE.0)GO TO 10
      NSET=IQ(JSET-1)
      CALL GLOOK(CHSET,IQ(JSET+1),NSET,ISET)
      IF(ISET.LE.0)GO TO 10
C
      JS=LQ(JSET-ISET)
      JH=LQ(JHITS-ISET)
      IF(JS.LE.0)GO TO 10
      IF(JH.LE.0)GO TO 10
      NDET=IQ(JS-1)
      CALL GLOOK(CHDET,IQ(JS+1),NDET,IDET)
      IF(IDET.EQ.0)GO TO 10
C
      JD=LQ(JS-IDET)
      JHD=LQ(JH-IDET)
      IF(JHD.LE.0)GO TO 10
      JDH=LQ(JD-1)
C
      ILAST=IQ(JH+IDET)
      IF(ILAST.EQ.0) THEN
         GPNHIT = 0
         GO TO 10
      ENDIF
      NV=IQ(JD+2)
      NH=IQ(JD+4)
      NW=IQ(JD+1)+IQ(JD+3)+1
      GPNHIT=INT(ILAST/NW)
   10 RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.01/00 07/05/96  14.45.26  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   07/05/96
      SUBROUTINE GPRSHT(IUSET,IUDET,NVDIM,NHDIM,NHMAX,NSHIT,ITRS
     +, NUMVS,ITRA,NUMBV,HITS,NHITS)
************************************************************************
*                                                                      *
* To retrive hits from the HITS structure in GEANT, starting from NSHIT hit. *
* Based on GFHITS from GEANT package, basically you can point the hits *
* you would like to retrive passing the hit number, it'll return the   *
* negative hit number in case the hit number is greater than the       *
* number of stored hits                                                *
*                                                                      *
* Variables definition:                                                *
* IN:                                                                  *
* IUSET,  user set identifier                                          *
* IUDET,  user    detector   identifier                                *
* NVDIM,  1st dimension of NUMBV and NUMVS                             *
* NHDIM,  1st  dimension  of  array  HITS                              *
* NHMAX,  maximum number of hits to be returned                        *
* NSHIT,  first hit to be retrived                                     *
* ITRS,   number of the selected track. If ITRS=0, all tracks are taken *
* NUMVS,  geometric path of the detector volume to be selected.        *
*                                                                      *
* OUT:                                                                 *
* ITRA,   for each hit the track number which has produced it.         *
* NUMBV,  2-D array. For each hit the list of volume numbers which     *
*         identify each physical volume.                               *
* HITS,   2-Dim array that will contain the NHITS hits                 *
* NHITS,  returns the number of selected hit. Negative if NSHIT is not *
*         in the hits structure, NHMAX+1 if total number of hits is greater *
*         than NHITS                                                    *
*                                                                      *
* Called by: <USER>                                                    *
* Author: Francesco Cafagna, 07/05/96 09.10.43                         *
*                                                                      *
************************************************************************
* It follows GFHITS comments:                                          *
C.
C.    ******************************************************************
C.    *                                                                *
C.    *                                                                *
C.    *   Returns the  hits produced  by track ITRS  (if 0,   by all   *
C.    * tracks)  in the physical volume  specified by the list NUMVS   *
C.    * with generic volume name IUDET belonging to set IUSET.         *
C.    * IUSET     user set identifier                                  *
C.    * IUDET     user    detector   identifier    (name   of    the   *
C.    *           corresponding sensitive volume)                      *
C.    * NVDIM     1st dimension of NUMBV and NUMVS (usually =NV, the   *
C.    *           number of volume descriptors which permit to identify*
C.    *           a given detector, eventually smaller than  NV)       *
C.    * NHDIM     1st  dimension  of  array  HITS  (argument  NH  of   *
C.    *           GSDETH)                                              *
C.    * NHMAX     maximum number of hits to be returned                *
C.    * ITRS      number of  the selected  track.   If  ITRS=0,  all   *
C.    *           tracks are taken                                     *
C.    * NUMVS     is a  1-Dim array that  must contain on  input the   *
C.    *           geometric  path  of  the  detector  volume  to  be   *
C.    *           selected.    All 0  interpreted  as 'all  physical   *
C.    *           volumes with generic names IUDET'                    *
C.    * ITRA      is a 1-Dim  array that will contain  on output for   *
C.    *           each  hit  the  number  of  the  track  which  has   *
C.    *           produced it                                          *
C.    * NUMBV     2-Dim array that  will contain on output  for each   *
C.    *           hit the list of volume numbers which identify each   *
C.    *           physical volume.   Zeroed when no more volumes are   *
C.    *           stored                                               *
C.    * HITS      2-Dim array that will contain the NHITS hits         *
C.    * NHITS     returns the number of selected  hits.  In case the   *
C.    *           total number of hits is greater than NHMAX,  NHITS   *
C.    *           is set to NHMAX+1 and only NHMAX hits are returned   *
C.    *   - HITS(1,I)  is the element 1 for hit number I               *
C.    *   - NUMBV(1,I) is the volume number 1 for hit number I         *
C.    *   - ITRA(I)    is  the  track number  corresponding  to  hit   *
C.    * number I                                                       *
C.    *   In the calling routine the arrays NUMVS,  NUMBV,  HITS and   *
C.    * ITRA must be dimensioned to:                                   *
C.    *     NUMVS(NVDIM)                                               *
C.    *     NUMBV(NVDIM,NHMAX)                                         *
C.    *     HITS(NHDIM,NHMAX)                                          *
C.    *     ITRA(NHMAX)                                                *
C.    *                                                                *
C.    *    ==>Called by : <USER>, GUDIGI                               *
C.    *       Author    R.Brun  *********                              *
C.    *                                                                *
C.    ******************************************************************
C.
#include "gcbank.inc"
      PARAMETER (NVMAX=20)
      DIMENSION NUMVT(NVMAX),NUMVS(NVDIM),NUMBV(NVDIM,1),ITRA(1)
      DIMENSION HITS(NHDIM,1)
      EQUIVALENCE (WS(1),NUMVT(1))
      CHARACTER*4 IUSET,IUDET
      INTEGER IHFRS
C.
C.    ------------------------------------------------------------------
C.
C             Find if selected set, detector exists
C
      NHITS=0
      IF(JHITS.LE.0)GO TO 70
      NSET=IQ(JSET-1)
      CALL GLOOK(IUSET,IQ(JSET+1),NSET,ISET)
      IF(ISET.LE.0)GO TO 70
C
      JS=LQ(JSET-ISET)
      JH=LQ(JHITS-ISET)
      IF(JS.LE.0)GO TO 70
      IF(JH.LE.0)GO TO 70
      NDET=IQ(JS-1)
      CALL GLOOK(IUDET,IQ(JS+1),NDET,IDET)
      IF(IDET.EQ.0)GO TO 70
C
      JD=LQ(JS-IDET)
      JHD=LQ(JH-IDET)
      IF(JHD.LE.0)GO TO 70
      JDH=LQ(JD-1)
C
      ILAST=IQ(JH+IDET)
      IF(ILAST.EQ.0)GO TO 70
      NV=IQ(JD+2)
      NH=IQ(JD+4)
      NW=IQ(JD+1)+IQ(JD+3)+1
C
C
C             Loop on all hits
C
C
      IHIT=0
      IHFRS = (NSHIT-1)*NW+1
      DO 50  I=IHFRS,ILAST,NW
C
C             Find the selected track
C
         ITRT=IQ(JHD+I)
         IF(ITRS.NE.0 .AND. ITRS.NE.ITRT)GO TO 50
C
C             Find the selected volume
C             (if NO volumes exist take ALL hits)
C
         NK=1
         IF(NV.GT.0)THEN
            K=1
            DO 10 IV=1,NV
               NB=IQ(JD+2*IV+10)
               IF(NB.LE.0)THEN
                  IF(K.GT.1)THEN
                     K=1
                     NK=NK+1
                  ENDIF
                  IF(IV.LE.NVMAX)NUMVT(IV)=IQ(JHD+I+NK)
                  IF(IV.NE.NV)NK=NK+1
               ELSE
                  IF(K+NB.GT.33)THEN
                     K=1
                     NK=NK+1
                  ENDIF
                  IF(IV.LE.NVMAX)NUMVT(IV)=IBITS(IQ(JHD+I+NK),K-1,NB)
                  K=K+NB
               ENDIF
               IF(IV.LE.NVDIM)THEN
                  IF(NUMVS(IV).NE.0)THEN
                     IF(NUMVS(IV).NE.NUMVT(IV))GO TO 50
                  ENDIF
               ENDIF
   10       CONTINUE
            NK=NK+1
         ENDIF
C
C
C
C ========>   Now store track number and volume numbers and fetch hits
C
         IHIT=IHIT+1
         IF(IHIT.GT.NHMAX)GO TO 60
C
         ITRA(IHIT)=ITRT
         NVMIN=MIN(NV,NVDIM)
         DO 20 J=1,NVDIM
   20    NUMBV(J,IHIT)=0
         DO 30 J=1,NVMIN
   30    NUMBV(J,IHIT)=NUMVT(J)
C
C             Get unpacked hits
C             Hits origin is shifted . Division by scale factor
C
         IF(NH.GT.0)THEN
            K=1
            DO 40 IH=1,NH
               NB=IQ(JDH+4*IH-2)
               IF(NB.LE.0)THEN
                  IF(K.GT.1)THEN
                     K=1
                     NK=NK+1
                  ENDIF
                  KHIT=IQ(JHD+I+NK)
                  NK=NK+1
               ELSE
                  IF(K+NB.GT.33)THEN
                     K=1
                     NK=NK+1
                  ENDIF
                  KHIT=IBITS(IQ(JHD+I+NK),K-1,NB)
                  K=K+NB
               ENDIF
               IF(IH.LE.NHDIM)THEN
                  HITS(IH,IHIT)=FLOAT(KHIT)/Q(JDH+4*IH) - Q(JDH+4*IH-1)
               ENDIF
   40       CONTINUE
         ENDIF
   50 CONTINUE
C
   60 NHITS=IHIT
C
   70 RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 25/02/2000  19.34.00  by  Francesco Cafagna
*CMZ :  1.02/00 06/03/97  21.46.02  by  Francesco Cafagna
*CMZ :  1.00/02 04/04/96  16.47.15  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   21/02/96
      SUBROUTINE GPUTOF(IACT,IS,ID,IPA,IT,DELOSS,TIME,PATH,
     +                  TRAPAR,NUMVOL,IMEC)
************************************************************************
*                                                                      *
* To collect and store the hit structure for TOF                       *
*                                                                      *
* Variables definition:                                                *
* IN:                                                                  *
*  IACT, integer specifing the action to be taken. It is the INWVOL    *
*        variable in GCTRAK common                                     *
*  IS    , set number                                                  *
*  ID    , detector number                                             *
*  IPA   , particle number                                             *
*  IT    , track number                                                *
*  DELOSS, energy loss in the step                                     *
*  TIME  , current time of flight in seconds                           *
*  PATH  , current track lenght                                        *
*  TRAPAR, track parameter, is the VECT vector in GCTRAK common        *
*  NUMVOL, integr array of numbers identifying the DETECTOR            *
*  IMEC  , integer indicating the LOSS mecanism position inside NMEC   *
*          vector, zero if not present                                 *
*                                                                      *
* Called by: GUSTEP                                                    *
* Author: Francesco Cafagna, 21/02/96 16.13.51                         *
*                                                                      *
************************************************************************
#include "gphit.inc"
#include "gcunit.inc"
#include "gpsed.inc"
*
      INTEGER IACT,IS,ID,IPA,IT,NUMVOL(20),IMEC,IDHIT
      REAL DELOSS,TIME,PATH,TRAPAR(7),VHIT(NHTOF)
      LOGICAL SAVE
*
* Track is inside a volume
*
      IF(IACT.EQ.0) THEN
         IF(IMEC.GT.0) THEN
            SAVE = .TRUE.
*ML:
*            VHIT(7) = DELOSS + VHIT(7)
            VHIT(11) = DELOSS + VHIT(11)
*END ML.
         ENDIF
      ENDIF
*
* Entering a new volume or is a new track
*
      IF(IACT.EQ.1) THEN
         SAVE = .FALSE.
         CALL VZERO(VHIT,NHTOF)
         DO I=1,3
            VHIT(I) = TRAPAR(I)
         ENDDO
         IF(IMEC.GT.0) THEN
            SAVE = .TRUE.
*ML:
            VHIT(11) = DELOSS
*            VHIT(7) = DELOSS
*END ML.
         ENDIF
         VHIT(8) = TIME
         VHIT(9) = PATH
         VHIT(10) = IPA
*ML:
*         VHIT(11) = TRAPAR(7)
         VHIT(7) = TRAPAR(7)
*END ML.
         IDHIT = -1
      ENDIF
*
* Track is exiting current volume
*
      IF(IACT.EQ.2) THEN
         DO I=1,3
            VHIT(I+3) = TRAPAR(I)
#if defined(GPAMELA_INTER)
* interactive case, we need the average position
            VHIT(I) = (VHIT(I) + VHIT(I+3) )/2.
#endif
         ENDDO
         IF(IMEC.GT.0) THEN
            SAVE = .TRUE.
*ML:
*            VHIT(7) = DELOSS + VHIT(7)
            VHIT(11) = DELOSS +VHIT(11)
*END ML.
         ENDIF
         VHIT(8) = (TIME + VHIT(8))/2.
         VHIT(9) = PATH - VHIT(9)
*ML:
*         VHIT(11) = (TRAPAR(7) + VHIT(11))/2.
         VHIT(7) = (TRAPAR(7) + VHIT(7))/2.
*END ML.
*
* Store the hit
*
         IF(IDHIT.EQ.-1) THEN
*ML:
*            IF (SAVE) CALL GSAHIT (IS,ID,IT,NUMVOL,VHIT,IDHIT)
*            IF (IDHIT.EQ.0) THEN
*               WRITE(CHMAIL,10000) IS,ID,IT
*               CALL GMAIL(1,0)
*            ENDIF
*         ELSE
*            WRITE(CHMAIL,10100) IS,ID,IT
*            CALL GMAIL(1,0)
*         ENDIF
            IF (SAVE) THEN
               IF(IS.EQ.ISS4) THEN
                  CALL GSCHIT(IS,ID,1,NUMVOL,VHIT,1,IDHIT)
               ELSE
                  CALL GSAHIT (IS,ID,IT,NUMVOL,VHIT,IDHIT)
               ENDIF
            ENDIF
            IF (IDHIT.EQ.0) THEN
               WRITE(CHMAIL,10000) IS,ID,IT
               CALL GMAIL(1,0)
            ENDIF
         ELSE
            WRITE(CHMAIL,10100) IS,ID,IT
            CALL GMAIL(1,0)
         ENDIF
*     END ML.
      ENDIF
*
* Track is exiting the set up
*
      IF(IACT.EQ.3) THEN
*
* Check if the hit have been previously stored or not
*
         IF(IDHIT.LT.0) THEN
            DO I=1,3
               VHIT(I+3) = TRAPAR(I)
#if defined(GPAMELA_INTER)
* interactive case, we need the average position
               VHIT(I) = (VHIT(I) + VHIT(I+3) )/2.
#endif
            ENDDO
            IF(IMEC.GT.0) THEN
               SAVE = .TRUE.
*ML:
*               VHIT(7) = DELOSS + VHIT(7)
               VHIT(11) = DELOSS + VHIT(11)
*END ML.
            ENDIF
            VHIT(8) = (TIME + VHIT(8))/2.
            VHIT(9) = PATH - VHIT(9)
*ML:
*            VHIT(11) = (TRAPAR(7) + VHIT(11))/2.
            VHIT(7) = (TRAPAR(7) + VHIT(7))/2.
*END ML.
*
* Store the hit
*
            IF(IDHIT.EQ.-1) THEN
*ML:
*            IF (SAVE) CALL GSAHIT (IS,ID,IT,NUMVOL,VHIT,IDHIT)
*            IF (IDHIT.EQ.0) THEN
*               WRITE(CHMAIL,10200) IS,ID,IT
*               CALL GMAIL(1,0)
*            ENDIF
*         ELSE
*            WRITE(CHMAIL,10300) IS,ID,IT
*            CALL GMAIL(1,0)
*         ENDIF
               IF (SAVE) THEN
                  IF(IS.EQ.ISS4) THEN
                     CALL GSCHIT(IS,ID,1,NUMVOL,VHIT,1,IDHIT)
                  ELSE
                     CALL GSAHIT (IS,ID,IT,NUMVOL,VHIT,IDHIT)
                  ENDIF
               ENDIF
               IF (IDHIT.EQ.0) THEN
                  WRITE(CHMAIL,10200) IS,ID,IT
                  CALL GMAIL(1,0)
               ENDIF
            ELSE
               WRITE(CHMAIL,10300) IS,ID,IT
               CALL GMAIL(1,0)
            ENDIF
*END ML.
*               IF (SAVE) CALL GSAHIT (IS,ID,IT,NUMVOL,VHIT,IDHIT)
*               IF (IDHIT.EQ.0) THEN
*                  WRITE(CHMAIL,10200) IS,ID,IT
*                  CALL GMAIL(1,0)
*               ENDIF
*            ELSE
*               WRITE(CHMAIL,10300) IS,ID,IT
*               CALL GMAIL(1,0)
*            ENDIF
         ENDIF
      ENDIF
10000 FORMAT(' GPUTOF error: HIT have not be stored for SET='
     +       ,I4,', DET=',I4,', TRACK=',I6)
10100 FORMAT(' GPUTOF error: HIT have not be initialized for SET='
     +       ,I4,', DET=',I4,', TRACK=',I6)
10200 FORMAT(' GPUTOF error: HIT have not be stored for SET='
     +       ,I4,', DET=',I4,', TRACK=',I6)
10300 FORMAT(' GPUTOF error: HIT have not be initialized for SET='
     +       ,I4,', DET=',I4,', TRACK=',I6)
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.01/00 30/04/96  18.28.33  by  Francesco Cafagna
*CMZ :  1.00/02 27/03/96  10.30.08  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   24/02/96
      SUBROUTINE GUOUT
************************************************************************
*                                                                      *
* User routine called at the end of one event                          *
*                                                                      *
* Called by: GTRIG                                                     *
* Author: Francesco Cafagna, 24/02/96 13.12.53                         *
*                                                                      *
************************************************************************
#include "gppntp.inc"
#include "gpkey.inc"
*
* User action
*
      CALL GPUOUT
*
* Fill the standard GEANT histos if required
*
      CALL GFHSTA
*
* Just fill the CWN. The commons required have been filled up into the GUDIGI
* rel* related routine
*
      IF(HBK) CALL HFNT(NCWN)
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.02/00 09/10/2000  15.33.16  by  Francesco Cafagna
*CMZ :  2.01/00 05/04/2000  14.35.17  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.00/02 15/03/96  17.52.56  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   02/02/96
      SUBROUTINE GPMAT
************************************************************************
*                                                                      *
* Material Definition for GPAMELA                                      *
*                                                                      *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 02/02/96 17.09.44                         *
*                                                                      *
************************************************************************
#include "gpmat.inc"
C
C           Plastic scintillator
C
      NMSCIN=17
      CALL GSMIXT(NMSCIN,'SCINT$',ASCIN,ZSCIN,DSCIN,-2,WSCIN)
C
C            G10
C
      NMG10 =18
      CALL GSMIXT(NMG10,'G10$',AG10,ZG10,DG10,-2,WG10)
C
C            N2 Gas
C
      NMN2 =19
      CALL GSMATE(NMN2,'N2GAS$',AN2G,ZN2G,DN2G,RN2G,RN2G,0.,0)
C
C            Silicon Tracker and Calo
C
      NMSITR =20
      CALL GSMATE(NMSITR,'SILICON TR$',ASI,ZSI,DSI,RSI,RSI,0.,0)
      NMSICA =21
      CALL GSMATE(NMSICA,'SILICON CA$',ASI,ZSI,DSI,RSI,RSI,0.,0)
C
C            Xenon
C
      NMXE =22
      CALL GSMATE(NMXE,'XENON$',AXE,ZXE,DXE,RXE,RXE,0.,0)
C
C            TRD radiator
C
      NMTRAD =23
      CALL GSMATE(NMTRAD,'TRDRAD$',ATRAD,ZTRAD,DTRAD,RTRAD,RTRAD,0.,0)
C
C            AEROGEL
C
      NMAER =24
      CALL GSMATE(NMAER,'AEROGEL$',AAER,ZAER,DAER,RAER,RAER,0.,0)
*EM:
C
C            TUNGSTEN MIXTURE FOR CALORIMETER
C
      NMWCAL =25	
      CALL GSMIXT(NMWCAL,'TUNGA$',AWCAL,ZWCAL,DWCAL,-3,WWCAL)
C
C 	     CERAMIC MIXTURE FOR CALORIMETER
C
      NMCERA =26	
      CALL GSMIXT(NMCERA,'CERAMIC$',ACERA,ZCERA,DCERA,4,WCERA)
C
C            G10 for Calorimeter
C
      NMG10C =27
      CALL GSMIXT(NMG10C,'G10C$',AG10C,ZG10C,DG10C,4,WG10C)
*END EM.
C
C User action
C
      CALL GPUMAT
C
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.03/00 31/10/2000  11.18.51  by  Francesco Cafagna
*CMZ :  2.02/00 10/10/2000  14.09.00  by  Francesco Cafagna
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 29/02/2000  17.39.10  by  Francesco Cafagna
*CMZ :  1.02/00 10/02/2000  17.28.08  by  Francesco Cafagna
*CMZ :  1.01/00 21/05/96  17.33.38  by  Francesco Cafagna
*CMZ :  1.00/02 05/04/96  11.26.03  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   23/02/96
      SUBROUTINE GPDCAL
************************************************************************
*                                                                      *
* To perform CAL digitization                                          *
*                                                                      *
* Called by: GUDIGI                                                    *
* Author: Francesco Cafagna, 23/02/96 12.50.38                         *
*                                                                      *
************************************************************************
#include "gcunit.inc"
#include "gpphit.inc"
      PARAMETER (NH=NHCAL,NHM=NHMCAL,NVOL=3,NVOL1=2)
#include "gprhit.inc"
#include "gpcal.inc"
#include "gpsed.inc"
#include "gpkey.inc"
#include "gpgeo.inc"
*
      INTEGER IS,ID,NV,NVM,NNHM
      CHARACTER*4 CSET
      INTEGER NUMD1(NVOL1),NUMBV1(NVOL1,NHM)
*
* Vector zeroed
*
      CALL VZERO(ICAPL ,NHMCAL)
      CALL VZERO(ICASI ,NHMCAL)
      CALL VZERO(ICAST ,NHMCAL)
      CALL VZERO(XCASI,NHMCAL)
      CALL VZERO(YCASI,NHMCAL)
      CALL VZERO(ZCASI,NHMCAL)
      CALL VZERO(IPARCAL,NHMCAL)
      CALL VZERO(ERCASI,NHMCAL)
      CALL VZERO(NUMD  ,NVOL)
      CALL VZERO(NUMD1 ,NVOL1)
*
      NV = NVOL
      NVM= NVMAX
      NTHCAL = 0
*
* The tungsten plane case
*
      IS   = ISCAL
      ID   = IDCASI
      IT = -1
      CSET = 'CAL '
*
* Check on the volume level
*
      IF (NV.GT.NVM) THEN
         WRITE(CHMAIL,10000) CSET,CNSED(IS,ID),NVOL,NVMAX,
     +                        IDRUN,IDEVT
         CALL GMAIL(1,0)
         GO TO 10
      ENDIF
      CALL VZERO(VHITS,NH*NHM)
      CALL VZERO(ITRA ,NHM)
      NHITS = -1
*
* Update the max number of hits to be retrived
*
      NNHM = NHM
      IF(NNHM.LE.0) THEN
         WRITE(CHMAIL,10100) CSET,CNSED(IS,ID),NTHCAL,NHM,
     +                        IDRUN,IDEVT
         CALL GMAIL(1,0)
         GO TO 10
      ENDIF
      CALL VZERO(NUMBV,NVOL*NHM)
      CALL GPRHIT(CSET,CNSED(IS,ID),IS,ID,NVOL,NH,NNHM,1,
     +           IT,NUMD,ITRA,NUMBV,VHITS,NHITS)
*
* If there was a problem in GPRHIT then exit
*
      IF(NHITS.LT.0) THEN
         WRITE(CHMAIL,10200) CSET,CNSED(IS,ID),NHITS,NHM,
     +                        IDRUN,IDEVT
         CALL GMAIL(1,0)
         GO TO 10
      ENDIF
*
* >>>>>>>>>>>>>>>>>>>>>> DIGI action
*
*
* Fill the CWN common
*
      DO I=1,NHITS
         NTHCAL = NTHCAL + 1
         ICAPL(NTHCAL) = NUMBV((NVCAL-2),I)
         ICASI(NTHCAL) = NUMBV((NVCAL-1),I)
         ICAST(NTHCAL) = NUMBV((NVCAL),I)
         XINCAL(NTHCAL) = VHITS(1,I)
         YINCAL(NTHCAL) = VHITS(2,I)
         ZINCAL(NTHCAL) = VHITS(3,I)
         ERELCAL(NTHCAL) = VHITS(4,I)
c         IPARCAL(NTHCAL) = VHITS(5,I)
c         P0CAL(NTHCAL) = VHITS(6,I)
      ENDDO
10000  FORMAT(' GPDCAL: VOLUME level too big: SET=',A4,', DET=',A4,',
     +        NVOL=',I3,', NVMAX=',I3,', RUN=',I5,', EVT=',I8)
10100  FORMAT(' GPDCAL: MAX number of hits retrived: SET=',A4,
     +        ', DET=',A4,',NHREAD=',I5,', NHMAX=',I5,
     +        ', RUN=',I5,', EVT=',I8)
10200  FORMAT(' GPDCAL: Error in GPRHIT: SET=',A4,
     +        ', DET=',A4,',NHITS=',I5,', NHMAX=',I5,
     +        ', RUN=',I5,', EVT=',I8)
   10 RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.06  by  Francesco Cafagna
*CMZ :  1.00/02 06/12/95  16.05.16  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   06/12/95
CDECK  ID>, GXINT.
*CMZ :  3.16/00 06/12/93  11.22.04  by  Federico Carminati
*-- Author :    Rene Brun   03/01/89
      PROGRAM GXINT
*
*     GEANT main program. To link with the MOTIF user interface
*     the routine GPAWPP(NWGEAN,NWPAW) should be called, whereas
*     the routine GPAW(NWGEAN,NWPAW) gives access to the basic
*     graphics version.
*
#include "gpmem.inc"
#include "gpzcom.inc"
#include "gpzhbo.inc"
*
#if defined(GPAMELA_X11)
      CALL GPAW(NWGEAN,NWPAW)
#endif
#if defined(GPAMELA_PP)
      CALL GPAWPP(NWGEAN,NWPAW)
#endif
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 06/04/2001  11.21.19  by  Marialuigia Ambriola
*-- Author :    Marialuigia Ambriola   05/04/2001
      INTEGER FUNCTION NPOISS(X)
**************************************
* Simulate the Poisson distribution
* From data particle book vol. 15 2000
**************************************
      REAL U,A,X
      INTEGER K,N
      NPOISS=0
      K=1
      A=1.
 100  U=RNDM(1)
      A=U*A
      IF(A.LT.EXP(-X)) THEN
         N=K-1
      ELSE
         K=K+1
         GOTO 100
      ENDIF
      NPOISS=N
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 28/01/2002  18.13.21  by  Unknown
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.00/02 13/02/96  18.40.55  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   12/02/96
      SUBROUTINE GUTRAK
************************************************************************
*                                                                      *
* User subroutine called for each track                                *
*                                                                      *
* Called by: GTREVE                                                    *
* Author: Francesco Cafagna, 12/02/96 16.16.17                         *
*                                                                      *
************************************************************************
*
* User action
*
#include "gckine.inc"
#include "gptotr.inc"
#include "gcunit.inc"
C # Set the tuning parameter for TR
      REAL PG2,PGXD,PGYD,PGZD,PGP
      ALFATR=-9999.
      TROK=.FALSE.
      PGXD = PVERT(1)
      PGYD = PVERT(2)
      PGZD = PVERT(3)
      PG2 = PGXD**2+PGYD**2+PGZD**2
      IF(PG2.GE.0.) THEN
         PGP    = SQRT(PG2)
         IF(PGP.LT.40.) THEN
            ALFATR=0.65
            TROK=.TRUE.
         ELSE
            ALFATR=0.69
            TROK=.TRUE.
         ENDIF
      ELSE
         WRITE(CHMAIL,10000)ALFATR
         CALL GMAIL(1,0)
c         PRINT*,'GUTRAK error: ALFATR not set',ALFATR
c         PRINT*,'GUTRAK error: momento=',PG2,PVERT(1),PVERT(2),PVERT(3)
      ENDIF
      CALL GPUTRA(1)
*
      CALL GTRACK
*
* User action
*
      CALL GPUTRA(2)
*
10000 FORMAT('GUTRAK error: ALFATR not set=',F10.3)
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.01/00 06/05/96  12.57.17  by  Francesco Cafagna
*CMZ :  1.00/03 15/04/96  17.01.32  by  Francesco Cafagna
*CMZ :  1.00/02 31/03/96  10.11.23  by  Francesco Cafagna
*-- Author :
      SUBROUTINE GDRAWS(ISHAPE,PAR)
C.
C.    ******************************************************************
C.    *                                                                *
C.    *       Draw the shape number ISHAPE, of parameters PAR          *
C.    *                                                                *
C.    * SHAPE     SHAPE    SHAPE                                       *
C.    * NUMBER    TYPE     PARAMETERS                                  *
C.    * -------------------------------------------------------------- *
C.    *                                                                *
C.    *   1       BOX      DX,DY,DZ                                    *
C.    *   2       TRD1     DX1,DX2,DY,DZ                               *
C.    *   3       TRD2     DX1,DX2,DY1,DY2,DZ                          *
C.    *   4       TRAP     DZ,TX,TY,H1,BL1,TL1,TTH1,H2,BL2,TL2,TTH2    *
C.    *                                                                *
C.    *   5       TUBE     RMIN,RMAX,DZ                                *
C.    *   6       TUBS     RMIN,RMAX,DZ,PHIMIN,PHIMAX                  *
C.    *   7       CONE     DZ,RMIN1,RMAX1,RMIN2,RMAX2                  *
C.    *   8       CONS     DZ,RMIN1,RMAX1,RMIN2,RMAX2,PHIMIN,PHIMAX    *
C.    *                                                                *
C.    *   9       SPHE     RMIN,RMAX,THEMIN,THEMAX,PHIMIN,PHIMAX       *
C.    *                                                                *
C.    *  10       PARA     DX,DY,DZ,TXY,TXZ,TYZ                        *
C.    *  11       PGON     PHIMIN,DPHI,NDIV,NZ,Z(1),RMIN(1),RMAX(1),...*
C.    *  12       PCON     PHIMIN,DPHI,NZ,Z(1),RMIN(1),RMAX(1),Z(2),...*
C.    *  13       ELTU     A,B,DZ                                      *
C.    *  14       HYPE     RMIN,RMAX,DZ,PHI                            *
C.    *  NSGTRA   GTRA     DZ,TH,PHI,TWIST,Y1,XL1,XH1,TH1,Y2,XL2,XH2,..*
C.    *  NSCTUB   CTUB     RMIN,RMAX,DZ,PHIMIN,PHIMAX,LXL,LYL,LZL,LXH,.*
C.    *                                                                *
C.    *    ==>Called by : GDRAW                                        *
C.    *       Author : P.Zanarini   *********                          *
C.    *       Modification log.                                        *
C.    *        1-Jun-88 A.C.McPherson - Introduce cut tube shape.      *
C.    *                                                                *
C.    ******************************************************************
C.
#include "gcdraw.inc"
#include "gconsp.inc"
#include "gcshno.inc"
*
      PARAMETER ( NLPC = 40 )
*
*            The constant NLPC defined in the parameter statement
*            is the number of line elements to form a complete
*            circle in the surface definitions for a cut tube.
*
      DIMENSION CPHIS(NLPC+1),SPHIS(NLPC+1)
*
      DIMENSION X(3,46), U(46), V(46)
      DIMENSION PAR(50),P(3,8),PP(3,8)
C.
C.    ------------------------------------------------------------------
C.
      IF (ISHAPE.NE.1) GO TO 10
C
C             BOX
C
      DX1=PAR(1)
      DY1=PAR(2)
      DX2=DX1
      DY2=DY1
      DZ=PAR(3)
      GO TO 170
C
   10 IF (ISHAPE.NE.2) GO TO 20
C
C             TRD1
C
      DX1=PAR(1)
      DX2=PAR(2)
      DY1=PAR(3)
      DY2=DY1
      DZ=PAR(4)
      GO TO 170
C
   20 IF (ISHAPE.NE.3) GO TO 30
C
C             TRD2
C
      DX1=PAR(1)
      DX2=PAR(2)
      DY1=PAR(3)
      DY2=PAR(4)
      DZ=PAR(5)
      GO TO 170
C
   30 IF (ISHAPE.NE.4) GO TO 40
C
C             TRAP
C
      DZ=PAR(1)
      TX=PAR(2)
      TY=PAR(3)
      H1=PAR(4)
      BL1=PAR(5)
      TL1=PAR(6)
      TTH1=PAR(7)
      H2=PAR(8)
      BL2=PAR(9)
      TL2=PAR(10)
      TTH2=PAR(11)
      GO TO 180
C
   40 IF (ISHAPE.NE.5) GO TO 50
C
C             TUBE
C
      RMIN1=PAR(1)
      RMAX1=PAR(2)
      RMIN2=RMIN1
      RMAX2=RMAX1
      Z2=PAR(3)
      Z1=-Z2
      GO TO 200
C
   50 IF (ISHAPE.NE.6) GO TO 60
C
C             TUBS
C
      RMIN1=PAR(1)
      RMAX1=PAR(2)
      RMIN2=RMIN1
      RMAX2=RMAX1
      Z2=PAR(3)
      Z1=-Z2
      PHIMIN=PAR(4)
      PHIMAX=PAR(5)
      GO TO 210
C
   60 IF (ISHAPE.NE.7) GO TO 70
C
C             CONE
C
      RMIN1=PAR(2)
      RMAX1=PAR(3)
      RMIN2=PAR(4)
      RMAX2=PAR(5)
      Z2=PAR(1)
      Z1=-Z2
      GO TO 200
C
   70 IF (ISHAPE.NE.8) GO TO 80
C
C             CONS
C
      RMIN1=PAR(2)
      RMAX1=PAR(3)
      RMIN2=PAR(4)
      RMAX2=PAR(5)
      Z2=PAR(1)
      Z1=-Z2
      PHIMIN=PAR(6)
      PHIMAX=PAR(7)
      GO TO 210
C
   80 IF (ISHAPE.NE.9) GO TO 90
C
C             SPHE
C
      RMIN=PAR(1)
      RMAX=PAR(2)
      thmi=par(3)
      thma=par(4)
      PHMI=PAR(5)
      PHMA=PAR(6)
      GO TO 240
C
   90 IF (ISHAPE.NE.10) GO TO 100
C
C             PARA
C
      DX=PAR(1)
      DY=PAR(2)
      DZ=PAR(3)
      TXY=PAR(4)
      TXZ=PAR(5)
      TYZ=PAR(6)
C
      TX=TXZ
      TY=TYZ
      H1=DY
      BL1=DX
      TL1=DX
      TTH1=TXY
      H2=DY
      BL2=DX
      TL2=DX
      TTH2=TXY
      GO TO 180
C
  100 IF (ISHAPE.NE.11) GO TO 110
C
C             PGON
C
      PHIMIN=PAR(1)
      PHIMAX=PHIMIN+PAR(2)
      NDIV=PAR(3)
      NZ=PAR(4)
      DPHI=(PHIMAX-PHIMIN)/NDIV
C
C             Z(1)=PAR(5) - RMIN(1)=PAR(6) - RMAX(1)=PAR(7) - Z(2)=PAR(8) - ...
C
      GO TO 300
C
  110 IF (ISHAPE.NE.12) GO TO 120
C
C             PCON
C
      PHIMIN=PAR(1)
      PHIMAX=PHIMIN+PAR(2)
      NZ=PAR(3)
C
C             Z(1)=PAR(4) - RMIN(1)=PAR(5) - RMAX(1)=PAR(6) - Z(2)=PAR(7) - ...
C
      GO TO 400
C
  120 CONTINUE
C
      IF (ISHAPE.NE.13) GO TO 130
C
C             ELTU
C
      A=PAR(1)
      B=PAR(2)
      Z2=PAR(3)
      Z1=-Z2
      GO TO 530
  130 CONTINUE
C
      IF (ISHAPE.NE.14) GO TO 140
C
C             HYPErboloid
C
      RMIN1 = PAR(1)
      RMAX1 = PAR(2)
      Z2=PAR(3)
      TANTHS = (TAN(PAR(4)*DEGRAD))**2
      RMIN12 = RMIN1*RMIN1
      RMAX12 = RMAX1*RMAX1
      RMIN2 = SQRT(RMIN12 + Z2*Z2*TANTHS)
      RMAX2 = SQRT(RMAX12 + Z2*Z2*TANTHS)
      Z1=-Z2
      GO TO 540

  140 CONTINUE
      IF(ISHAPE.NE.28) GO TO 160
C
C             General twisted trapezoid.
C
      DO 150 IL=1,4
         I0=IL*4+11
         P(3,IL)=-PAR(1)
         P(1,IL)=PAR(I0)+PAR(I0+2)*P(3,IL)
         P(2,IL)=PAR(I0+1)+PAR(I0+3)*P(3,IL)
         P(3,IL+4)=PAR(1)
         P(1,IL+4)=PAR(I0)+PAR(I0+2)*P(3,IL+4)
         P(2,IL+4)=PAR(I0+1)+PAR(I0+3)*P(3,IL+4)
  150 CONTINUE
C
      GO TO 190
*
  160 CONTINUE
      IF( ISHAPE .EQ. NSCTUB ) THEN
*
         DPHIS = PAR(5)-PAR(4)
         IF( DPHIS .LE. 0.0 ) DPHIS=DPHIS+TWOPI
         NL = MAX(DPHIS*NLPC/360.0,1.)
         DPHI = 360.0/NLPC
         PHIS = PAR(4)
         IF( PAR(4) .EQ. 0.0 .AND. PAR(5) .EQ. 360.0 ) THEN
            ISEG = 0
         ELSE
            ISEG = 1
            DPHI = DPHIS/NL
         ENDIF
*
         GO TO 470
*
      ELSE
         GO TO 999
      ENDIF
C
  170 CONTINUE
C
C             Rectilinear shapes: BOX,TRD1,TRD2
C
      X1=0.
      Y1=0.
      X2=0.
      Y2=0.
      Z1=-DZ
      Z2=DZ
C
C             Calculate the 8 vertex for rectilinear shapes
C
      P(1,1)=X1+DX1
      P(2,1)=Y1+DY1
      P(3,1)=Z1
      P(1,2)=X1-DX1
      P(2,2)=Y1+DY1
      P(3,2)=Z1
      P(1,3)=X1-DX1
      P(2,3)=Y1-DY1
      P(3,3)=Z1
      P(1,4)=X1+DX1
      P(2,4)=Y1-DY1
      P(3,4)=Z1
      P(1,5)=X2+DX2
      P(2,5)=Y2+DY2
      P(3,5)=Z2
      P(1,6)=X2-DX2
      P(2,6)=Y2+DY2
      P(3,6)=Z2
      P(1,7)=X2-DX2
      P(2,7)=Y2-DY2
      P(3,7)=Z2
      P(1,8)=X2+DX2
      P(2,8)=Y2-DY2
      P(3,8)=Z2
C
      CALL GDRECT(P(1,1),P(1,2),P(1,3),P(1,4))
      CALL GDRECT(P(1,5),P(1,6),P(1,7),P(1,8))
      CALL GDLINE(P(1,1),P(1,5))
      CALL GDLINE(P(1,2),P(1,6))
      CALL GDLINE(P(1,3),P(1,7))
      CALL GDLINE(P(1,4),P(1,8))
C
      GO TO 999
C
  180 CONTINUE
C
C             TRAP,PARA
C
C             Calculate the 8 vertex
C
      P(1,1)=-DZ*TX+TTH1*H1+TL1
      P(2,1)=+H1-DZ*TY
      P(3,1)=-DZ
      P(1,2)=-DZ*TX+TTH1*H1-TL1
      P(2,2)=+H1-DZ*TY
      P(3,2)=-DZ
      P(1,3)=-DZ*TX-TTH1*H1-BL1
      P(2,3)=-H1-DZ*TY
      P(3,3)=-DZ
      P(1,4)=-DZ*TX-TTH1*H1+BL1
      P(2,4)=-H1-DZ*TY
      P(3,4)=-DZ
      P(1,5)=+DZ*TX+TTH2*H2+TL2
      P(2,5)=+H2+DZ*TY
      P(3,5)=+DZ
      P(1,6)=+DZ*TX+TTH2*H2-TL2
      P(2,6)=+H2+DZ*TY
      P(3,6)=+DZ
      P(1,7)=+DZ*TX-TTH2*H2-BL2
      P(2,7)=-H2+DZ*TY
      P(3,7)=+DZ
      P(1,8)=+DZ*TX-TTH2*H2+BL2
      P(2,8)=-H2+DZ*TY
      P(3,8)=+DZ
C
  190 CONTINUE
C
      CALL GDRECT(P(1,1),P(1,2),P(1,3),P(1,4))
      CALL GDRECT(P(1,5),P(1,6),P(1,7),P(1,8))
      CALL GDLINE(P(1,1),P(1,5))
      CALL GDLINE(P(1,2),P(1,6))
      CALL GDLINE(P(1,3),P(1,7))
      CALL GDLINE(P(1,4),P(1,8))
C
C             Condition for plane sides are :
C
C             TTH1=TTH2
C
C             and
C
C             H2*(BL1-TL1)=H1(BL2-TL2)
C
C             In that case we should draw on each side 10 lines
C             (perpendicular to side lines) to make an easy
C             visualisation that sides are not planes
C
      GO TO 999
C
  200 CONTINUE
C
C             Cylindric shapes: TUBE,CONE
C
      CALL GDCIRC(RMAX1,Z1)
      CALL GDCIRC(RMIN1,Z1)
      CALL GDCIRC(RMAX2,Z2)
      CALL GDCIRC(RMIN2,Z2)
      PHIP=GPHI+90.
      PHIM=GPHI+270.
      CALL GDLCYL(RMIN1,PHIP,Z1,RMIN2,PHIP,Z2)
      CALL GDLCYL(RMIN1,PHIM,Z1,RMIN2,PHIM,Z2)
      CALL GDLCYL(RMAX1,PHIP,Z1,RMAX2,PHIP,Z2)
      CALL GDLCYL(RMAX1,PHIM,Z1,RMAX2,PHIM,Z2)
C
      GO TO 999
C
  210 CONTINUE
C
C             Segmented cylindric shapes: TUBS,CONS
C
      CALL GDARC(RMAX1,Z1,PHIMIN,PHIMAX)
      CALL GDARC(RMIN1,Z1,PHIMIN,PHIMAX)
      CALL GDARC(RMAX2,Z2,PHIMIN,PHIMAX)
      CALL GDARC(RMIN2,Z2,PHIMIN,PHIMAX)
      PHIP=AMOD((GPHI+90.),360.)
      PHIM=AMOD((GPHI+270.),360.)
      IF (PHIP.LE.PHIMIN.OR.PHIP.GE.PHIMAX) GO TO 220
      CALL GDLCYL(RMIN1,PHIP,Z1,RMIN2,PHIP,Z2)
      CALL GDLCYL(RMAX1,PHIP,Z1,RMAX2,PHIP,Z2)
  220 IF (PHIM.LE.PHIMIN.OR.PHIM.GE.PHIMAX) GO TO 230
      CALL GDLCYL(RMIN1,PHIM,Z1,RMIN2,PHIM,Z2)
      CALL GDLCYL(RMAX1,PHIM,Z1,RMAX2,PHIM,Z2)
  230 CALL GDLCYL(RMAX1,PHIMIN,Z1,RMAX2,PHIMIN,Z2)
      CALL GDLCYL(RMAX1,PHIMAX,Z1,RMAX2,PHIMAX,Z2)
      CALL GDLCYL(RMIN1,PHIMIN,Z1,RMIN2,PHIMIN,Z2)
      CALL GDLCYL(RMIN1,PHIMAX,Z1,RMIN2,PHIMAX,Z2)
      CALL GDLCYL(RMAX1,PHIMIN,Z1,RMIN1,PHIMIN,Z1)
      CALL GDLCYL(RMAX2,PHIMIN,Z2,RMIN2,PHIMIN,Z2)
      CALL GDLCYL(RMAX1,PHIMAX,Z1,RMIN1,PHIMAX,Z1)
      CALL GDLCYL(RMAX2,PHIMAX,Z2,RMIN2,PHIMAX,Z2)
C
      GO TO 999
C
  240 CONTINUE
C
C             SPHE
C
C Setup theta, phi loop intervals.
C
      dt = thma-thmi
      ntstep = max(dt/15.,1.)
      ddt = dt/ntstep
      tth = thmi - ddt
      dp = phma-phmi
      if (dp.le.0.) dp = dp+360.
      npstep = max(dp/15.,1.)
      ddp = dp/npstep
C
C Loop over theta.
C
      do 250  j = 1,ntstep+1
         tth = tth + ddt
         rarc1 = rmax*sin(tth*degrad)
         zarc1 = rmax*cos(tth*degrad)
         rarc2 = rmin*sin(tth*degrad)
         zarc2 = rmin*cos(tth*degrad)
C
C Draw latitude arcs.
C
         call gdarc(rarc1,zarc1,phmi,phma)
         call gdarc(rarc2,zarc2,phmi,phma)
C
C Loop over phi and draw radial segments.
C
         pph = phmi - ddp
         do 250  i = 1,npstep+1
            pph = pph + ddp
            rpph = pph*degrad
            cosph = cos(rpph)
            sinph = sin(rpph)
            p(1,1) = rarc1*cosph
            p(2,1) = rarc1*sinph
            p(3,1) = zarc1
            p(1,2) = rarc2*cosph
            p(2,2) = rarc2*sinph
            p(3,2) = zarc2
            if (j.eq.1.or.j.eq.ntstep+1.or.i.eq.1.or.i.eq.npstep+1)
     +      call gdline(p(1,1),p(1,2))
  250 continue
C
C Loop over PHI, and draw theta arcs.
C
      PPH = PHMI - DDP
      DO 270  I=1,NPSTEP+1
         PPH = PPH+DDP
         RPPH = PPH*DEGRAD
         COSPH = COS(RPPH)
         SINPH = SIN(RPPH)
         DO 260  J=1,46
            THET = ((J-1)*dt/45. + thmi)*degrad
            X(1,J) = RMAX*SIN(THET)*COSPH
            X(2,J) = RMAX*SIN(THET)*SINPH
            X(3,J) = RMAX*COS(THET)
  260    CONTINUE
         CALL GDFR3D(X,46,U,V)
         CALL GDRAWV(U,V,46)
  270 CONTINUE
      IF(RMIN.GE.0.) THEN
         PPH = PHMI-DDP
         DO 290  I=1,NPSTEP+1
            PPH = PPH+DDP
            RPPH = PPH*DEGRAD
            COSPH = COS(RPPH)
            SINPH = SIN(RPPH)
            DO 280  J=1,46
               THET = ((J-1)*dt/45. + thmi)*degrad
               X(1,J) = RMIN*SIN(THET)*COSPH
               X(2,J) = RMIN*SIN(THET)*SINPH
               X(3,J) = RMIN*COS(THET)
  280       CONTINUE
            CALL GDFR3D(X,46,U,V)
            CALL GDRAWV(U,V,46)
  290    CONTINUE
      ENDIF
      GO TO 999
C
  300 CONTINUE
C
C             PGON
C
      FACT=1./COS(DEGRAD*DPHI/2.)
      DO 310  IZ=1,NZ
         PAR(6+(IZ-1)*3)=PAR(6+(IZ-1)*3)*FACT
         PAR(7+(IZ-1)*3)=PAR(7+(IZ-1)*3)*FACT
  310 CONTINUE
C
      DO 390  IZ=1,NZ
C
         ZI=PAR(5+(IZ-1)*3)
         R0=PAR(6+(IZ-1)*3)
         R1=PAR(7+(IZ-1)*3)
C
         IF (IZ.EQ.1.OR.IZ.EQ.NZ) GO TO 320
         R0PRE=PAR(6+(IZ-2)*3)
         R0POST=PAR(6+IZ*3)
         IF (R0.EQ.R0PRE)GO TO 340
         IF (R0.EQ.R0POST)GO TO 340
  320    CONTINUE
         DO 330  IDIV=1,NDIV
            PHI0=PHIMIN+(IDIV-1)*DPHI
            PHI1=PHI0+DPHI
            CALL GDLCYL(R0,PHI0,ZI,R0,PHI1,ZI)
  330    CONTINUE
C
  340    IF (IZ.EQ.1.OR.IZ.EQ.NZ) GO TO 350
         R1PRE=PAR(7+(IZ-2)*3)
         R1POST=PAR(7+IZ*3)
         IF (R1.EQ.R1PRE )GO TO 370
         IF (R1.EQ.R1POST)GO TO 370
  350    CONTINUE
         DO 360  IDIV=1,NDIV
            PHI0=PHIMIN+(IDIV-1)*DPHI
            PHI1=PHI0+DPHI
            CALL GDLCYL(R1,PHI0,ZI,R1,PHI1,ZI)
  360    CONTINUE
C
  370    IF ((IZ.EQ.1.OR.IZ.EQ.NZ).AND.(PHIMAX-PHIMIN.NE.360.)) THEN
            CALL GDLCYL(R0,PHIMIN,ZI,R1,PHIMIN,ZI)
            CALL GDLCYL(R0,PHIMAX,ZI,R1,PHIMAX,ZI)
         ENDIF
C
         IF (IZ.EQ.1) GO TO 390
C
         ZI0=PAR(5+(IZ-2)*3)
         R00=PAR(6+(IZ-2)*3)
         R10=PAR(7+(IZ-2)*3)
         DO 380  IDIV=1,NDIV
            PH=PHIMIN+(IDIV-1)*DPHI
            CALL GDLCYL(R00,PH,ZI0,R0,PH,ZI)
            CALL GDLCYL(R10,PH,ZI0,R1,PH,ZI)
  380    CONTINUE
         CALL GDLCYL(R00,PHIMAX,ZI0,R0,PHIMAX,ZI)
         CALL GDLCYL(R10,PHIMAX,ZI0,R1,PHIMAX,ZI)
C
  390 CONTINUE
C
      GO TO 999
C
  400 CONTINUE
C
C             PCON
C
      DO 460  IZ=1,NZ
         ZI=PAR(4+(IZ-1)*3)
         R0=PAR(5+(IZ-1)*3)
         R1=PAR(6+(IZ-1)*3)
         IF (IZ.EQ.1.OR.IZ.EQ.NZ) GO TO 410
         R1PRE=PAR(6+(IZ-2)*3)
         R1POST=PAR(6+IZ*3)
         IF (R1.LE.R1PRE.OR.R1.LE.R1POST) GO TO 420
  410    CONTINUE
         CALL GDARC(R0,ZI,PHIMIN,PHIMAX)
         CALL GDARC(R1,ZI,PHIMIN,PHIMAX)
  420    CONTINUE
         IF ((PHIMAX-PHIMIN).EQ.360.) GO TO 430
         CALL GDLCYL(R0,PHIMIN,ZI,R1,PHIMIN,ZI)
         CALL GDLCYL(R0,PHIMAX,ZI,R1,PHIMAX,ZI)
  430    CONTINUE
         IF (IZ.EQ.1) GO TO 460
         ZI0=PAR(4+(IZ-2)*3)
         R00=PAR(5+(IZ-2)*3)
         R10=PAR(6+(IZ-2)*3)
         IF ((PHIMAX-PHIMIN).EQ.360.) GO TO 440
         CALL GDLCYL(R00,PHIMIN,ZI0,R0,PHIMIN,ZI)
         CALL GDLCYL(R10,PHIMIN,ZI0,R1,PHIMIN,ZI)
         CALL GDLCYL(R00,PHIMAX,ZI0,R0,PHIMAX,ZI)
         CALL GDLCYL(R10,PHIMAX,ZI0,R1,PHIMAX,ZI)
C
  440    CONTINUE
         PHIP=AMOD((GPHI+90.),360.)
         PHIM=AMOD((GPHI+270.),360.)
         IF (PHIP.LT.PHIMIN.OR.PHIP.GT.PHIMAX) GO TO 450
         CALL GDLCYL(R00,PHIP,ZI0,R0,PHIP,ZI)
         CALL GDLCYL(R10,PHIP,ZI0,R1,PHIP,ZI)
  450    IF (PHIM.LT.PHIMIN.OR.PHIM.GT.PHIMAX) GO TO 460
         CALL GDLCYL(R00,PHIM,ZI0,R0,PHIM,ZI)
         CALL GDLCYL(R10,PHIM,ZI0,R1,PHIM,ZI)
  460 CONTINUE
C
      GO TO 999
*
  470 CONTINUE
*
*          Cut tube shape.
*
      CPHIS(1) = COS( PHIS*DEGRAD )
      SPHIS(1) = SIN( PHIS*DEGRAD )
      DO 480  I = 1, NL
         PHIS = PHIS+DPHI
         CPHIS(I+1) = COS( PHIS*DEGRAD )
         SPHIS(I+1) = SIN( PHIS*DEGRAD )
  480 CONTINUE
      P( 1, 1) = PAR(2)*CPHIS(1)
      P( 2, 1) = PAR(2)*SPHIS(1)
      P( 3, 1) = -( PAR( 6)*P( 1, 1) +PAR( 7)*P( 2, 1) )/PAR( 8)
     + -PAR( 3)
      P( 1, 4) = PAR(1)*CPHIS(1)
      P( 2, 4) = PAR(1)*SPHIS(1)
      P( 3, 4) = -( PAR( 6)*P( 1, 4) +PAR( 7)*P( 2, 4) )/PAR( 8)
     + -PAR( 3)
      P( 1, 5) = PAR(2)*CPHIS(1)
      P( 2, 5) = PAR(2)*SPHIS(1)
      P( 3, 5) = -( PAR( 9)*P( 1, 5) +PAR( 10)*P( 2, 5) )/PAR( 11)
     + +PAR( 3)
      P( 1, 8) = PAR(1)*CPHIS(1)
      P( 2, 8) = PAR(1)*SPHIS(1)
      P( 3, 8) = -( PAR( 9)*P( 1, 8) +PAR( 10)*P( 2, 8) )/PAR( 11)
     + +PAR( 3)
*
      IF( ISEG .EQ. 1 ) THEN
         CALL GDRECT( P( 1, 1), P( 1, 4), P( 1, 8), P( 1, 5) )
      ENDIF
*
      DO 490  I = 1, NL
         P( 1, 2) = PAR(2)*CPHIS(I+1)
         P( 2, 2) = PAR(2)*SPHIS(I+1)
         P( 3, 2) = -( PAR( 6)*P( 1, 2) +PAR( 7)*P( 2, 2) )/PAR( 8)
     +   -PAR( 3)
         CALL GDLINE( P( 1, 1), P( 1, 2) )
         P( 1, 1) = P( 1, 2)
         P( 2, 1) = P( 2, 2)
         P( 3, 1) = P( 3, 2)
  490 CONTINUE
*
      DO 500  I = 1, NL
         P( 1, 3) = PAR(1)*CPHIS(I+1)
         P( 2, 3) = PAR(1)*SPHIS(I+1)
         P( 3, 3) = -( PAR( 6)*P( 1, 3) +PAR( 7)*P( 2, 3) )/PAR( 8)
     +   -PAR( 3)
         CALL GDLINE( P( 1, 4), P( 1, 3) )
         P( 1, 4) = P( 1, 3)
         P( 2, 4) = P( 2, 3)
         P( 3, 4) = P( 3, 3)
  500 CONTINUE
*
      DO 510  I = 1, NL
         P( 1, 6) = PAR(2)*CPHIS(I+1)
         P( 2, 6) = PAR(2)*SPHIS(I+1)
         P( 3, 6) = -( PAR( 9)*P( 1, 6) +PAR( 10)*P( 2, 6) )/PAR( 11)
     +   +PAR( 3)
         CALL GDLINE( P( 1, 5), P( 1, 6) )
         P( 1, 5) = P( 1, 6)
         P( 2, 5) = P( 2, 6)
         P( 3, 5) = P( 3, 6)
  510 CONTINUE
*
      DO 520  I = 1, NL
         P( 1, 7) = PAR(1)*CPHIS(I+1)
         P( 2, 7) = PAR(1)*SPHIS(I+1)
         P( 3, 7) = -( PAR( 9)*P( 1, 7) +PAR( 10)*P( 2, 7) )/PAR( 11)
     +   +PAR( 3)
         CALL GDLINE( P( 1, 8), P( 1, 7) )
         P( 1, 8) = P( 1, 7)
         P( 2, 8) = P( 2, 7)
         P( 3, 8) = P( 3, 7)
  520 CONTINUE
*
      IF( ISEG .EQ. 1 ) THEN
         CALL GDRECT( P( 1, 1), P( 1, 4), P( 1, 8), P( 1, 5) )
      ENDIF
*
      PHIP = AMOD( GPHI+90.0, 360.0 )
      PHIM = AMOD( GPHI+270.0, 360.0 )
      DPHIP = PHIP-PAR(4)
      DPHIM = PHIM-PAR(4)
      IF( DPHIP .LT. 0.0 ) DPHIP = DPHIP+TWOPI
      IF( DPHIM .LT. 0.0 ) DPHIM = DPHIM+TWOPI
*
      IF( DPHIP .LE. DPHIS ) THEN
         CP = COS( PHIP*DEGRAD )
         SP = SIN( PHIP*DEGRAD )
         P( 1, 1) = PAR(2)*CP
         P( 2, 1) = PAR(2)*SP
         P( 3, 1) = -( PAR( 6)*P( 1, 1) +PAR( 7)*P( 2, 1) )/PAR( 8)
     +   -PAR( 3)
         P( 1, 4) = PAR(1)*CP
         P( 2, 4) = PAR(1)*SP
         P( 3, 4) = -( PAR( 6)*P( 1, 4) +PAR( 7)*P( 2, 4) )/PAR( 8)
     +   -PAR( 3)
         P( 1, 5) = PAR(2)*CP
         P( 2, 5) = PAR(2)*SP
         P( 3, 5) = -( PAR( 9)*P( 1, 5) +PAR( 10)*P( 2, 5) )/PAR( 11)
     +   +PAR( 3)
         P( 1, 8) = PAR(1)*CP
         P( 2, 8) = PAR(1)*SP
         P( 3, 8) = -( PAR( 9)*P( 1, 8) +PAR( 10)*P( 2, 8) )/PAR( 11)
     +   +PAR( 3)
         CALL GDLINE( P( 1, 1), P( 1, 5) )
         CALL GDLINE( P( 1, 4), P( 1, 8) )
*
      ENDIF
*
      IF( DPHIM .LE. DPHIS ) THEN
         CP = COS( PHIM*DEGRAD )
         SP = SIN( PHIM*DEGRAD )
         P( 1, 1) = PAR(2)*CP
         P( 2, 1) = PAR(2)*SP
         P( 3, 1) = -( PAR( 6)*P( 1, 1) +PAR( 7)*P( 2, 1) )/PAR( 8)
     +   -PAR( 3)
         P( 1, 4) = PAR(1)*CP
         P( 2, 4) = PAR(1)*SP
         P( 3, 4) = -( PAR( 6)*P( 1, 4) +PAR( 7)*P( 2, 4) )/PAR( 8)
     +   -PAR( 3)
         P( 1, 5) = PAR(2)*CP
         P( 2, 5) = PAR(2)*SP
         P( 3, 5) = -( PAR( 9)*P( 1, 5) +PAR( 10)*P( 2, 5) )/PAR( 11)
     +   +PAR( 3)
         P( 1, 8) = PAR(1)*CP
         P( 2, 8) = PAR(1)*SP
         P( 3, 8) = -( PAR( 9)*P( 1, 8) +PAR( 10)*P( 2, 8) )/PAR( 11)
     +   +PAR( 3)
         CALL GDLINE( P( 1, 1), P( 1, 5) )
         CALL GDLINE( P( 1, 4), P( 1, 8) )
*
      ENDIF
      GO TO 999
C
  530 CONTINUE
C
C             ELTU
C
      CALL GDELTU(A,B,Z1)
      CALL GDELTU(A,B,Z2)
      P(1,1)=A
      P(2,1)=0.
      P(3,1)=Z1
      P(1,2)=A
      P(2,2)=0.
      P(3,2)=Z2
      P(1,3)=-A
      P(2,3)=0.
      P(3,3)=Z1
      P(1,4)=-A
      P(2,4)=0.
      P(3,4)=Z2
      CALL GDLINE(P(1,1),P(1,2))
      CALL GDLINE(P(1,3),P(1,4))
      GO TO 999
C                               draw HYPErboloid
  540 CONTINUE
      PP(2,1) = RMAX2
      PP(2,3) = RMIN2
      P(1,1) = 0.
      P(1,2) = 0.
      P(1,3) = 0.
      P(1,4) = 0.
      PP(3,1) = Z2
      PP(3,3) = Z2
      CALL GDCIRC(RMAX2,Z1)
      CALL GDCIRC(RMIN2,Z1)
      CALL GDCIRC(RMAX2,Z2)
      CALL GDCIRC(RMIN2,Z2)
      NZSTEP = 20
      DELZ = Z2 / NZSTEP
      DO 570  IZ = 1, NZSTEP
         ZZ = Z2 - IZ*DELZ
         PP(3,2) = ZZ
         PP(3,4) = ZZ
         ZZZ = ZZ*ZZ*TANTHS
         PP(2,2) = SQRT(RMAX12 + ZZZ)
         PP(2,4) = SQRT(RMIN12 + ZZZ)
         DO 560  ISY = -1, +1, 2
            DO 560  ISZ = -1, +1, 2
               DO 550  J = 1, 4
                  P(2,J) = ISY * PP(2,J)
                  P(3,J) = ISZ * PP(3,J)
  550          CONTINUE
               CALL GDLINE(P(1,1),P(1,2))
               CALL GDLINE(P(1,3),P(1,4))
  560    CONTINUE
         PP(2,1) = PP(2,2)
         PP(2,3) = PP(2,4)
         PP(3,1) = PP(3,2)
         PP(3,3) = PP(3,4)
  570 CONTINUE
C
  999 END

*-- Author :    Francesco Cafagna   02/05/96
      SUBROUTINE FFUSER(KEY)
************************************************************************
*                                                                      *
* User action required in FFREAD                                       *
*                                                                      *
* Variables definition:                                                *
* IN:                                                                  *
*  KEY , Integer with key that caused the FFUSER call                  *
* Called by: FFGO                                                      *
* Author: Francesco Cafagna, 02/05/96 08.57.54                         *
*                                                                      *
************************************************************************
#include "gpkey.inc"
#include "gpunit.inc"
      INTEGER KEY
      CHARACTER*4 CKEY
C
      CALL UHTOC (KEY,4,CKEY,4)
C
C         Card *HBFI action, save name and logical units for HBOOK file
C
      IF(CKEY.EQ.'HBFI') THEN
         LUHBK = NHBFILE(1)

C
C         Convert the file name
C
         CALL UHTOC(NHBFILE(2),4,CHHBK,80)
      ENDIF
C
C         Card *GAFI action, save name and logical units for GARFIELD file
C
      IF(CKEY.EQ.'GAFI') THEN
         LUGAR = NGARFILE(1)

C
C         Convert the file name
C
         CALL UHTOC(NGARFILE(2),4,CHGAR,80)
      ENDIF
C
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.03/00 06/11/2000  01.11.37  by  Francesco Cafagna
*CMZ :  2.01/00 05/04/2000  14.35.17  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 21/10/99  16.30.25  by  Francesco Cafagna
*CMZ :  1.00/02 15/03/96  16.25.51  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   13/02/96
      SUBROUTINE GPHIT
************************************************************************
*                                                                      *
* HITS definition                                                      *
*                                                                      *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 13/02/96 18.20.10                         *
*                                                                      *
************************************************************************
#include "gphit.inc"
#include "gpsed.inc"
#include "gpkey.inc"
*
* Tof
*
      IF(PTOF) THEN
         CALL GSDETH ('S11 ',CNSED(ISS11,IDS11X),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
         CALL GSDETH ('S12 ',CNSED(ISS12,IDS12Y),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
*
         CALL GSDETH ('S21 ',CNSED(ISS21,IDS21X),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
         CALL GSDETH ('S22 ',CNSED(ISS22,IDS22Y),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
*
         CALL GSDETH ('S31 ',CNSED(ISS31,IDS31Y),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
         CALL GSDETH ('S32 ',CNSED(ISS32,IDS32X),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
*
         CALL GSDETH ('S4  ',CNSED(ISS4,IDS4),NHTOF,CHTOF, NBHTOF,
     +   OHTOF,FHTOF)
      ENDIF
*
* TRD
*
      IF(PTRD) THEN
         CALL GSDETH ('TRD ',CNSED(ISTRD,IDTRSI),NHTRD,CHTRD,NBHTRD,
     +   OHTRD,FHTRD)
      ENDIF
*
* CAT
*
      IF(PCAT) THEN
         CALL GSDETH ('CAT ',CNSED(ISCAT,IDCATL),NHCAT,CHCAT, NBHCAT,
     +   OHCAT,FHCAT)
         CALL GSDETH ('CAT ',CNSED(ISCAT,IDCATT),NHCAT,CHCAT, NBHCAT,
     +   OHCAT,FHCAT)
      ENDIF
*
* CAS
*
      IF(PCAS) THEN
         CALL GSDETH ('CAS ',CNSED(ISCAS,IDCASX),NHCAS,CHCAS,NBHCAS,
     +   OHCAS,FHCAS)
         CALL GSDETH ('CAS ',CNSED(ISCAS,IDCASY),NHCAS,CHCAS,NBHCAS,
     +   OHCAS,FHCAS)
      ENDIF
*
* SPE
*
      IF(PSPE) CALL GSDETH ('SPE ',CNSED(ISSPE,IDTSPA),
     +             NHSPE,CHSPE,NBHSPE,OHSPE,FHSPE)
*
* CAL
*
      IF(PCAL) THEN
         CALL GSDETH ('CAL ',CNSED(ISCAL,IDCASI),
     +                NHCAL,CHCAL,NBHCAL,OHCAL,FHCAL)
      ENDIF
*
* User action
*
      CALL GPUHIT
*
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.01/00 06/05/96  12.57.18  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   03/05/96
      REAL FUNCTION GPGAUS(XDUMMY)
************************************************************************
*                                                                      *
* To generate a normally distribute deviate with zero mean and unit variance *
* From GASDEV, Numerical recepies $7.3.                                *
* Variables definition:                                                *
* IN:                                                                  *
*  XDUMMY, dummy argument                                              *
*                                                                      *
* Called by:<USER>                                                     *
* Author: Francesco Cafagna, 03/05/96 17.11.14                         *
*                                                                      *
************************************************************************
      INTEGER ISET
      REAL V1,V2,GAS1,RVAL(2),R
*
      DATA ISET/0/
*
* Generate a random number in the circle of radius 1
*
      IF (ISET.EQ.0) THEN
   10    CALL GRNDM(RVAL,2)
         V1 = 2.*RVAL(1) -1.
         V2 = 2.*RVAL(2) -1.
         R  = V1**2 + V2**2
         IF(R.GE.1.) GO TO 10
         GAS1 = V1 * SQRT(-2.*LOG(R)/R)
         GPGAUS = V2 * SQRT(-2.*LOG(R)/R)
         ISET = 1
      ELSE
         GPGAUS = GAS1
         ISET = 0
      ENDIF
*
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 09/02/2000  13.11.57  by  Francesco Cafagna
*CMZ :  1.00/02 15/03/96  16.04.21  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   05/12/95
      SUBROUTINE GPTRDV
************************************************************************
*                                                                      *
* Volume definition for TRD                                            *
* Called by: GPGEO                                                     *
* Author: Francesco Cafagna, 05/12/95 17.25.32                         *
*                                                                      *
************************************************************************
#include "gpgeo.inc"
#include "gpmed.inc"
*
      INTEGER IROT,IVOLU,N,NMED,NUM,NAN
      REAL X,Y,Z
*
*  Define the TRDB     volume
*
      NMED=MN2
      CALL GSVOLU('TRDB','BOX ',NMED,TRDB, 3,IVOLU)
*
*  Define the TRAN     volume
*
      NMED=MAL
      CALL GSVOLU('TRAN','BOX ',NMED,TRAN, 3,IVOLU)
*
*  Define the TRAI     volume
*
      NMED=MN2
      CALL GSVOLU('TRAI','BOX ',NMED,TRAI, 3,IVOLU)
*
*  Define the TRBS     volumes
*
      NMED=MN2
      CALL GSVOLU('TRBS','BOX ',NMED,TRBS, 3,IVOLU)
*
*  Define the TRSO     volumes
*
      NMED=MKAP
      CALL GSVOLU('TRSO','TUBE',NMED,TRSO, 3,IVOLU)
*
*  Define the TRSI     volumes
*
      NMED=MXE
      CALL GSVOLU('TRSI','TUBE',NMED,TRSI, 3,IVOLU)
*
*  Define the TRRA     volumes
*
      NMED=MTRAD
      CALL GSVOLU('TRRA','BOX ',NMED,TRRA, 3,IVOLU)
*
*   Define the TRFR    volumes
*
      NMED=MCF
      CALL GSVOLU('TRFR','BOX ',NMED,TRFR, 3,IVOLU)
*
*   Define the TRFI    volumes
*
      NMED=MN2
      CALL GSVOLU('TRFI','BOX ',NMED,TRFI, 3,IVOLU)
*
*   Define the TRDT    volumes
*
      NMED=MAL
      CALL GSVOLU('TRDT','BOX ',NMED,TRDT, 3,IVOLU)
*
* Positioning volumes TRSI     into mothers TRSO
*
      N= 1
      X= 0.
      Y= 0.
      Z= 0.
*      CALL GSPOS('TRSI',N,'TRSO',X,Y,Z,0,'ONLY')
*Positioning volumes TRSO into mothers TRSI, because now TRSO is included in
*TRSI and TRSI is included in TRBS
      CALL GSPOS('TRSO',N,'TRSI',X,Y,Z,0,'ONLY')
*
*
* Positioning volumes TRSO     into mothers TRBS. Remember we have to put
* tubes one over each other
*
      Y=0.
      NUM = 0
      DO II=1,2
#if defined(GPAMELA_UNIX)
         Z= TRSO(2) * COS(30./180.*ACOS(-1.)) * (-1)**II
#endif
#if !defined(GPAMELA_UNIX)
         Z= TRSO(2) * COSD(30.) * (-1)**II
#endif
         DO I=1, 16
            NUM = NUM + 1
            X= -TRBS(1) + II*TRSO(2) + (I-1)*2.*TRSO(2)
*            CALL GSPOS('TRSO',NUM,'TRBS',X,Y,Z,2,'ONLY')
*now TRSI is into TRBS (I don't change TRSO(2) in TRSI(2) because they
*are equal and the velue of X does not change:
            CALL GSPOS('TRSI',NUM,'TRBS',X,Y,Z,2,'ONLY')
         ENDDO
      ENDDO
*
* Positioning volumes TRFI     into mothers TRFR
*
      N= 1
      X= 0.
      Y= 0.
      Z= 0.
      CALL GSPOS('TRFI',N,'TRFR',X,Y,Z,0,'ONLY')
*
* Positioning volumes TRAI     into mothers TRAN
*
      N= 1
      X= 0.
      Y= TRAN(2)-TRAI(2)
      Z= 0.
      CALL GSPOS('TRAI',N,'TRAN',X,Y,Z,0,'ONLY')
*
* Positioning volumes TRAI, TRFR, TRBS&TRRA     into the mother TRDB
*
      NAN = 0
      Z= -TRDB(3) + TRAN(3)
      DO I = 1,2
         X = (-1)**(I-1)*TRAN(1)+ (-1)**I*TRDB(1)
         Y = -TRAN(2)+ TRDB(2)
         NAN = NAN + 1
         CALL GSPOS('TRAN',NAN,'TRDB',X,Y,Z,0,'ONLY')
         Y = +TRAN(2)- TRDB(2)
         NAN = NAN + 1
         CALL GSPOS('TRAN',NAN,'TRDB',X,Y,Z,4,'ONLY')
      ENDDO
      Y= 0.
*      Z= -TRDB(3) + TRRA(3) + GAPTRD
      NUM = 0
      M=3
      Z = Z + TRAN(3)
      DO I=1,4
         X= 0.
         Z= Z + TRFR(3)
         CALL GSPOS('TRFR',I,'TRDB',X,Y,Z,0,'ONLY')
         Z= Z + TRFR(3) + TRBS(3)
         DO II=1, M
            NUM = NUM + 1
*shift of modules to have the right overlap:
            X= (II-1)*2.*TRBS(1) - ( M*TRBS(1) - TRBS(1) ) -
     +           (II-2)*TRSI(2)
*now there two different volumes interested at same time:
*            CALL GSPOS('TRBS',NUM,'TRDB',X,Y,Z,0,'ONLY')
            CALL GSPOS('TRBS',NUM,'TRDB',X,Y,Z,0,'MANY')
         ENDDO
         DO III = 1,2
            X = (-1)**(III-1)*TRAN(1)+ (-1)**III*TRDB(1)
            Y = -TRAN(2)+ TRDB(2)
            NAN = NAN + 1
            CALL GSPOS('TRAN',NAN,'TRDB',X,Y,Z,0,'ONLY')
            Y = TRAN(2) - TRDB(2)
            NAN = NAN + 1
            CALL GSPOS('TRAN',NAN,'TRDB',X,Y,Z,4,'ONLY')
         ENDDO
         X = 0.
         Y = 0.
         Z = Z + TRSO(2)*( 1 + COS(30./180.*ACOS(-1.))) + TRRA(3)
C #          Z= Z + 2*TRSO(2) + TRRA(3)
         CALL GSPOS('TRRA',I,'TRDB',X,Y,Z,0,'ONLY')
C #          Z= Z - (2*TRSO(2) + TRRA(3)) + TRBS(3)
         Z = Z - ( TRSO(2)*( 1 + COS(30./180.*ACOS(-1.))) + TRRA(3))
     +        + TRBS(3)
      ENDDO
      M=4
      DO I=1,5
         X= 0.
         Z= Z + TRFR(3)
         CALL GSPOS('TRFR',(I+4),'TRDB',X,Y,Z,0,'ONLY')
         Z= Z + TRFR(3) + TRBS(3)
         DO II=1, M
            NUM = NUM + 1
*shift of modules to have the right overlap:
            X= (II-1)*2.*TRBS(1) - ( M*TRBS(1) - TRBS(1) )
     +           + (3/2 -(II-1))*TRSI(2)
*now there two different volumes interested at same time:
*            CALL GSPOS('TRBS',NUM,'TRDB',X,Y,Z,0,'ONLY')
            CALL GSPOS('TRBS',NUM,'TRDB',X,Y,Z,0,'MANY')
         ENDDO
         DO III = 1,2
            X = (-1)**(III-1)*TRAN(1)+ (-1)**III*TRDB(1)
            Y = -TRAN(2)+ TRDB(2)
            NAN = NAN + 1
            CALL GSPOS('TRAN',NAN,'TRDB',X,Y,Z,0,'ONLY')
            Y = TRAN(2) - TRDB(2)
            NAN = NAN + 1
            CALL GSPOS('TRAN',NAN,'TRDB',X,Y,Z,4,'ONLY')
         ENDDO
         X= 0.
         Y= 0.
         Z = Z + TRSO(2)*( 1 + COS(30./180.*ACOS(-1.))) + TRRA(3)
C #          Z= Z + 2*TRSO(2) + TRRA(3)
         CALL GSPOS('TRRA',(I+4),'TRDB',X,Y,Z,0,'ONLY')
C #          Z= Z - (2*TRSO(2) + TRRA(3)) +TRBS(3)
         Z = Z - (TRSO(2)*( 1 + COS(30./180.*ACOS(-1.))) + TRRA(3) )
     +        + TRBS(3)
      ENDDO
*
* Positioning an extra radiator plane on top
*
      Z = Z - TRBS(3) + TRSO(2)*( 1 + COS(30./180.*ACOS(-1.)))
     +     + 3*TRRA(3)
      CALL GSPOS('TRRA',NUM,'TRDB',X,Y,Z,0,'ONLY')
      Z = Z + TRBS(3) -( TRSO(2)*( 1 + COS(30./180.*ACOS(-1.)))
     +     + 3*TRRA(3) )
*
* Positioning the TOP frame
*
      X = 0.
      Y = 0.
      Z = Z + TRFR(3)
      CALL GSPOS('TRFR',10,'TRDB',X,Y,Z,0,'ONLY')
*
* Positioning the angular pieces to hold the TOF. TRAN & TRDT
*
      Z = Z + TRFR(3) + TRAN(3)
      DO I = 1,2
         X = (-1)**(I-1)*TRAN(1)+ (-1)**I*TRDB(1)
         Y = -TRAN(2)+ TRDB(2)
         NAN = NAN + 1
         CALL GSPOS('TRAN',NAN,'TRDB',X,Y,Z,0,'ONLY')
         Y = +TRAN(2)- TRDB(2)
         NAN = NAN + 1
         CALL GSPOS('TRAN',NAN,'TRDB',X,Y,Z,4,'ONLY')
      ENDDO
      Z = Z + TRAN(3) + TRDT(3)
      NDT = 0
      DO I = 1,2
         X = (-1)**(I-1)*(2*TRAN(1)-TRDT(1))+ (-1)**I*TRDB(1)
         Y = -(2*TRAN(2)-TRDT(2)) + TRDB(2)
         NDT = NDT + 1
         CALL GSPOS('TRDT',NDT,'TRDB',X,Y,Z,0,'ONLY')
         Y = +(2*TRAN(2)-TRDT(2)) - TRDB(2)
         NDT = NDT + 1
         CALL GSPOS('TRDT',NDT,'TRDB',X,Y,Z,0,'ONLY')
      ENDDO
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 28/03/2001  20.04.41  by  Marialuigia Ambriola
*CMZ :  2.02/00 09/10/2000  15.33.16  by  Francesco Cafagna
*CMZ :  2.01/01 05/04/2000  16.38.43  by  Unknown
*CMZU:  2.01/00 04/04/2000  18.51.31  by  Unknown
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 20/01/2000  17.45.30  by  Francesco Cafagna
*CMZ :  1.00/03 15/04/96  16.59.39  by  Francesco Cafagna
*CMZ :  1.00/02 15/03/96  17.47.37  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   20/12/95
      SUBROUTINE GPMED
************************************************************************
*                                                                      *
* Material definition for PAMELA                                       *
* Please note that the EPSILGP variable is set depending on the volume   *
* thickness. This is why you will find Two kind of silicon.            *
* The material parameter sign has been turned negative to let GEANT    *
* calculate them automatically besides the AUTO = 0 have been required *
*                                                                      *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 05/12/95 13.21.27                         *
*                                                                      *
************************************************************************
#include "gpkey.inc"
#include "gpmed.inc"
#include "gppmat.inc"
#include "gpmat.inc"
#include "gpgeo.inc"
#include "gcunit.inc"
*
      REAL TMAXFDREF,STEMAXREF,DEEMAXREF,STMINREF,UWBUF(NWMMAT)
*ML:
      REAL EPSILREF
*END ML.
      INTEGER NJUNK
      NJUNK = 0
      TMAXFDREF = TMAXFDGP
      STEMAXREF = STEMAXGP
      DEEMAXREF = DEEMAXGP
      STMINREF  = STMINGP
      EPSILREF  = EPSILGP
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      IF(ADEEMAX) DEEMAXGP = -DEEMAXGP
      IF(ASTMIN)  STMINGP  = -STMINGP
C
C Al, not sensitive.
C
      NJUNK = NJUNK+1
      MAL = NJUNK
      ISVOLGP = -1
*ML:
      IF(TPAL(1).GT.0.) THEN
         TMAXFDGP = TPAL(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TPAL','TPAL'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPAL(2).GT.0.) THEN
         STEMAXGP=TPAL(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TPAL','TPAL'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPAL(3).GT.0.) THEN
         DEEMAXGP=TPAL(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TPAL','TPAL'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPAL(4).GT.0.) THEN
         STMINGP=TPAL(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TPAL','TPAL'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPAL(5).GT.0.) THEN
         EPSILGP=TPAL(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TPAL','TPAL'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*ABS(SHEL(2)-SHEL(1))
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*ABS(SHEL(2)-SHEL(1))
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*END ML.
      CALL GSTMED(MAL,'ALUMINIUM         $' ,9, ISVOLGP,FFIELD,
     + FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
C
C G10, not sensitive
C
      NJUNK = NJUNK+1
      MG10 = NJUNK
      ISVOLGP = -1
*ML:
      IF(TG10(1).GT.0.) THEN
         TMAXFDGP = TG10(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TG10','TG10'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TG10(2).GT.0.) THEN
         STEMAXGP=TG10(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TG10','TG10'
            CALL GMAIL(1,0)
         ENDIF
      ELSEIF(.NOT.BSTEMAX) THEN
         STEMAXGP = 0.15
         IF(ASTEMAX) STEMAXGP = -STEMAXGP
      ENDIF
      IF(TG10(3).GT.0.) THEN
         DEEMAXGP=TG10(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TG10','TG10'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TG10(4).GT.0.) THEN
         STMINGP=TG10(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TG10','TG10'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TG10(5).GT.0.) THEN
         EPSILGP=TG10(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TG10','TG10'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.*CG10(3)
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.*CG10(3)
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*      IF(VSTEMAX.GT.0) THEN
*         STEMAXGP = VSTEMAX
*      ELSE
*         STEMAXGP = 0.15
*      ENDIF
*      IF(ASTEMAX) STEMAXGP = -STEMAXGP
*END ML.
      CALL GSTMED(MG10,'G10               $',NMG10, ISVOLGP,FFIELD,
     +FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
*ML:
*      STEMAXGP = STEMAXREF
*      IF(ASTEMAX) STEMAXGP = -STEMAXGP
*      TMAXFDGP=TMAXFDREF
*END ML.
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
C
C N2, gas, not sensitive, epsil =10 microns
C
      NJUNK = NJUNK+1
      MN2 = NJUNK
      ISVOLGP = -1
*ML:
      IF(TPN2(1).GT.0.) THEN
         TMAXFDGP = TPN2(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TPN2','TPN2'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPN2(2).GT.0.) THEN
         STEMAXGP=TPN2(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TPN2','TPN2'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPN2(3).GT.0.) THEN
         DEEMAXGP=TPN2(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TPN2','TPN2'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPN2(4).GT.0.) THEN
         STMINGP=TPN2(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TPN2','TPN2'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPN2(5).GT.0.) THEN
         EPSILGP=TPN2(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TPN2','TPN2'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*END ML.
      CALL GSTMED(MN2,'N2 GAS             $',NMN2, ISVOLGP,FFIELD,
     +FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
*ML:
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
*END ML.
C
C W, not sensitive, parameter updated following M. MAsini & M.P.De Pascale
C
      NJUNK = NJUNK+1
      MW = NJUNK
      ISVOLGP = -1
*ML:
      IF(TPW(1).GT.0.) THEN
         TMAXFDGP = TPW(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TPW','TPW'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPW(2).GT.0.) THEN
         STEMAXGP=TPW(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TPW','TPW'
            CALL GMAIL(1,0)
         ENDIF
      ELSEIF(.NOT.BSTEMAX) THEN
         STEMAXGP=0.05
         IF(ASTEMAX) STEMAXGP = -STEMAXGP
      ENDIF
      IF(TPW(3).GT.0.) THEN
         DEEMAXGP=TPW(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TPW','TPW'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPW(4).GT.0.) THEN
         STMINGP=TPW(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TPW','TPW'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPW(5).GT.0.) THEN
         EPSILGP=TPW(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TPW','TPW'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.*CAAB(3)
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.*CAAB(3)
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*      IF(VSTEMAX.GT.0) THEN
*         STEMAXGP = VSTEMAX
*      ELSE
*         STEMAXGP = 0.05
*      ENDIF
*      IF(ASTEMAX) STEMAXGP = -STEMAXGP
*END ML.
      CALL GSTMED(MW,'TUNGSTEN           $',12, ISVOLGP,FFIELD,
     + FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
*ML:
      STEMAXGP = STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
*END ML.
C
C Fe, not sensitive.
C
      NJUNK = NJUNK+1
      MMAG = NJUNK
      ISVOLGP = -1
*ML:
      IF(TPFE(1).GT.0.) THEN
         TMAXFDGP = TPFE(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TPFE','TPFE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPFE(2).GT.0.) THEN
         STEMAXGP=TPFE(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TPFE','TPFE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPFE(3).GT.0.) THEN
         DEEMAXGP=TPFE(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TPFE','TPFE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPFE(4).GT.0.) THEN
         STMINGP=TPFE(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TPFE','TPFE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPFE(5).GT.0.) THEN
         EPSILGP=TPFE(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TPFE','TPFE'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.*MGPL(3)
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.*MGPL(3)
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*END ML.
      CALL GSTMED(MMAG,'IRON               $',10,ISVOLGP,FFIELD,
     + FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
*ML:
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
*END ML.
C
C Kapton, not sensitive volume. Using scintillator for the moment
C
      NJUNK = NJUNK+1
      MKAP = NJUNK
*ML:
*      ISVOLGP = -1
      ISVOLGP = 1
*END ML.
*ML:
      IF(TPKA(1).GT.0.) THEN
         TMAXFDGP = TPKA(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TPKA','TPKA'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPKA(2).GT.0.) THEN
         STEMAXGP=TPKA(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TPKA','TPKA'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPKA(3).GT.0.) THEN
         DEEMAXGP=TPKA(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TPKA','TPKA'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPKA(4).GT.0.) THEN
         STMINGP=TPKA(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TPKA','TPKA'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPKA(5).GT.0.) THEN
         EPSILGP=TPKA(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TPKA','TPKA'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.*ABS(TRSO(2)-TRSO(1))
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.*ABS(TRSO(2)-TRSO(1))
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*END ML.
      CALL GSTMED(MKAP,'KAPTON             $',NMSCIN,ISVOLGP,FFIELD,
     + FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
*ML:
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
*END ML.
C
C TRD radiator, not sensitive volume.
C
      NJUNK = NJUNK+1
      MTRAD = NJUNK
      ISVOLGP = -1
*ML:
      IF(TRAD(1).GT.0.) THEN
         TMAXFDGP = TRAD(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TRAD','TRAD'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TRAD(2).GT.0.) THEN
         STEMAXGP=TRAD(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TRAD','TRAD'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TRAD(3).GT.0.) THEN
         DEEMAXGP=TRAD(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TRAD','TRAD'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TRAD(4).GT.0.) THEN
         STMINGP=TRAD(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TRAD','TRAD'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TRAD(5).GT.0.) THEN
         EPSILGP=TRAD(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TRAD','TRAD'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.*TRRA(3)
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.*TRRA(3)
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*END ML.
      CALL GSTMED(MTRAD,'TRD RADIATOR       $',NMTRAD,ISVOLGP,FFIELD,
     + FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
*ML:
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
*END ML.
C
C ROACELL, not sensitive volume. Using scintillator for the moment
C
      NJUNK = NJUNK+1
      MROA = NJUNK
      ISVOLGP = -1
*ML:
      IF(TPRO(1).GT.0.) THEN
         TMAXFDGP = TPRO(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TPRO','TPRO'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPRO(2).GT.0.) THEN
         STEMAXGP=TPRO(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TPRO','TPRO'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPRO(3).GT.0.) THEN
         DEEMAXGP=TPRO(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TPRO','TPRO'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPRO(4).GT.0.) THEN
         STMINGP=TPRO(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TPRO','TPRO'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPRO(5).GT.0.) THEN
         EPSILGP=TPRO(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TPRO','TPRO'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*END ML.
      CALL GSTMED(MROA,'ROACELL            $',NMSCIN,ISVOLGP,FFIELD,
     + FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
*ML:
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
*END ML.
C
C Carbon fiber, not sensitive volume. Using scintillator for the moment
C
      NJUNK = NJUNK+1
      MCF = NJUNK
      ISVOLGP = -1
*ML:
      IF(TPCF(1).GT.0.) THEN
         TMAXFDGP = TPCF(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TPCF','TPCF'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPCF(2).GT.0.) THEN
         STEMAXGP=TPCF(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TPCF','TPCF'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPCF(3).GT.0.) THEN
         DEEMAXGP=TPCF(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TPCF','TPCF'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPCF(4).GT.0.) THEN
         STMINGP=TPCF(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TPCF','TPCF'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPCF(5).GT.0.) THEN
         EPSILGP=TPCF(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TPCF','TPCF'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.*TRCP(3)
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.*TRCP(3)
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*END ML.
      CALL GSTMED(MCF,'CARBON FIBER       $',NMSCIN,ISVOLGP,FFIELD,
     + FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
*ML:
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
*END ML.
C
C Plastic scint., sensitive volume, CATB is the reference volume to calculate
C EPSILGP
C
      NJUNK = NJUNK+1
      MSCIN = NJUNK
      ISVOLGP = 1
*ML:
      IF(TPSC(1).GT.0.) THEN
         TMAXFDGP = TPSC(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TPSC','TPSC'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPSC(2).GT.0.) THEN
         STEMAXGP=TPSC(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TPSC','TPSC'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPSC(3).GT.0.) THEN
         DEEMAXGP=TPSC(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TPSC','TPSC'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPSC(4).GT.0.) THEN
         STMINGP=TPSC(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TPSC','TPSC'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPSC(5).GT.0.) THEN
         EPSILGP=TPSC(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TPSC','TPSC'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.*CATB(3)
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.*CATB(3)
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*END ML.
      CALL GSTMED(MSCIN,'SCINTILLATOR       $',NMSCIN,ISVOLGP,FFIELD,
     +FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
*ML:
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
*END ML.
C
C Silicon, sensitive volume. Si calorimeter material.
C
      NJUNK = NJUNK+1
      MSIC = NJUNK
      ISVOLGP = 1
*ML:
      IF(TSCA(1).GT.0.) THEN
         TMAXFDGP = TSCA(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TSCA','TSCA'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TSCA(2).GT.0.) THEN
         STEMAXGP=TSCA(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TSCA','TSCA'
            CALL GMAIL(1,0)
         ENDIF
      ELSEIF(.NOT.BSTEMAX) THEN
C         STEMAXGP = 0.15
         STEMAXGP = 100.
         IF(ASTEMAX) STEMAXGP = -STEMAXGP
      ENDIF
      IF(TSCA(3).GT.0.) THEN
         DEEMAXGP=TSCA(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TSCA','TSCA'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TSCA(4).GT.0.) THEN
         STMINGP=TSCA(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TSCA','TSCA'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TSCA(5).GT.0.) THEN
         EPSILGP=TSCA(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TSCA','TSCA'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.*CASI(3)
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.*CASI(3)
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*      IF(VSTEMAX.GT.0) THEN
*         STEMAXGP = VSTEMAX
*      ELSE
*         STEMAXGP = 0.15
*      ENDIF
*      IF(ASTEMAX) STEMAXGP = -STEMAXGP
*END ML.
      UWBUF(1) = D2SICA
*ML:
*END ML.
      CALL GSTMED(MSIC,'SICALO             $',NMSICA,ISVOLGP,FFIELD,
     +FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,UWBUF,1)
*ML:
      STEMAXGP = STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
*END ML.
C
C Silicon, sensitive volume. Si Tracker material.
C
      NJUNK = NJUNK+1
      MSIT = NJUNK
      ISVOLGP = 1
*ML:
*      PRINT*,'STAMPO TSTR',TSTR(1),TSTR(2),TSTR(3),TSTR(4),TSTR(5)
      IF(TSTR(1).GT.0.) THEN
         TMAXFDGP = TSTR(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TSTR','TSTR'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TSTR(2).GT.0.) THEN
         STEMAXGP=TSTR(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TSTR','TSTR'
            CALL GMAIL(1,0)
         ENDIF
      ELSEIF(.NOT.BSTEMAX) THEN
         STEMAXGP = 0.015
         IF(ASTEMAX) STEMAXGP = -STEMAXGP
      ENDIF
      IF(TSTR(3).GT.0.) THEN
         DEEMAXGP=TSTR(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TSTR','TSTR'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TSTR(4).GT.0.) THEN
         STMINGP=TSTR(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TSTR','TSTR'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TSTR(5).GT.0.) THEN
         EPSILGP=TSTR(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TSTR','TSTR'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.*TSPA(3)
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.*TSPA(3)
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*      IF(VSTEMAX.GT.0) THEN
*         STEMAXGP = VSTEMAX
*      ELSE
*         STEMAXGP = 0.015
*      ENDIF
*      IF(ASTEMAX) STEMAXGP = -STEMAXGP
*END ML.
      UWBUF(1) = D2SITR
*ML:
*      PRINT*,'SI TRACKER',TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP
*END ML.
      CALL GSTMED(MSIT,'SITRACKER          $',NMSITR,ISVOLGP,FFIELD,
     +FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,UWBUF,1)
*ML:
      STEMAXGP = STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
*END ML.
C
C Xenon, sensitive volume.
C
      NJUNK = NJUNK+1
      MXE = NJUNK
      ISVOLGP = 1
*ML:
      IF(TPXE(1).GT.0.) THEN
         TMAXFDGP = TPXE(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TPXE','TPXE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPXE(2).GT.0.) THEN
         STEMAXGP=TPXE(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TPXE','TPXE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPXE(3).GT.0.) THEN
         DEEMAXGP=TPXE(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TPXE','TPXE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPXE(4).GT.0.) THEN
         STMINGP=TPXE(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TPXE','TPXE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPXE(5).GT.0.) THEN
         EPSILGP=TPXE(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TPXE','TPXE'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*ABS(TRSI(2)-TRSI(1))
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*ABS(TRSI(2)-TRSI(1))
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*END ML.
      CALL GSTMED(MXE,'XENON              $',NMXE,ISVOLGP,FFIELD,
     + FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
*ML:
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
*END ML.
C
C Aerogel, sensitive volume. Using scintillator for the moment
C
      NJUNK = NJUNK+1
      MAER = NJUNK
      ISVOLGP = 1
*ML:
      IF(TPAE(1).GT.0.) THEN
         TMAXFDGP = TPAE(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TPAE','TPAE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPAE(2).GT.0.) THEN
         STEMAXGP=TPAE(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TPAE','TPAE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPAE(3).GT.0.) THEN
         DEEMAXGP=TPAE(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TPAE','TPAE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPAE(4).GT.0.) THEN
         STMINGP=TPAE(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TPAE','TPAE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPAE(5).GT.0.) THEN
         EPSILGP=TPAE(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TPAE','TPAE'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*END ML.
      CALL GSTMED(MAER,'AEROGEL            $',NMAER,ISVOLGP,FFIELD,
     + FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
*ML:
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
*END ML.
*EM:
C
C W, not sensitive, parameter updated following Mirko
C
      NJUNK = NJUNK+1
      MW2 = NJUNK
      ISVOLGP = -1
      IF(TPW2(1).GT.0.) THEN
         TMAXFDGP = TPW2(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TPW2','TPW2'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPW2(2).GT.0.) THEN
         STEMAXGP=TPW2(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TPW2','TPW2'
            CALL GMAIL(1,0)
         ENDIF
      ELSEIF(.NOT.BSTEMAX) THEN
         STEMAXGP=100.
         IF(ASTEMAX) STEMAXGP = -STEMAXGP
      ENDIF
      IF(TPW2(3).GT.0.) THEN
         DEEMAXGP=TPW2(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TPW2','TPW2'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPW2(4).GT.0.) THEN
         STMINGP=TPW2(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TPW2','TPW2'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPW2(5).GT.0.) THEN
         EPSILGP=TPW2(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TPW2','TPW2'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.*CAAB(3)
      ENDIF
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.*CAAB(3)
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*      IF(VSTEMAX.GT.0) THEN
*         STEMAXGP = VSTEMAX
*      ELSE
*C         STEMAXGP = 0.05
*         STEMAXGP = 100.
*      ENDIF
*      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      CALL GSTMED(MW2,'TUNGA              $',NMWCAL, ISVOLGP,FFIELD,
     + FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
      STEMAXGP = STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
C
C KAOLINITE, not sensitive, parameter updated following Mirko
C
      NJUNK = NJUNK+1
      MCER = NJUNK
      ISVOLGP = -1
      IF(TPCE(1).GT.0.) THEN
         TMAXFDGP = TPCE(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','TPCE','TPCE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPCE(2).GT.0.) THEN
         STEMAXGP=TPCE(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','TPCE','TPCE'
            CALL GMAIL(1,0)
         ENDIF
      ELSEIF(.NOT.BSTEMAX) THEN
         STEMAXGP=100.
         IF(ASTEMAX) STEMAXGP = -STEMAXGP
      ENDIF
      IF(TPCE(3).GT.0.) THEN
         DEEMAXGP=TPCE(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','TPCE','TPCE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPCE(4).GT.0.) THEN
         STMINGP=TPCE(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','TPCE','TPCE'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(TPCE(5).GT.0.) THEN
         EPSILGP=TPCE(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','TPCE','TPCE'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.*CAKA(3)
      ENDIF
C
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.*CAKA(3)
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*      IF(VSTEMAX.GT.0) THEN
*         STEMAXGP = VSTEMAX
*      ELSE
*         STEMAXGP = 100.
*      ENDIF
*      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      CALL GSTMED(MCER,'KAOLINITE          $',NMCERA, ISVOLGP,FFIELD,
     + FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
      STEMAXGP = STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
C
C G10C for calorimeter , not sensitive
C
      NJUNK = NJUNK+1
      MG10C = NJUNK
      ISVOLGP = -1
      IF(T10C(1).GT.0.) THEN
         TMAXFDGP = T10C(1)
         IF(BTMAXFD) THEN
            WRITE(CHMAIL,10000) 'TMAX','T10C','T10C'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(T10C(2).GT.0.) THEN
         STEMAXGP=T10C(2)
         IF(BSTEMAX) THEN
            WRITE(CHMAIL,10000) 'STMA','T10C','T10C'
            CALL GMAIL(1,0)
         ENDIF
      ELSEIF(.NOT.BSTEMAX) THEN
         STEMAXGP=100.
         IF(ASTEMAX) STEMAXGP = -STEMAXGP
      ENDIF
      IF(T10C(3).GT.0.) THEN
         DEEMAXGP=T10C(3)
         IF(BDEEMAX) THEN
            WRITE(CHMAIL,10000) 'DEEM','T10C','T10C'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(T10C(4).GT.0.) THEN
         STMINGP=T10C(4)
         IF(BSTMIN) THEN
            WRITE(CHMAIL,10000) 'STMI','T10C','T10C'
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
      IF(T10C(5).GT.0.) THEN
         EPSILGP=T10C(5)
         IF(BEPSIL) THEN
            WRITE(CHMAIL,10000) 'EPSI','T10C','T10C'
         ENDIF
      ELSEIF(.NOT.BEPSIL.OR.AEPSIL) THEN
         EPSILGP = 0.01*2.*C10C(3)
      ENDIF
*
*      IF(VEPSIL.GT.0) THEN
*         EPSILGP = VEPSIL
*      ELSE
*         EPSILGP = 0.01*2.*C10C(3)
*      ENDIF
*      IF(AEPSIL) EPSILGP = -EPSILGP
*      IF(VSTEMAX.GT.0) THEN
*         STEMAXGP = VSTEMAX
*      ELSE
*         STEMAXGP = 0.15
*      ENDIF
*      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      CALL GSTMED(MG10C,'G10C              $',NMG10C, ISVOLGP,FFIELD,
     +FIELDMGP,TMAXFDGP,STEMAXGP,DEEMAXGP,EPSILGP,STMINGP,0,0)
      STEMAXGP = STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      TMAXFDGP=TMAXFDREF
      IF(ATMAXFD) TMAXFDGP = -TMAXFDGP
      STEMAXGP=STEMAXREF
      IF(ASTEMAX) STEMAXGP = -STEMAXGP
      DEEMAXGP=DEEMAXREF
      IF(ADEEMAX) DEEMAXGP = - DEEMAXGP
      STMINGP=STMINREF
      IF(ASTMIN) STMINGP = -STMINGP
      EPSILGP=EPSILREF
*END EM.
C
C User action
C
      CALL GPUMED
C
*ML:
10000 FORMAT('Error in GPMED: data cards ',A4,' and ',A4,
     +    ' enabled at the same time. ',A4,' has been considered.')
*END ML.
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.03/00 31/10/2000  10.57.01  by  Francesco Cafagna
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 29/02/2000  10.23.24  by  Francesco Cafagna
*CMZ :  1.02/00 08/02/2000  21.29.53  by  Francesco Cafagna
*CMZ :  1.00/02 04/04/96  16.47.16  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   21/02/96
      SUBROUTINE GPUCAL(IACT,IS,ID,IPA,IT,DELOSS,PATH,
     +                  TRAPAR,NUMVOL,IMEC)
************************************************************************
*                                                                      *
* To collect and store the hit structure for CAL                       *
*                                                                      *
* Variables definition:                                                *
* IN:                                                                  *
*  IACT, integer specifing the action to be taken. It is the INWVOL    *
*        variable in GCTRAK common                                     *
*  IS    , set number                                                  *
*  ID    , detector number                                             *
*  IPA   , particle number                                             *
*  IT    , track number                                                *
*  DELOSS, energy loss in the step                                     *
*  PATH  , current track lenght                                        *
*  TRAPAR, track parameter, is the VECT vector in GCTRAK common        *
*  NUMVOL, integer array of numbers identifying the DETECTOR           *
*  IMEC  , integer indicating the LOSS mecanism position inside NMEC   *
*          vector, zero if not present                                 *
*                                                                      *
*                                                                      *
* NOTE: The IT variable is overwritten and the GSCHIT is used          *
*       to account for the multi-tracks produced in an e.m. shower     *
*                                                                      *
* Called by: GUSTEP                                                    *
* Author: Francesco Cafagna, 21/02/96 16.13.51                         *
*                                                                      *
************************************************************************
#include "gphit.inc"
#include "gcunit.inc"
*EM:
      PARAMETER (CALIB=0.0001085200)
*END EM.
      INTEGER IACT,IS,ID,IPA,IT,NUMVOL(20),IMEC,IDHIT
      REAL DELOSS,PATH,TRAPAR(7),VHIT(NHCAL),XYZM(3),XYZD(3)
      REAL DELTA2,SIGMA2,SIGMA,GRNDM0,GPGAUS,PATHINI
      LOGICAL SAVE
*
* Track is inside a volume
*
      IF(IACT.EQ.0) THEN
         IF(IMEC.GT.0) THEN
            SAVE = .TRUE.
*EM:
            VHIT(4) = (DELOSS/CALIB) + VHIT(4)
*            VHIT(4) = DELOSS + VHIT(4)
*END EM
         ENDIF
      ENDIF
*
* Entering a new volume or is a new track
*
      IF(IACT.EQ.1) THEN
         SAVE = .FALSE.
         CALL VZERO(VHIT,NHCAL)
         DO I=1,3
            VHIT(I) = TRAPAR(I)
         ENDDO
         IF(IMEC.GT.0) THEN
            SAVE = .TRUE.
*EM:
            VHIT(4) = DELOSS/CALIB
*            VHIT(4) = DELOSS
*END EM
         ENDIF
         IDHIT = -1
* Store the particle and momentum if is the first track
c         IF(IT.EQ.1) THEN
c            VHIT(5) = IPA
c            VHIT(6) = TRAPAR(7)
c         ENDIF
         PATHINI = PATH
      ENDIF
*
* Track is exiting current volume
*
      IF(IACT.EQ.2) THEN
         IF(IMEC.GT.0) THEN
            SAVE = .TRUE.
*EM:
            VHIT(4) = (DELOSS/CALIB) + VHIT(4)
*            VHIT(4) = DELOSS + VHIT(4)
*END EM
         ENDIF
#if defined(GPAMELA_NOGFLUCT)
*
* change in de/dx with gaussian convolution
* see Hall paper: NIM 220 (1984) 356.
*
* FIRST: Look if the STOP mechanism is present
*
         IF(IMEC.EQ.1) THEN
* This particle has NOT been stopped. So gaussian energy spread...
* Delta is in GeV^2/cm
            DELTA2=.5E-8
            SIGMA2=DELTA2*(PATH - PATHINI)
            SIGMA=SQRT(SIGMA2)
            GRNDM0 = GPGAUS(0.)
*EM:
            VHIT(4)=VHIT(4)+GRNDM0*SIGMA/CALIB
c            VHIT(4)=VHIT(4)+GRNDM0*SIGMA
*END EM
            IF(VHIT(4).LT.0.) VHIT(4)=0.
         ENDIF
#endif
*
* Store the hit
*
         IF(IDHIT.EQ.-1) THEN
*ML:
*            IF(SAVE) CALL GSCHIT (IS,ID,1,NUMVOL,VHIT,4,IDHIT)
            IF(SAVE) CALL GSCHIT (IS,ID,1,NUMVOL,VHIT,1,IDHIT)
*END ML.
            IF (IDHIT.EQ.0) THEN
               WRITE(CHMAIL,10000) IS,ID,IT
               CALL GMAIL(1,0)
            ENDIF
         ELSE
            WRITE(CHMAIL,10100) IS,ID,IT
            CALL GMAIL(1,0)
         ENDIF
      ENDIF
*
* Track is exiting the set up
*
      IF(IACT.EQ.3) THEN
*
* Check if the hit have been previously stored or not
*
         IF(IDHIT.LT.0) THEN
            IF(IMEC.GT.0) THEN
               SAVE = .TRUE.
*EM:
               VHIT(4) = (DELOSS/CALIB) + VHIT(4)
c               VHIT(4) = DELOSS + VHIT(4)
*END EM
            ENDIF
#if defined(GPAMELA_NOGFLUCT)
*
* change in de/dx with gaussian convolution
* see Hall paper: NIM 220 (1984) 356.
*
* FIRST: Look if the STOP mechanism is present
*
            IF(IMEC.EQ.1) THEN
* This particle has NOT been stopped. So gaussian energy spread...
* Delta is in GeV^2/cm
               DELTA2=.5E-8
               SIGMA2=DELTA2*(PATH - PATHINI)
               SIGMA=SQRT(SIGMA2)
               GRNDM0 = GPGAUS(0.)
*EM:
               VHIT(4)=VHIT(4)+GRNDM0*SIGMA/CALIB
c               VHIT(4)=VHIT(4)+GRNDM0*SIGMA
*END EM.
               IF(VHIT(4).LT.0.) VHIT(4)=0.
            ENDIF
#endif
*
* Store the hit
*
            IF(IDHIT.EQ.-1) THEN
*ML
*               IF (SAVE) CALL GSCHIT (IS,ID,1,NUMVOL,VHIT,4,IDHIT)
               IF (SAVE) CALL GSCHIT (IS,ID,1,NUMVOL,VHIT,1,IDHIT)
*END ML.
               IF (IDHIT.EQ.0) THEN
                  WRITE(CHMAIL,10200) IS,ID,IT
                  CALL GMAIL(1,0)
               ENDIF
            ELSE
               WRITE(CHMAIL,10300) IS,ID,IT
               CALL GMAIL(1,0)
            ENDIF
         ENDIF
      ENDIF
10000 FORMAT(' GPUCAL error: HIT have not be stored for SET='
     +       ,I4,', DET=',I4,', TRACK=',I6)
10100 FORMAT(' GPUCAL error: HIT have not be initialized for SET='
     +       ,I4,', DET=',I4,', TRACK=',I6)
10200 FORMAT(' GPUCAL error: HIT have not be stored for SET='
     +       ,I4,', DET=',I4,', TRACK=',I6)
10300 FORMAT(' GPUCAL error: HIT have not be initialized for SET='
     +       ,I4,', DET=',I4,', TRACK=',I6)
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.06  by  Francesco Cafagna
*CMZ :  1.02/00 19/01/2000  15.50.14  by  Francesco Cafagna
*CMZ :  1.01/00 16/05/96  17.38.13  by  Francesco Cafagna
*CMZ :  1.00/02 27/03/96  18.35.42  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   23/02/96
      SUBROUTINE GPDSPE
************************************************************************
*                                                                      *
* To perform SPE digitization                                          *
*                                                                      *
* Called by: GUDIGI                                                    *
* Author: Francesco Cafagna, 23/02/96 12.50.38                         *
*                                                                      *
************************************************************************
#include "gcunit.inc"
#include "gpphit.inc"
      PARAMETER (NH=NHSPE,NHM=NHMSPE,NVOL=4)
#include "gppdigi.inc"
c +SEQ,GPDSPE.
#include "gprhit.inc"
#include "gpspe.inc"
#include "gpsed.inc"
*
      INTEGER IS,ID,NV,NVM,GPNHIT,NTHIT,NHFRST
      CHARACTER*4 CSET
      LOGICAL CONT,HF
*
* Data block for digitalization
*
      INTEGER NTRA,IDIG,LTRA,NPLANE,LKDN,NTDIGI,JJ
      INTEGER KDIGI(4),NUMBVD(NVOL)
      REAL XI,YI,XO,YO,PATH,DE,GPGAUS
*
      DATA NTRA,LTRA/1,1/
*
*
* Vector zeroed
*
      CALL VZERO(ITRPB ,NHM)
      CALL VZERO(ITRSL ,NHM)
      CALL VZERO(ITSPA ,NHM)
      CALL VZERO(XTSPA,NHM)
      CALL VZERO(YTSPA,NHM)
      CALL VZERO(ZTSPA,NHM)
      CALL VZERO(XOTSPA,NHM)
      CALL VZERO(YOTSPA,NHM)
      CALL VZERO(ZOTSPA,NHM)
      CALL VZERO(ERTSPA,NHM)
      CALL VZERO(PATSPA,NHM)
      CALL VZERO(NUMD  ,NVOL)
      CALL VZERO(NDPLAN,NDMSPE)
      CALL VZERO(NDSIL ,NDMSPE)
      CALL VZERO(NDISTR,NDMSPE)
      CALL VZERO(NDIADC,NDMSPE)
*
      CONT = .FALSE.
      HF   = .TRUE.
      NTDIGI = 0
      NDISPE = 0
      NV = NVOL
      NVM= NVMAX
      IS   = ISSPE
      ID   = IDTSPA
      CSET = 'SPE '
      IT = -1
*
* Get the total number of hits stored for TSPA detector
*
      NTHIT = GPNHIT(CSET,CNSED(IS,ID) )
      IF (NTHIT.GT.NHM) CONT=.TRUE.
*
* Check on the volume level
*
      IF (NV.GT.NVM) THEN
         WRITE(CHMAIL,10000) CSET,CNSED(IS,ID),NVOL,NVMAX,
     +                        IDRUN,IDEVT
         CALL GMAIL(1,0)
         GO TO 20
      ENDIF
      CALL VZERO(VHITS,NH*NHM)
      CALL VZERO(ITRA ,NHM)
      CALL VZERO(NUMBV,NVOL*NHM)
      NHITS = -1
      NHFRST = 1
      LKDN = 0
   10 CALL GPRHIT(CSET,CNSED(IS,ID),IS,ID,NVOL,NH,NHM,NHFRST,
     +            IT,NUMD,ITRA,NUMBV,VHITS,NHITS)
*
* If there was a problem in GPRHIT then exit
*
      IF(NHITS.LT.0.AND.(NHITS.NE.-(NHM+1)) ) THEN
         WRITE(CHMAIL,10100) CSET,CNSED(IS,ID),NHITS,NHM,
     +                        IDRUN,IDEVT
         CALL GMAIL(1,0)
         GO TO 20
      ENDIF
      IF( NHITS.EQ. -(NHM+1) ) NHITS = NHM
*
* Fill CWN entuple
*
      NTHSPE = NHITS
      DO I=1,NHITS
         ITRPB(I)   = NUMBV(1,I)
         ITRSL(I)   = NUMBV(3,I)
         ITSPA(I)   = NUMBV(4,I)
#if defined(GPAMELA_INTER)
         XAVSPE(I) = VHITS(1,I)
         YAVSPE(I) = VHITS(2,I)
         ZAVSPE(I) = VHITS(3,I)
         XOUTSPE(I) = VHITS(4,I)
         YOUTSPE(I) = VHITS(5,I)
         ZOUTSPE(I) = VHITS(6,I)
         XINSPE(I) = 2*XAVSPE(I) - XOUTSPE(I)
         YINSPE(I) = 2*YAVSPE(I) - YOUTSPE(I)
         ZINSPE(I) = 2*ZAVSPE(I) - ZOUTSPE(I)
#endif
#if !defined(GPAMELA_INTER)
         XINSPE(I) = VHITS(1,I)
         YINSPE(I) = VHITS(2,I)
         ZINSPE(I) = VHITS(3,I)
         XOUTSPE(I) = VHITS(4,I)
         YOUTSPE(I) = VHITS(5,I)
         ZOUTSPE(I) = VHITS(6,I)
         XAVSPE(I) = (XINSPE(I)+XOUTSPE(I))/2.
         YAVSPE(I) = (YINSPE(I)+YOUTSPE(I))/2.
         ZAVSPE(I) = (ZINSPE(I)+ZOUTSPE(I))/2.
#endif
         ERELSPE(I) = VHITS(7,I)
         PATHSPE(I) = VHITS(8,I)
         IPARSPE(I) = VHITS(9,I)
         P0SPE (I) = VHITS(10,I)
      ENDDO
*
* Loop on the hits retrived to fill the CWN common and the DIGI bank
*
C fc       IF (HF) NTHSPE = NHITS
C fc       DO I=1,NHITS
C fc *
C fc * Start DIGI action
C fc *
C fc          NPLANE=NUMBV(3,I)
C fc          XI=VHITS(1,I)
C fc          YI=VHITS(2,I)
C fc          ZI=VHITS(3,I)
C fc          XO=VHITS(4,I)
C fc          YO=VHITS(5,I)
C fc          ZO=VHITS(6,I)
C fc +SELF,IF=INTER
C fc * interactive case: we need the track edges
C fc          XI=2.*XI-XO
C fc          YI=2.*YI-YO
C fc          ZI=2.*ZI-ZO
C fc +SELF.
C fc          PATH=VHITS(8,I)
C fc          DE=VHITS(7,I)
C fc          IF(DE.GT.0.) THEN
C fc             DO J=1,6
C fc                NUMBVD(J)=NUMBV(J,I)
C fc             ENDDO
C fc c+SELF,IF=PAOLO
C fc c            CALL GPSPEHD(I,NPLANE,XI,YI,ZI,XO,YO,ZO,PATH,DE,LKDN)
C fc c+SELF
C fc c+SELF,IF=-PAOLO
C fc c            CALL GPSPEHD(I,NUMBVD,NVSPE,XI,YI,ZI,XO,YO,ZO,PATH,DE,LKDN)
C fc c+SELF.
C fc             NTDIGI = LKDN
C fc          ENDIF
C fc *
C fc * Fill CWN common
C fc *
C fc          IF(HF) THEN
C fc             ITRPB(I) = NUMBV((NVSPE-3),I)
C fc             ITRSL(I) = NUMBV((NVSPE-1),I)
C fc             ITSPA(I) = NUMBV(NVSPE,I)
C fc             XTSPA(I) = VHITS(1,I)
C fc             YTSPA(I) = VHITS(2,I)
C fc             ZTSPA(I) = VHITS(3,I)
C fc             XOTSPA(I) = VHITS(4,I)
C fc             YOTSPA(I) = VHITS(5,I)
C fc             ZOTSPA(I) = VHITS(6,I)
C fc             ERTSPA(I) = VHITS(7,I)
C fc             PATSPA(I) = VHITS(8,I)
C fc          ENDIF
C fc          IF(CONT) HF = .FALSE.
C fc       ENDDO
C fc       IF(CONT) THEN
C fc          NHFRST = NHFRST + NHM
C fc          IF( (NTHIT-NHFRST).LE.NHM) CONT=.FALSE.
C fc          GO TO 10
C fc       ENDIF
C fc *
C fc * fill digits with noise included
C fc *
C fc       IF(LKDN.GE.1) THEN
C fc          DO II=1,LKDN
C fc * plane=0 if the signal is lesser than 1 ADC
C fc             IF(INT(RLKD4(II)*ADCX).LE.0.AND.LKD2(II).GE.1.
C fc      +      AND.LKD2(II).LE.3) LKD1(II)=0
C fc             IF(INT(RLKD4(II)*ADCY).LE.0.AND.LKD2(II).GE.4.
C fc      +      AND.LKD2(II).LE.5) LKD1(II)=0
C fc *
C fc             JJ=LKDH(II)+(NHFRST-1)
C fc *            KDIGI(1)=LKD1(II)
C fc *            KDIGI(2)=LKD2(II)
C fc             KDIGI(1)=LKD2(II)
C fc             KDIGI(2)=LKD3(II)
C fc *            R1=RAN(IR)
C fc *            R2=RAN(IR)
C fc *            GRNDM0=SIN(2.*3.14159*R1)*SQRT(-2.*LOG(R2))
C fc             GRNDM0 = GPGAUS(0.)
C fc             IF(LKD2(II).GE.1.AND.LKD2(II).LE.3) THEN
C fc                RLKD4(II)=RLKD4(II)+GRNDM0*ENOISX+PIEDX
C fc                KDIGI(3)=INT(RLKD4(II)*ADCX)
C fc             ENDIF
C fc             IF(LKD2(II).GE.4.AND.LKD2(II).LE.5) THEN
C fc                RLKD4(II)=RLKD4(II)+GRNDM0*ENOISY+PIEDY
C fc                KDIGI(3)=INT(RLKD4(II)*ADCY)
C fc             ENDIF
C fc C+SELF,IF=PAOLO
C fc             DO J=1,NVOL
C fc                NUMBVD(J)=NUMBV(J,JJ)
C fc             ENDDO
C fc C+SELF
C fc             LTRA=ITRA(JJ)
C fc             IF(KDIGI(3).LT.0) KDIGI(3)=0
C fc             IF(KDIGI(3).GE.1024) KDIGI(3)=1023
C fc             IF(KDIGI(3).GT.0.AND.LKD1(II).GT.0) THEN
C fc                CALL GSDIGI(IS,ID,LTRA,NTRA,NUMBVD,KDIGI,IDIG)
C fc                IF (IDIG.EQ.0) THEN
C fc                   WRITE(CHMAIL,10200) CSET,CNSED(IS,ID),NVOL,KDIGI
C fc                   CALL GMAIL(1,0)
C fc                   GO TO 20
C fc                ENDIF
C fc             ENDIF
C fc *
C fc * Fills CWN
C fc *
C fc             IF(HF) THEN
C fc                IF(LKD2(II).GE.1.AND.LKD2(II).LE.3) KDIGIT=INT(RLKD4(II)*
C fc      +         ADCX)
C fc                IF(LKD2(II).GE.4.AND.LKD2(II).LE.5) KDIGIT=INT(RLKD4(II)*
C fc      +         ADCY)
C fc                IF(KDIGIT.GT.0.AND.LKD1(II).GT.0) THEN
C fc                   NDISPE=NDISPE+1
C fc                   IF (NDISPE.LE.NDMSPE) THEN
C fc                      NDPLAN(NDISPE)=LKD1(II)
C fc                      NDSIL (NDISPE)=LKD2(II)
C fc                      NDISTR(NDISPE)=LKD3(II)
C fc                      IF(KDIGIT.LT.1024) THEN
C fc                         NDIADC(NDISPE)=KDIGIT
C fc                      ELSE
C fc                         NDIADC(NDISPE)=1023
C fc                      ENDIF
C fc                   ENDIF
C fc                ENDIF
C fc             ENDIF
C fc          ENDDO
C fc       ENDIF
*
10000  FORMAT(' GPDSPE: VOLUME level too big: SET=',A4,', DET=',A4,',
     +        NVOL=',I3,', NVMAX=',I3,', RUN=',I5,', EVT=',I8)
10100  FORMAT(' GPDSPE: Error in GPRHIT: SET=',A4,
     +        ', DET=',A4,',NHITS=',I5,', NHMAX=',I5,
     +        ', RUN=',I5,', EVT=',I8)
10200  FORMAT(' GPDSPE: digitization ERROR: SET=',A4,', DET=',A4,',
     +        NVOL=',I3,', KDIGI=',4I4)
   20 RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.00/03 15/04/96  17.01.32  by  Francesco Cafagna
*CMZ :  1.00/02 04/04/96  17.35.45  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   04/04/96
      LOGICAL FUNCTION GPLOOK(CHAR,NVEC,NCOM)
************************************************************************
*                                                                      *
* Returns TRUE if the CHARACTER*4 string is found into the vector NVEC *
* of NCOM words                                                        *
*                                                                      *
* Variables definition:                                                *
* IN:                                                                  *
*  CHAR  , CHARACTER*4 word to be searched                             *
*  NVEC  , INTEGER vector to be searched for CHAR                      *
*  NCOM  , Number of NVEC components                                   *
*                                                                      *
* Called by: <USER>                                                    *
* Author: Francesco Cafagna, 04/04/96 17.17.32                         *
*                                                                      *
************************************************************************
      CHARACTER*4 CHAR
      INTEGER NVEC(1),NCOM,IL
      IL = 0
      GPLOOK = .FALSE.
      CALL GLOOK(CHAR,NVEC,NCOM,IL)
      IF(IL.GT.0) GPLOOK = .TRUE.
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 06/03/2000  13.07.03  by  Francesco Cafagna
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZU:  1.01/00 26/04/96  15.12.30  by  Paolo (The Magic) Papini
*-- Author :
      SUBROUTINE GUFLD(V,F)
************************************************************************
*                                                                      *
* To map Pamela magnetic field                                         *
* A bit of housekeeping: delete print statement etc. etc., by F. Caf.  *
*                                                                      *
* Variables definition:                                                *
* IN:                                                                  *
*  V , vector with coordinates in MARS                                 *
* OUT:                                                                 *
*  F , Magnetic field components along X, Y and Z                      *
*                                                                      *
* Called by: GHELIX, GRKUTA                                            *
* Author: Paolo Papini   16/02/96                                      *
*                                                                      *
************************************************************************
#include "gpfield.inc"
*
      INTEGER II,III
      REAL DISM,F0X,F0Y,F0Z,F1X,F1Y,F1Z,F2X,F2Y,F2Z,
     +     F3X,F3Y,F3Z
      REAL V(3),F(3),AV(3)
*
* Transform coordinates to Spectrometer frame
*
      CALL GPMASPE(V)
*
* Take just the absolute value for the coordinates
*
      DO I=1,3
         AV(I) = ABS( V(I) )
      ENDDO
      F(1)=0.
      F(2)=0.
      F(3)=0.
*
* Check if we are outside the map
*
      IF( (AV(1).GE.20).OR.(AV(2).GE.20).OR.(AV(3).GE.60.) )
     +    GOTO 10
      IV(1)=INT(AV(1)*2.)+1
      IV(2)=INT(AV(2)*2.)+1
      IV(3)=INT(AV(3)/2.)+1
      DO I1=0,1
         DO I2=0,1
            DO I3=0,1
               II=I1*4+I2*2+I3+1
               VV(II,1)=FLOAT(IV(1)+I1-1)*0.5
               VV(II,2)=FLOAT(IV(2)+I2-1)*0.5
               VV(II,3)=FLOAT(IV(3)+I3-1)*2.
               IVV(II,1)=IV(1)+I1
               IVV(II,2)=IV(2)+I2
               IVV(II,3)=IV(3)+I3
               DD(II)=(VV(II,1)-AV(1))**2 + (VV(II,2)-AV(2))**2 +
     +         (VV(II,3)-AV(3))**2
            ENDDO
         ENDDO
      ENDDO
* --- v0
      DISM=1.E9
      II=0
      DO I=1,8
         IF(DD(I).LT.DISM) THEN
            DISM=DD(I)
            II=I
         END IF
      END DO
      DO I=1,3
         V0(I)=VV(II,I)
      END DO
      F0X=FX(IVV(II,1),IVV(II,2),IVV(II,3))
      F0Y=FY(IVV(II,1),IVV(II,2),IVV(II,3))
      F0Z=FZ(IVV(II,1),IVV(II,2),IVV(II,3))
* --- v1
      V1(2)=V0(2)
      V1(3)=V0(3)
      IF(AV(1).GE.V0(1)) THEN
         III=IVV(II,1)+1
         V1(1)=V0(1)+0.5
      ELSE
         III=IVV(II,1)-1
         V1(1)=V0(1)-0.5
      END IF
      F1X=FX(III,IVV(II,2),IVV(II,3))
      F1Y=FY(III,IVV(II,2),IVV(II,3))
      F1Z=FZ(III,IVV(II,2),IVV(II,3))
* --- v2
      V2(1)=V0(1)
      V2(3)=V0(3)
      IF(AV(2).GE.V0(2)) THEN
         III=IVV(II,2)+1
         V2(2)=V0(2)+0.5
      ELSE
         III=IVV(II,2)-1
         V2(2)=V0(2)-0.5
      END IF
      F2X=FX(IVV(II,1),III,IVV(II,3))
      F2Y=FY(IVV(II,1),III,IVV(II,3))
      F2Z=FZ(IVV(II,1),III,IVV(II,3))
* --- v3
      V3(1)=V0(1)
      V3(2)=V0(2)
      IF(AV(3).GE.V0(3)) THEN
         III=IVV(II,3)+1
         V3(3)=V0(3)+2.
      ELSE
         III=IVV(II,3)-1
         V3(3)=V0(3)-2.
      END IF
      F3X=FX(IVV(II,1),IVV(II,2),III)
      F3Y=FY(IVV(II,1),IVV(II,2),III)
      F3Z=FZ(IVV(II,1),IVV(II,2),III)
* --- linear interpolation, magnetic field calculation
      CALL FLIN3(V0,V1,V2,V3,F0X,F1X,F2X,F3X,AV,F(1))
      CALL FLIN3(V0,V1,V2,V3,F0Y,F1Y,F2Y,F3Y,AV,F(2))
      CALL FLIN3(V0,V1,V2,V3,F0Z,F1Z,F2Z,F3Z,AV,F(3))
* --- mirroing
      IF(V(2).LT.0.) THEN
         F(1)=-1.*F(1)
         F(3)=-1.*F(3)
      END IF
      IF(V(1).LT.0.) F(1)=-1.*F(1)
      IF(V(3).LT.0.) F(3)=-1.*F(3)
*
* Transform coordinates back to MARS
*
   10 CALL GPSPEMA(V)
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 04/04/2001  15.19.56  by  Marialuigia Ambriola
*CMZ :  2.03/00 06/11/2000  01.58.14  by  Francesco Cafagna
*CMZ :  2.02/00 12/10/2000  18.37.54  by  Francesco Cafagna
*CMZU:  2.01/00 04/04/2000  17.20.52  by  Unknown
*CMZ :  2.00/00 01/03/2000  21.21.39  by  Francesco Cafagna
*CMZ :  1.02/00 31/12/99  17.53.56  by  Francesco Cafagna
*CMZ :  1.01/00 04/05/96  09.50.23  by  Francesco Cafagna
*CMZ :  1.00/03 17/04/96  17.35.58  by  Francesco Cafagna
*CMZ :  1.00/02 05/04/96  09.27.01  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   05/12/95
      SUBROUTINE GPDAT
************************************************************************
*                                                                      *
* Data initialization for PAMELA.                                      *
* Geometry parameter and general constant are definited                *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 05/12/95 13.21.27                         *
*                                                                      *
************************************************************************
#include "gclist.inc"
#include "gcflag.inc"
#include "gcunit.inc"
*
#include "gpgeo.inc"
#include "gpmed.inc"
#include "gpmat.inc"
#include "gpkey.inc"
#include "gphit.inc"
#include "gpdigi.inc"
#include "gpfield.inc"
#include "gprzfi.inc"
#include "gpunit.inc"
#include "gpal.inc"
#include "gpg10.inc"
#include "gpn2g.inc"
#include "gpw.inc"
#include "gpfe.inc"
#include "gpkap.inc"
#include "gptrad.inc"
#include "gproa.inc"
#include "gpcp.inc"
#include "gpscint.inc"
#include "gpsica.inc"
#include "gpsitr.inc"
#include "gpxe.inc"
#include "gpaer.inc"
#include "gpgene.inc"
*EM:
#include "gpce.inc"
#include "gpw2.inc"
#include "gpg10c.inc"
*END: EM.
*ML:
#include "gpaltr.inc"
*END ML.
*
      INTEGER ICP
      LOGICAL TEST,GPLOOK
      CHARACTER*4 CJUNK
*
* Data statements
*
#include "gpdgeo.inc"
#include "gpdmat.inc"
#include "gpdhit.inc"
#include "gpddigi.inc"
#include "gpdal.inc"
#include "gpdg10.inc"
#include "gpdn2g.inc"
#include "gpdw.inc"
#include "gpdfe.inc"
#include "gpdkap.inc"
#include "gpdtrad.inc"
#include "gpdroa.inc"
#include "gpdcp.inc"
#include "gpdscin.inc"
#include "gpdsica.inc"
#include "gpdsitr.inc"
#include "gpdxe.inc"
#include "gpdaer.inc"
*EM:
#include "gpdce.inc"
#include "gpdw2.inc"
#include "gpdg10c.inc"
*END: EM.
*ML:
C
C Read the attenuation lengths for the TRD from the file
C
      READ(LUTR) ENATT,ATTTRD
      CALL VZERO(EY,115)
*END ML.
C
C Set quantities from DATA cards
C
C
C Number of plane without tungsten
C
      ICP = -1
      NCANOW = 1
      DO I=1,3
         CALL UHTOC(NCAL(I),4,CJUNK,4)
         ICP = ICFIND('NOW',CJUNK,1,4)
         IF(ICP.EQ.1) NCANOW = ICDECI(CJUNK,4,4)
      ENDDO
C
C CWN booking and filling
C
      IF(HBOOK.EQ.1) THEN
         HBK = .TRUE.
      ELSE
         HBK = .FALSE.
      ENDIF
C
c Look for longer CWN-tplue selection
C
      IF(HLON.EQ.1) THEN
         HLONG = .TRUE.
      ELSE
         HLONG =.FALSE.
      ENDIF

C
C Volume to be subtracted via NDET card
C
      SPH=.NOT.GPLOOK('SPHE',NDET,8)
C
      TOF=.NOT.GPLOOK('TOF ',NDET,8)
      HTOF = .FALSE.
      IF(HBK.AND.TOF) HTOF = .TRUE.
C
      TRD=.NOT.GPLOOK('TRD ',NDET,8)
      HTRD = .FALSE.
      IF(HBK.AND.TRD) HTRD = .TRUE.
C
      CAT =.NOT.GPLOOK('CAT ',NDET,8)
      HCAT = .FALSE.
      IF(HBK.AND.CAT) HCAT = .TRUE.
C
      CAS=.NOT.GPLOOK('CAS ',NDET,8)
      HCAS = .FALSE.
      IF(HBK.AND.CAS) HCAS = .TRUE.
C
      SPE=.NOT.GPLOOK('SPE ',NDET,8)
      HSPE = .FALSE.
      IF(HBK.AND.SPE) HSPE = .TRUE.
C
      CAL=.NOT.GPLOOK('CAL ',NDET,8)
      HCAL = .FALSE.
      IF(HBK.AND.CAL) HCAL = .TRUE.
C
C E-ntple or physics disablign for single detectors
C
      IF (CAS) THEN
         CAS=.NOT.GPLOOK('NVOL',NDECAS,3)
         PCAS=.NOT.GPLOOK('NPHY',NDECAS,3)
         HCAS=.NOT.GPLOOK('NHBK',NDECAS,3)
         IF(.NOT.CAS) PCAS = .FALSE.
         IF(.NOT.PCAS)HCAS = .FALSE.
         IF(.NOT.HBK) HCAS = .FALSE.
      ELSE
         PCAS = .FALSE.
         HCAS = .FALSE.
      ENDIF
      IF (CAT) THEN
         CAT=.NOT.GPLOOK('NVOL',NDECAT,3)
         PCAT=.NOT.GPLOOK('NPHY',NDECAT,3)
         HCAT=.NOT.GPLOOK('NHBK',NDECAT,3)
         IF(.NOT.CAT) PCAT = .FALSE.
         IF(.NOT.PCAT)HCAT = .FALSE.
         IF(.NOT.HBK) HCAT = .FALSE.
      ELSE
         PCAT = .FALSE.
         HCAT = .FALSE.
      ENDIF
      IF (TOF) THEN
         TOF=.NOT.GPLOOK('NVOL',NDETOF,3)
         PTOF=.NOT.GPLOOK('NPHY',NDETOF,3)
         HTOF=.NOT.GPLOOK('NHBK',NDETOF,3)
         IF(.NOT.TOF) PTOF = .FALSE.
         IF(.NOT.PTOF)HTOF = .FALSE.
         IF(.NOT.HBK) HTOF = .FALSE.
      ELSE
         PTOF = .FALSE.
         HTOF = .FALSE.
      ENDIF
      IF (TRD) THEN
         TRD=.NOT.GPLOOK('NVOL',NDETRD,3)
         PTRD=.NOT.GPLOOK('NPHY',NDETRD,3)
         HTRD=.NOT.GPLOOK('NHBK',NDETRD,3)
         IF(.NOT.TRD) PTRD = .FALSE.
         IF(.NOT.PTRD)HTRD = .FALSE.
         IF(.NOT.HBK) HTRD = .FALSE.
      ELSE
         PTRD = .FALSE.
         HTRD = .FALSE.
      ENDIF
      IF (SPE) THEN
         SPE=.NOT.GPLOOK('NVOL',NDESPE,3)
         PSPE=.NOT.GPLOOK('NPHY',NDESPE,3)
         HSPE=.NOT.GPLOOK('NHBK',NDESPE,3)
         IF(.NOT.SPE) PSPE = .FALSE.
         IF(.NOT.PSPE)HSPE = .FALSE.
         IF(.NOT.HBK) HSPE = .FALSE.
      ELSE
         PSPE = .FALSE.
         HSPE = .FALSE.
      ENDIF
      IF (CAL) THEN
         CAL=.NOT.GPLOOK('NVOL',NDECAL,3)
         PCAL=.NOT.GPLOOK('NPHY',NDECAL,3)
         HCAL=.NOT.GPLOOK('NHBK',NDECAL,3)
         IF(.NOT.CAL) PCAL = .FALSE.
         IF(.NOT.PCAL)HCAL = .FALSE.
         IF(.NOT.HBK) HCAL = .FALSE.
      ELSE
         PCAL = .FALSE.
         HCAL = .FALSE.
      ENDIF
      IF (TS4) THEN
         TS4=.NOT.GPLOOK('NVOL',NDES4,3)
         PS4=.NOT.GPLOOK('NPHY',NDES4,3)
         HS4=.NOT.GPLOOK('NHBK',NDES4,3)
         IF(.NOT.TS4)  PS4 = .FALSE.
         IF(.NOT.PS4) HS4 = .FALSE.
         IF(.NOT.HBK) HS4 = .FALSE.
      ELSE
         PS4 = .FALSE.
         HS4 = .FALSE.
      ENDIF
*
* Look for special tracking media settings
*
      TEST =GPLOOK('AL  ',NSPTM,17)
      IF(TEST) CALL GPAL
      TEST =GPLOOK('G10 ',NSPTM,17)
      IF(TEST)  CALL GPG10
*EM:
      TEST =GPLOOK('G10C',NSPTM,17)
      IF(TEST)  CALL GPG10C
*END: EM.
      TEST =GPLOOK('N2G ',NSPTM,17)
      IF(TEST)  CALL GPN2G
      TEST =GPLOOK('W   ',NSPTM,17)
      IF(TEST)  CALL GPW
*EM:
      TEST =GPLOOK('W2  ',NSPTM,17)
      IF(TEST)  CALL GPW2
*END: EM.
      TEST =GPLOOK('FE  ',NSPTM,17)
      IF(TEST)  CALL GPFE
      TEST =GPLOOK('KAP ',NSPTM,17)
      IF(TEST)  CALL GPKAP
      TEST =GPLOOK('TRAD',NSPTM,17)
      IF(TEST)  CALL GPTRAD
      TEST =GPLOOK('ROA ',NSPTM,17)
      IF(TEST)  CALL GPROA
      TEST =GPLOOK('CP  ',NSPTM,17)
      IF(TEST)  CALL GPCP
      TEST =GPLOOK('SCIN',NSPTM,17)
      IF(TEST)  CALL GPSCINT
      TEST =GPLOOK('SICA',NSPTM,17)
      IF(TEST)  CALL GPSICA
      TEST =GPLOOK('SITR',NSPTM,17)
      IF(TEST)  CALL GPSITR
      TEST =GPLOOK('XE  ',NSPTM,17)
      IF(TEST)  CALL GPXE
*EM:
      TEST =GPLOOK('CE  ',NSPTM,17)
      IF(TEST)  CALL GPCE
*END EM.
*
* Look for parameter to be always atomaticaly calculated by GEANT
*
      ATMAXFD = GPLOOK('TMAX',NAUTMED,5)
      ASTEMAX = GPLOOK('STMA',NAUTMED,5)
      ADEEMAX = GPLOOK('DEEM',NAUTMED,5)
      AEPSIL  = GPLOOK('EPSI',NAUTMED,5)
      ASTMIN  = GPLOOK('STMI',NAUTMED,5)
*
* Look for hadronic package to be used
*
      FLUKA =GPLOOK('FLUK',NHPAK,1)
*
* Look for Gaussian straggling parameter
* Please note that is updated only if ISSTR is one !
*
      IF(ISSTR.EQ.1) THEN
         IF(SSTR(1).NE.0) D2SICA = SSTR(1)
         IF(SSTR(2).NE.0) D2SITR = SSTR(2)
      ENDIF
*
* Look for calorimeter planes to be excluded
*
      DO I=1,2*NCAPL
         IF(NCPL(I).GT.0) THEN
            IF(NCPL(I).LE.2*NCAPL) THEN
               NOCAPL(NCPL(I))=.TRUE.
            ELSE
               WRITE(CHMAIL,10100) NCPL(I)
               CALL GMAIL(1,0)
            ENDIF
         ENDIF
      ENDDO
*
* Look for calorimeter silicon detectors to be excluded
*
      DO I=1,9
         IF(NCSI(I).GT.0) THEN
            IF(NCSI(I).LE.9) THEN
               NOCASI(NCSI(I))=.TRUE.
            ELSE
               WRITE(CHMAIL,10000) NCSI(I)
               CALL GMAIL(1,0)
            ENDIF
         ENDIF
      ENDDO
*
* Look for calorimeter absorber planes to be excluded
*
      DO I=1,NCAPL
         IF(NCAB(I).GT.0) THEN
            IF(NCAB(I).LE.22) THEN
               NOCAAB(NCAB(I))=.TRUE.
            ELSE
               WRITE(CHMAIL,10200) NCAB(I)
               CALL GMAIL(1,0)
            ENDIF
         ENDIF
      ENDDO
*
* Origin of PAMELA in the MARS GEANT coordinates system
*
      XYZPOR(1) = 0.
      XYZPOR(2) = 0.
      XYZPOR(3) = 0.
C
C TOF dimensions
C
      S11X(1)=S11(1)/NS11X
      S11X(2)=S11(2)
      S11X(3)=S11(3)-2.*SCTIC
      SC11(1)=S11(1)
      SC11(2)=S11(2)
      SC11(3)=SCTIC
      S12Y(1)=S12(1)
      S12Y(2)=S12(2)/NS12Y
      S12Y(3)=S12(3)-2.*SCTIC
      SC12(1)=S12(1)
      SC12(2)=S12(2)
      SC12(3)=SCTIC
      S21X(1)=S21(1)/NS21X
      S21X(2)=S21(2)
      S21X(3)=S21(3)-2.*SCTIC
      SC21(1)=S21(1)
      SC21(2)=S21(2)
      SC21(3)=SCTIC
      S22Y(1)=S22(1)
      S22Y(2)=S22(2)/NS22Y
      S22Y(3)=S22(3)-2.*SCTIC
      SC22(1)=S22(1)
      SC22(2)=S22(2)
      SC22(3)=SCTIC
      S31Y(1)=S31(1)
      S31Y(2)=S31(2)/NS31Y
      S31Y(3)=S31(3)-2.*SCTIC
      SC31(1)=S31(1)
      SC31(2)=S31(2)
      SC31(3)=SCTIC
      S32X(1)=S32(1)/NS32X
      S32X(2)=S32(2)
      S32X(3)=S32(3)-2.*SCTIC
      SC32(1)=S32(1)
      SC32(2)=S32(2)
      SC32(3)=SCTIC
      ZS4 = ZCAL - CALS(3) - S4(3)
*
* Calculate TRD straw box dimentions add some dead space
*
C #       TRBS(1) = (16.+0.5)*TRSO(2)
C #       TRBS(2) = TRSO(3)
C # +SELF,IF=UNIX
C #       TRBS(3) = 0.246+(1+COS(30./180.*ACOS(-1.)))*TRSO(2)
C # +SELF.
C #       TRBS(3) = 0.246+(1+COSD(30.))*TRSO(2)
C # +SELF.
*
* Calculate TRD radiator thickness
*
      TRRA(3) = (TRBS(3) - (TRSO(2)*( 1 + COS(30./180.*ACOS(-1.))))) +
     +           TRFR(3)
*
* Calculate TRD virtual box dimensions
*
      TRDB(1) = TRFR(1)
      TRDB(2) = TRFR(2)
*      TRDB(3) = 9*TRBS(3) + 9*TRFR(3) + 2* TRAN(3) + TRDT(3)
      TRDB(3) = 10*TRFR(3) + 11* TRAN(3) + TRDT(3)
*
* Calculate the silicon ladder and spectrometer plane dimensions
*
      TRSL(1) = TSPA(1) + 2.*TRCP(1)
      TRSL(3) = TRCP(3)
      TRPL(1) = TRSL(1)*NTRSL
*
* Calculate spectrometer box Z dimentions
*
      SPEB(3) = 5.*MGPL(3) + 6.*TRPL(3)
*
* Calculate the calorimeter planes dimentions, both for actual and dummy planes
*
C fc mod by caf on 20-10-1999
C      CAPL(3) = ((2.*CALB(3)/NCAPL - 2*CAAB(3))/2.)/2.
C end of mod
*EM:
c      CAPL(3) = (2.*CG10(3) + 2*CASI(3) + DCASIZ/2. )/2.
      CAPL(3) = (DCASIZ/2. + 2*CASI(3) + 2.*CAKP(3) +
     + 2.*CAGL(3)+ 2.*C10C(3) + 2*CAKA(3))/2.
      CAPD(3) = CAPL(3)
C
C We have repectively: N2, Si, Kapton, Glue, G10C, Kaolinite
C
*END EM.
      CASIOFF = (2.*CASI(1) - CALSTWID*NCASTR)/2. - CASI(1)
*
* Calculate the inner shell dimentions and the TOP shell maximum theta angle
* The inner shel is two centimeters from the external and 1 mm thick
*
      SHEI(2) = SHEL(2) - 2.
      SHEI(1) = SHEI(2) - .1
      TSPH(1) = TSPH(2) - .25
#if defined(GPAMELA_UNIX)
      TSPH(4) = ASIN(SHEL(2)/TSPH(2)) * 180./ACOS(-1.)
#endif
#if !defined(GPAMELA_UNIX)
      TSPH(4) = ASIND(SHEL(2)/TSPH(2))
#endif
*
* Quote definition for the main volumes
*
* Note that the quote are in PAMELA System of reference. They are transformed
* in GEANT coordinates system
*
*EM:
C      ZCAS = ZSPEC
*END EM.
*
* The shells heights are the same of the TRD height
*
      SHEL(3) = (ZTRD + TRDB(3) +PAME(3) )/2.
*
* Add user defined hieght to the external shell
*
      SHEL(3) = SHEL(3) + DZSH
      SHEI(3) = SHEL(3)
      ZSHEL = SHEL(3) - PAME(3)
      ZSHEI = SHEI(3) - PAME(3)
      ZTFLA = ZSHEL + SHEL(3) + TFLA(3)
#if defined(GPAMELA_UNIX)
      ZTSPH = (2.*SHEI(3)-PAME(3))-TSPH(2)*COS(TSPH(4)/180.*ACOS(-1.))
#endif
#if !defined(GPAMELA_UNIX)
      ZTSPH = (2.*SHEI(3)-PAME(3)) - TSPH(2) * COSD(TSPH(4))
#endif
*
* Origin of the spectrometer in the MARS GEANT coordinates system
*
      XYZSOR(1) = 0.
      XYZSOR(2) = 0.
      XYZSOR(3) = ZSPEC
*
* Calculate generation surface & quote based on the S11 dimentions
*
      IF(XYZGEN(1).NE.-1111) THEN
         XGEN = XYZGEN(1)
      ELSE
         XGEN = -S11(1)
      ENDIF
      IF(XYZGEN(2).NE.-1111) THEN
         YGEN = XYZGEN(2)
      ELSE
         YGEN = -S11(2)
      ENDIF
      IF(XYZGEN(3).NE.-1111) THEN
         ZGEN = XYZGEN(3)
      ELSE
         ZGEN = ZS11 + 2.
      ENDIF
      IF(XYZGEN(4).NE.-1111) THEN
         XDGEN = XYZGEN(4)
      ELSE
         XDGEN = 2.*S11(1)
      ENDIF
      IF(XYZGEN(5).NE.-1111) THEN
         YDGEN = XYZGEN(5)
      ELSE
         YDGEN= 2.*S11(2)
      ENDIF
C
C Set max and min generation angles
C
      THMIN = THGEN(1)
      THMAX = THGEN(2)
      PHMIN = PHGEN(1)
      PHMAX = PHGEN(2)
C
C Tracking media parameters. These have been set following M. Boezio
C suggestions, to be optimized for silicon detectors simulation
*ML:
C The EPSILGP variable will be set in GPMED routine.
* The EPSILGP variable is set now and, if it is the case, it is modified
* in GPMED routine.
*ML.
C The FFIELD variable is passed by a DATA CARD
C
      FIELDMGP = 40.
      IF(VTMAXFD.GT.0.) THEN
         TMAXFDGP = VTMAXFD
*ML:
         BTMAXFD = .TRUE.
*END ML.
      ELSE
         TMAXFDGP = 1.
      ENDIF
      IF(VSTEMAX.GT.0.) THEN
         STEMAXGP = VSTEMAX
*ML:
         BSTEMAX = .TRUE.
*END ML.
      ELSE
         STEMAXGP = 0.05
      ENDIF
      IF(VDEEMAX.GT.0.) THEN
         DEEMAXGP = VDEEMAX
*ML:
         BDEEMAX = .TRUE.
*END ML.
      ELSE
         DEEMAXGP = 0.05
      ENDIF
      IF(VSTMIN.GT.0.) THEN
         STMINGP = VSTMIN
*ML:
         BSTMIN = .TRUE.
*END ML.
      ELSE
         STMINGP = 0.0005
      ENDIF
*ML:
      IF(VEPSIL.GT.0.) THEN
         EPSILGP = VEPSIL
         BEPSIL = .TRUE.
      ENDIF
*END ML.
C
C Read magnetic field map
C
      IF (FFIELD.EQ.1) THEN
C fc          DO IX=1,41
C fc             DO IY=1,41
C fc                DO IZ=1,31
C fc                   READ(LUFMAP,ERR=10) FX(IX,IY,IZ),FY(IX,IY,IZ),
C fc      +                                FZ(IX,IY,IZ)
C fc                END DO
C fc             END DO
C fc          END DO
C fc    10    PRINT*,'ERROR READING MAP FILE',IX,IY,IZ
         CALL HCDIR('//FIELD',' ')
         CALL HRIN(30,9999,0)
         CALL HPRNT(30)
         CALL HBNAME(30,' ',0,'$CLEAR')
         CALL HBNAME(30,'FIELD',F,'$SET')
         CALL HNOENT(30,IPTOT)
         IP=0
         DO IX=1,41
            DO IY=1,41
               DO IZ=1,31
                  IP=IP+1
                  CALL HGNT(30,IP,IERR)
                  FX(IX,IY,IZ)=F(1)
                  FY(IX,IY,IZ)=F(2)
                  FZ(IX,IY,IZ)=F(3)
               END DO
            END DO
         END DO
         CALL HREND('FIELD')
      ENDIF
*
* Set run and first event number from RUNG GEANT data card
*
      IRUN = IDRUN
      IEVNT = IDEVT
C
C User action
C
      CALL GPUDAT
10000 FORMAT(' GPDDAT: NCPL out of range, NCPL=',I8,'. Not used')
10100 FORMAT(' GPDDAT: NCSI out of range, NCSI=',I8,'. Not used')
10200 FORMAT(' GPDDAT: NCAB out of range, NCAB=',I8,'. Not used')
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.03/00 06/11/2000  01.31.21  by  Francesco Cafagna
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 20/03/97  16.04.05  by  Francesco Cafagna
*CMZ :  1.00/02 02/03/96  12.36.09  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   23/02/96
      SUBROUTINE GUDIGI
************************************************************************
*                                                                      *
* To perform user detectors digitization                               *
*                                                                      *
* Called by: GTRIG                                                     *
* Author: Francesco Cafagna, 23/02/96 12.50.38                         *
*                                                                      *
************************************************************************
#include "gpkey.inc"
*
* Call TOF DIGI routine
*
      IF(PTOF) THEN
         CALL GPDTOF
      ENDIF
*
* Call TRD DIGI routine
*
      IF(PTRD) CALL GPDTRD
*
* Call CAT DIGI routine
*
      IF(PCAT) CALL GPDCAT
*
* Call CAS DIGI routine
*
      IF(PCAS) CALL GPDCAS
*
* Call SPE DIGI routine
*
      IF(PSPE) CALL GPDSPE
*
* Call CAL DIGI routine
*
      IF(PCAL) CALL GPDCAL
*
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 08/02/2002  17.54.28  by  Unknown
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.00/02 04/04/96  17.54.02  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   04/04/96
      SUBROUTINE GPXE
************************************************************************
*                                                                      *
* To define special tracking parameters for Xenon                      *
*                                                                      *
* Called by: GPDAT                                                     *
* Author: Francesco Cafagna, 04/04/96 17.41.17                         *
*                                                                      *
************************************************************************
#include "gpxe.inc"
*kinetic energy cuts in GeV:
      CUTGAMXE = 0.0001
      CUTELEXE = 0.0001
      CUTHADXE = 0.0001
      CUTNEUXE = 0.0001
      CUTMUOXE = 0.0001
c      BCUTEXE = CUTGAMXE
c      BCUTMXE = CUTGAMXE
      BCUTEXE = 0.001
      BCUTMXE = 0.001
      DCUTEXE = CUTELEXE
      DCUTMXE = CUTELEXE
      PPCUTMXE  = 0.01
*control of physics process:
*default:
c      PAIRXE = 1
c      COMPXE = 1
c      PHOTXE = 1
c      PFISXE = 0
c      ANNIXE = 1
c      BREMXE = 1
c      HADRXE = 1
c      MUNUXE = 1
c      DCAYXE = 1
C      MULSXE = 1
cc      BIRK1XE =
cc      BIRK2XE =
cc      BIRK3XE =
cc      LABSXE =
cc      SYNCXE =
*user:
*.
#if defined(GPAMELA_GARFIELD)
      LOSSXE = 0
      DRAYXE = 0
      MULSXE = 0
      PAIRXE = 0
      COMPXE = 0
      PHOTXE = 0
      PFISXE = 0
      ANNIXE = 0
      BREMXE = 0
      HADRXE = 0
      MUNUXE = 0
      DCAYXE = 0
*.
#endif
#if !defined(GPAMELA_GARFIELD)
      LOSSXE = 1
      DRAYXE = 1
      MULSXE = 1
      PAIRXE = 1
      COMPXE = 1
      PHOTXE = 1
      PFISXE = 0
      ANNIXE = 1
      BREMXE = 1
      HADRXE = 1
      MUNUXE = 1
      DCAYXE = 1
#endif
*
      RETURN
      END

*
* $Id$
*
* $Log$
*
#if !defined(GPAMELA_INTER)
*CMZ :  2.02/00 10/10/2000  15.15.49  by  Francesco Cafagna
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.06  by  Francesco Cafagna
*CMZ :  1.00/02 06/02/96  17.34.49  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      PROGRAM GPMAIN
************************************************************************
*                                                                      *
* Program for PAMELA Simulation with GEANT                             *
* This is the main routine to be used for batch or not                 *
* interactive version                                                  *
*                                                                      *
* Author: Francesco Cafagna, 30/11/95 01.51.27                         *
*                                                                      *
************************************************************************
*
#include "gcflag.inc"
#include "gpmem.inc"
#include "gpzhbo.inc"
#include "gpzcom.inc"
*
*     ------------------------------------------------------------------
*
*   ZEBRA, HBOOK, HIGZ Initialization
      CALL GZEBRA(NWGEAN)
      CALL HLIMIT(-NWPAW)
#if defined(GPAMELA_HIGZ)
      CALL IGINIT(0)
      IWK=0
      CALL IGWKTY(IWK)
*
*
*           Initialize HPLOT
*
      CALL HPLINT(IWK)
      CALL HERMES(6)
      CALL IGSA(0)
#endif
*
*             Geant initialization.
      CALL UGINIT
*
*             Main structures printings.
*
*      CALL GPRINT('PART',0)
      CALL GPRINT('MATE',0)
      CALL GPRINT('TMED',0)
* VOLU printout commented to avoid GEANT bug
*      CALL GPRINT('VOLU',0)
*
*
*             Start events processing.
      CALL GRUN
*
*             End of run.
      CALL UGLAST
      STOP
      END
#endif

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 01/05/2001  16.02.39  by  Marialuigia Ambriola
*CMZ :  2.03/00 06/11/2000  01.54.21  by  Francesco Cafagna
*CMZ :  2.02/00 12/10/2000  16.03.56  by  Francesco Cafagna
*CMZU:  2.01/00 04/04/2000  18.14.49  by  Unknown
*CMZ :  2.00/00 01/03/2000  12.47.24  by  Francesco Cafagna
*CMZ :  1.02/00 22/10/99  13.28.17  by  Francesco Cafagna
*CMZ :  1.01/00 02/05/96  08.57.38  by  Francesco Cafagna
*CMZ :  1.00/03 15/04/96  14.56.37  by  Francesco Cafagna
*CMZ :  1.00/02 05/04/96  09.10.39  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE GPFFR
************************************************************************
*                                                                      *
*   To define GPAMELA user's data cards
*                                                                      *
* Called by: UGINIT
* Author: Francesco Cafagna, 30/11/95 16.16.02                         *
*                                                                      *
************************************************************************
#include "gpkey.inc"
#include "gpdkey.inc"
*
* User action
*
      CALL GPUFFR
*
*  Define MAGN card to turn on or off the magnet
*
      CALL FFKEY('MAGN',FFIELD,1,'I')
*
*  Define NDET card to exclude detectors from the simulation
*
      CALL FFKEY('NDET',NDET,7,'I')
*
*  Define CALO card to select specific option for CALO detector
*
      CALL FFKEY('CALO',NCAL,3,'I')
*
*  Define HBOOK card to enable CWN booking and filling
*
      CALL FFKEY('HCWN',HBOOK,1,'I')
*
*  Define SPTM card to enable special tracking media definition for some
*  material
*
      CALL FFKEY('SPTM',NSPTM,17,'I')
*
*  Define HPAK card to slect FLUKA hadronic package
*
      CALL FFKEY('HPAK',NHPAK,1,'I')
*
*  Define AUTM card to slect AUTO tracking media prameter calculation
*
      CALL FFKEY('AUTM',NAUTMED,5,'I')
*
*  Define cards to define the tracking media prameters values
*
      CALL FFKEY('TMAX',VTMAXFD,1,'R')
      CALL FFKEY('STMA',VSTEMAX,1,'R')
*ML:
      CALL FFKEY('DEEM',VDEEMAX,1,'R')
*      CALL FFKEY('DEMA',VDEEMAX,1,'R')
*END ML.
      CALL FFKEY('EPSI',VEPSIL ,1,'R')
      CALL FFKEY('STMI',VSTMIN ,1,'R')
*ML:
*
*  Define cards to define the tracking parameters for each media
*
      CALL FFKEY('TPAL',TPAL,5,'R')
      CALL FFKEY('TG10',TG10,5,'R')
      CALL FFKEY('TPN2',TPN2,5,'R')
      CALL FFKEY('TPW ',TPW,5,'R')
      CALL FFKEY('TPKA',TPKA,5,'R')
      CALL FFKEY('TPFE',TPFE,5,'R')
      CALL FFKEY('TRAD',TRAD,5,'R')
      CALL FFKEY('TPRO',TPRO,5,'R')
      CALL FFKEY('TPCF',TPCF,5,'R')
      CALL FFKEY('TPSC',TPSC,5,'R')
      CALL FFKEY('TSCA',TSCA,5,'R')
      CALL FFKEY('TSTR',TSTR,5,'R')
      CALL FFKEY('TPXE',TPXE,5,'R')
      CALL FFKEY('TPAE',TPAE,5,'R')
*EM:
      CALL FFKEY('TPW2',TPW2,5,'R')
      CALL FFKEY('TPCE',TPCE,5,'R')
      CALL FFKEY('T10C',T10C,5,'R')
*END EM.
*END ML.

*
*  Define HBFI to define an user HBOOK file name and LUNIT
*
      CALL FFKEY('HBFI',NHBFILE,21,'I')

*
*  Define GAFI to define the GARFIELD file and LUNIT
*
      CALL FFKEY('GAFI',NGARFILE,21,'I')
*
*  Define SSTR to enable gaussian straggling in silicon
*
      CALL FFKEY('SSTR',ISSTR,3,'M')
*
*  Define GEN to define generation surface and quote
*
      CALL FFKEY('GEN ',XYZGEN,5,'R')
*
*  Define DZSH to define the height adjust for the external shell SHEL
*
      CALL FFKEY('DZSH',DZSH,1,'R')
*
*  Define HLON to select a longer CWN-tupla
*
      CALL FFKEY('HLON',HLON,1,'I')
*
*  ML: Define PHI to define phi generation angle
*
      CALL FFKEY('PHI ',PHGEN,2,'R')
*
*  Define THET to define theta generation angle
*
      CALL FFKEY('THET',THGEN,2,'R')
*  END ML.
*
*  Define NCPL to exclude calorimeter planes from the geometry definition
*
      CALL FFKEY('NCPL',NCPL,44,'I')
*
*  Define NCSI to exclude calorimeter silicon detectors from a plane
*
      CALL FFKEY('NCSI',NCSI,9,'I')
*
*  Define NCAB to exclude calorimeter absorber planes
*
      CALL FFKEY('NCAB',NCAB,22,'I')
*
*  Define DETEcotr cards to exclude detector volume, physics or n-tple
*  from the simulation
*
      CALL FFKEY('CAS ',NDECAS,3,'I')
      CALL FFKEY('CAT ',NDECAT,3,'I')
      CALL FFKEY('TOF ',NDETOF,3,'I')
      CALL FFKEY('TRD ',NDETRD,3,'I')
      CALL FFKEY('SPE ',NDESPE,3,'I')
      CALL FFKEY('CAL ',NDECAL,3,'I')
      CALL FFKEY('S4 ',NDES4,3,'I')
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 06/04/2001  14.50.18  by  Marialuigia Ambriola
*CMZ :  2.03/00 06/11/2000  01.09.51  by  Francesco Cafagna
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 28/02/2000  18.48.57  by  Francesco Cafagna
*CMZ :  1.02/00 04/02/2000  20.31.22  by  Francesco Cafagna
*CMZ :  1.01/00 16/05/96  17.38.13  by  Francesco Cafagna
*CMZ :  1.00/02 28/03/96  23.38.53  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE GPSED
*********************************************************************
*
* To define sets, detectors and HITS
*
* The USER set numbers are:
*  S11 = 1
*  S12 = 2
*  S21 = 3
*  S22 = 4
*  S31 = 5
*  S32 = 6
*  S4  = 7
*  TRD = 8
*  CAT = 9
*  CAS = 10
*  SPE = 11
*  CAL = 12
*
* The USER detector numbers are, inside the SET structure,:
*  S11X= 1
*  S12Y= 1
*  S21X= 1
*  S22Y= 1
*  S31Y= 1
*  S32X= 1
*  CHAE= 1
*  TRSI= 1
*  CATL= 1
*  CATT= 2
*  CASX= 1
*  CASY= 2
*  TSPA= 1
*  CASI= 1
*  CAST= 1, in case the division have been requested
*
* The USER detector type are:
*  1, scintillator counter
*  2, aerogel
*  3, TRD
*  4, silicon detector
*
* Called by: UGINIT
* Author: F. Cafagna 13/02/96 13.21.27                               *
*                                                                    *
**********************************************************************
#include "gpgeo.inc"
#include "gpkey.inc"
#include "gpsed.inc"
*
      INTEGER NBITSV(6),NWHI,NWDI
      CHARACTER*4 CVOLU(6)
*
      CALL VZERO(NBITSV,6)
      NWHI = 100
      NWDI = 100
*
c      CVOLU(1) ='PAME'
*
* Tof
*
      IF(PTOF) THEN
c         NVTOF = 3
         NVTOF = 2
c         NBITSV(1) = 1
c         NBITSV(2) = 1
c         NBITSV(3) = 4
         NBITSV(1) = 1
         NBITSV(2) = 4
         CVOLU(1) ='S11 '
         CVOLU(2) ='S11X'
         CVOLU(3) ='    '
         CVOLU(4) ='    '
         CVOLU(5) ='    '
         CVOLU(6) ='    '
         CALL GSDET('S11 ','S11X',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISS11,IDS11X)
         CNSED(ISS11,IDS11X) = CVOLU(NVTOF)
*
         CVOLU(1) ='S12 '
         CVOLU(2) ='S12Y'
         CALL GSDET('S12 ','S12Y',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISS12,IDS12Y)
         CNSED(ISS12,IDS12Y) = CVOLU(NVTOF)
*
         CVOLU(1) ='S21 '
         CVOLU(2) ='S21X'
         CALL GSDET('S21 ','S21X',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISS21,IDS21X)
         CNSED(ISS21,IDS21X) = CVOLU(NVTOF)
*
         CVOLU(1) ='S22 '
         CVOLU(2) ='S22Y'
         CALL GSDET('S22 ','S22Y',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISS22,IDS22Y)
         CNSED(ISS22,IDS22Y) = CVOLU(NVTOF)
*
         CVOLU(1) ='S31 '
         CVOLU(2) ='S31Y'
         CALL GSDET('S31 ','S31Y',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISS31,IDS31Y)
         CNSED(ISS31,IDS31Y) = CVOLU(NVTOF)
*
         CVOLU(1) ='S32 '
         CVOLU(2) ='S32X'
         CALL GSDET('S32 ','S32X',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISS32,IDS32X)
         CNSED(ISS32,IDS32X) = CVOLU(NVTOF)
*
*ML:
*         NVTOF =1
         NVS4=1
*END ML.
         CVOLU(1) ='S4  '
         CVOLU(2) ='    '
*ML:
*         CALL GSDET('S4  ','S4  ',NVTOF,CVOLU,NBITSV,1,NWHI,NWDI,
*     +   ISS4,IDS4)
         CALL GSDET('S4  ','S4  ',NVS4,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISS4,IDS4)
*         CNSED(ISS4,IDS4) = CVOLU(NVTOF)
         CNSED(ISS4,IDS4) = CVOLU(NVS4)
*END ML.
      ELSE
         ISS11  = -1
         IDS11X = -1
         ISS12  = -1
         IDS12Y = -1
         ISS21  = -1
         IDS21X = -1
         ISS22  = -1
         IDS22Y = -1
         ISS31  = -1
         IDS31Y = -1
         ISS32  = -1
         IDS31X = -1
         ISS4   = -1
         IDS4   = -1
      ENDIF
*
* TRD
*
      IF(PTRD) THEN

         NVTRD = 2
c         NBITSV(1) = 1
c         NBITSV(2) = 1
         NBITSV(1) = 6
         NBITSV(2) = 6
c         CVOLU(2) ='TRDB'
         CVOLU(1) ='TRBS'
         CVOLU(2) ='TRSI'
C #          CVOLU(2) ='TRSO'
C #          CVOLU(3) ='TRSI'
         CVOLU(3) ='    '
         CVOLU(4) ='    '
         CVOLU(5) ='    '
         CVOLU(6) ='    '
         CALL GSDET('TRD ','TRSI',NVTRD,CVOLU,NBITSV,3,NWHI,NWDI,
     +   ISTRD,IDTRSI)
         CNSED(ISTRD,IDTRSI) = CVOLU(NVTRD)
*ML:
 	 NVTRD=3
         NBITSV(3) = 2
         CVOLU(3) = 'TRSO'
 	 CALL GSDET('TRD ','TRSO',NVTRD,CVOLU,NBITSV,3,NWHI,NWDI,
     +   ISTRD,IDTRSO)
         CNSED(ISTRD,IDTRSO) = CVOLU(NVTRD)
****** DON'T MODIFY !!!!!! SEE GPDTRD
	NVTRD = 2
*END ML.
*
      ELSE
         ISTRD = -1
         IDTRSI= -1
*ML:
	 IDTRSO= -1
*END ML.
      ENDIF
*
* CAT
*
      IF(PCAT) THEN
         NVCAT = 2
c         NBITSV(1) = 1
         NBITSV(1) = 1
         NBITSV(2) = 2
         CVOLU(1) ='CATB'
         CVOLU(2) ='CATL'
         CVOLU(3) ='    '
         CVOLU(4) ='    '
         CVOLU(5) ='    '
         CVOLU(6) ='    '
         CALL GSDET('CAT ','CATL',NVCAT,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISCAT,IDCATL)
         CNSED(ISCAT,IDCATL) = CVOLU(NVCAT)
         CVOLU(2) ='CATT'
         CALL GSDET('CAT ','CATT',NVCAT,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISCAT,IDCATT)
         CNSED(ISCAT,IDCATT) = CVOLU(NVCAT)
      ELSE
         ISCAT = -1
         IDCATT= -1
         IDCATL= -1
      ENDIF
*
* CAS
*
      IF(PCAS) THEN
         NVCAS = 1
c         NBITSV(1) = 1
         NBITSV(1) = 4
         CVOLU(1) ='CASX'
         CVOLU(2) ='    '
         CVOLU(3) ='    '
         CVOLU(4) ='    '
         CVOLU(5) ='    '
         CVOLU(6) ='    '
         CALL GSDET('CAS ','CASX',NVCAS,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISCAS,IDCASX)
         CNSED(ISCAS,IDCASX) = CVOLU(NVCAS)
         CVOLU(1) ='CASY'
         CALL GSDET('CAS ','CASY',NVCAS,CVOLU,NBITSV,1,NWHI,NWDI,
     +   ISCAS,IDCASY)
         CNSED(ISCAS,IDCASY) = CVOLU(NVCAS)
      ELSE
         ISCAS = -1
         IDCASX= -1
      ENDIF
*
* SPE
*
      IF(PSPE) THEN
         NVSPE = 4
c         NBITSV(1) = 1
c         NBITSV(2) = 1
         NBITSV(1) = 3
         NBITSV(2) = 1
         NBITSV(3) = INT(LOG(FLOAT(NTRSL))/LOG(2.)) + 1
         NBITSV(4) = 2
c         CVOLU(2) ='SPEB'
         CVOLU(1) ='TRPB'
         CVOLU(2) ='TRPL'
         CVOLU(3) ='TRSL'
         CVOLU(4) ='TSPA'
         CVOLU(5) ='    '
         CVOLU(6) ='    '
         CALL GSDET('SPE ','TSPA',NVSPE,CVOLU,NBITSV,4,NWHI,NWDI,
     +   ISSPE,IDTSPA)
         CNSED(ISSPE,IDTSPA) = CVOLU(NVSPE)
      ELSE
         ISSPE = -1
         IDTSPA= -1
      ENDIF
*
* CAL
*
      IF(PCAL) THEN
c         NBITSV(1) = 1
c         NBITSV(2) = 1
         NBITSV(1) = INT(LOG(FLOAT(2*NCAPL))/LOG(2.)) + 1
         NBITSV(2) = 4
         NBITSV(3) = INT(LOG(FLOAT(NCASTR))/LOG(2.))+1
c         CVOLU(2) ='CALB'
         CVOLU(1) ='CAPL'
         CVOLU(2) ='CASI'
         CVOLU(3) ='CAST'
         CVOLU(4) ='    '
         CVOLU(5) ='    '
         CVOLU(6) ='    '
         NVCAL = 3
         CALL GSDET('CAL ','CAST',NVCAL,CVOLU,NBITSV,4, NWHI,NWDI,
     +      ISCAL,IDCASI)
         CNSED(ISCAL,IDCASI) = CVOLU(NVCAL)
      ELSE
         ISCAL  = -1
         IDCASI = -1
      ENDIF
*
* User action
*
      CALL GPUSED
*
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 30/03/2001  14.16.15  by  Marialuigia Ambriola
*CMZ :  2.01/00 08/03/2000  18.33.09  by  Unknown
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 22/10/99  17.53.59  by  Francesco Cafagna
*CMZ :  1.01/00 02/05/96  09.43.56  by  Francesco Cafagna
*CMZ :  1.00/02 21/02/96  10.12.34  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE GPFIL
************************************************************************
*                                                                      *
*            To open FFREAD and HBOOK files
*
* Called by: GPAMELA,GXINT
*                                                                      *
* Author: Francesco Cafagna, 30/11/95 15.53.48                         *
*                                                                      *
************************************************************************
#include "gppntp.inc"
#include "gpunit.inc"
*
* User action
*
      CALL GPUFIL
*
*             Open a HBOOK4 direct access file
*
      CALL HROPEN(LUHBK,'GPAMELA',CHHBK,'N',NBSIZE,ISTAT)
*
*             Open the magnetic field map
*
C fc +SELF,IF=UNIX.
C fc       OPEN(UNIT=LUFMAP,FILE=CHFMAP,FORM='UNFORMATTED',
C fc      +     STATUS='OLD')
C fc +SELF,IF=-UNIX.
C fc       OPEN(UNIT=LUFMAP,FILE=CHFMAP,FORM='UNFORMATTED',SHARED,
C fc      +     STATUS='OLD',READONLY)
C fc +SELF.
*ML:
      CALL HROPEN(LUFMAP,'FIELD',CHFMAP,' ',NBSIZE,ISTAT)
*END ML.
*
*ML: (to simulate the TR from TRD)
      OPEN(UNIT=LUTR,FILE=CHTR,FORM='UNFORMATTED',STATUS='UNKNOWN')
*END ML.
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 14/11/2000  09.13.05  by  Emiliano Mocchiutti
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.06  by  Francesco Cafagna
*CMZ :  1.00/02 08/02/96  17.12.36  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   08/02/96
      SUBROUTINE GPCATV
************************************************************************
*                                                                      *
* Volumes definition for the TOP  anticoincidence counters             *
* Called by: GPGEO                                                     *
*                                                                      *
* Author: Francesco Cafagna, 08/02/96 16.58.49                         *
*                                                                      *
************************************************************************
#include "gpgeo.inc"
#include "gpmed.inc"
*
      INTEGER IROT,IVOLU,N,NMED,NUM
      REAL X,Y,Z
*EM:
      NMED=MSCIN
*
*  Define the CATL     volume
*
      CALL GSVOLU('CATL','BOX ',NMED,CATL, 3,IVOLU)
*
*  Define the CATT     volume
*
      CALL GSVOLU('CATT','BOX ',NMED,CATT, 3,IVOLU)
*
      NMED=MN2
*
*  Define the CATH     volume
*
      CALL GSVOLU('CATH','BOX ',NMED,CATH, 3,IVOLU)
*
*  Define the CATF     volume
*
      CALL GSVOLU('CATF','BOX ',NMED,CATF, 3,IVOLU)
*
      NMED=MAL
*
*  Define the CATB     volume
*
      CALL GSVOLU('CATB','BOX ',NMED,CATB, 3,IVOLU)
*
*  Define the CATO     volume
*
      CALL GSVOLU('CATO','BOX ',NMED,CATO, 3,IVOLU)
*
*  Define the CATP     volume
*
      CALL GSVOLU('CATP','BOX ',NMED,CATP, 3,IVOLU)
*
* Positioning volume CATT     into the mother CATB
*
      N = 1
C      X= CATL(1)-CATB(1)
C      Y= CATL(2)+(2.*CATT(2)-CATB(2))
      X = -CATT(1)
      Y = 0.
      Z = 0.
      CALL GSPOS('CATT',N,'CATB',X,Y,Z,0,'ONLY')
      N = 2
      X = -X
      Y = -Y
      Z = 0.
      CALL GSPOS('CATT',N,'CATB',X,Y,Z,0,'ONLY')
*
* Positioning volume CATL     into the mother CATB
*
      N = 1
C      X = -CATT(1)-(2.*CATL(1)-CATB(1))
C      Y = CATT(2)-CATB(2)
      X = -(2*CATT(1)+CATL(1))
      Y = 0.
      Z = 0.
      CALL GSPOS('CATL',N,'CATB',X,Y,Z,0,'ONLY')
      N = 2
      X = -X
      Y = -Y
      Z = 0.
      CALL GSPOS('CATL',N,'CATB',X,Y,Z,0,'ONLY')
*
* Positioning volume CATH     into the mother CATB
*
      N = 1
      X = 0.
      Y = 0.
      Z = 0.
      CALL GSPOS('CATH',N,'CATB',X,Y,Z,0,'ONLY')
*
* Positioning volume CATF     into the mother CATB
*
      N = 1
      X = -(2*CATT(1)+CATL(1))
      Y = CATL(2)+CATF(2)
      Z = 0.
      CALL GSPOS('CATF',N,'CATB',X,Y,Z,0,'ONLY')
      N = 2
      X = X
      Y = -Y
      Z = 0.
      CALL GSPOS('CATF',N,'CATB',X,Y,Z,0,'ONLY')
      N = 3
      X = -X
      Y = Y
      Z = 0.
      CALL GSPOS('CATF',N,'CATB',X,Y,Z,0,'ONLY')
      N = 4
      X = X
      Y = -Y
      Z = 0.
      CALL GSPOS('CATF',N,'CATB',X,Y,Z,0,'ONLY')

*
* Positioning volume CATP  into the mother CATB
*
      N = 1
      X = -CATH(1)+CATP(1)
      Y = 0.
      Z = 0.
      CALL GSPOS('CATP',N,'CATB',X,Y,Z,0,'ONLY')
      N = 2
      X = -X
      Y = Y
      Z = 0.
      CALL GSPOS('CATP',N,'CATB',X,Y,Z,0,'ONLY')
*
* Positioning volume CATO  into the mother CATB
*
      N = 1
      X = 0.
      Y = -CATH(2)+CATO(2)
      Z = 0.
      CALL GSPOS('CATO',N,'CATB',X,Y,Z,0,'ONLY')
      N = 2
      X = X
      Y = -Y
      Z = 0.
      CALL GSPOS('CATO',N,'CATB',X,Y,Z,0,'ONLY')
*
      RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  3.00/00 08/02/2002  17.36.53  by  Unknown
*CMZ :  2.01/00 08/03/2000  18.34.57  by  Unknown
*CMZ :  2.00/00 25/02/2000  15.46.40  by  Francesco Cafagna
*CMZ :  1.02/00 22/10/99  16.17.58  by  Francesco Cafagna
*CMZ :  1.01/00 21/05/96  17.33.37  by  Francesco Cafagna
*CMZ :  1.00/02 04/04/96  16.08.24  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   23/02/96
      SUBROUTINE GPDTRD
************************************************************************
*                                                                      *
* To perform TRD digitization                                          *
*                                                                      *
* Called by: GUDIGI                                                    *
* Author: Francesco Cafagna, 23/02/96 12.50.38                         *
*                                                                      *
************************************************************************
#include "gcunit.inc"
#include "gpphit.inc"
       PARAMETER (NH=NHTRD,NHM=NHMTRD,NVOL=5)
#include "gprhit.inc"
#include "gptrd.inc"
#include "gpsed.inc"
*
      INTEGER IS,ID,NV,NVM,NNHM
      CHARACTER*4 CSET
*
*
* Vector zeroed
*
      CALL VZERO(ITRBS,NHMTRD)
*ML:
*      CALL VZERO(ITRSO,NHMTRD)
      CALL VZERO(ITRSI,NHMTRD)
*END ML.
#if defined(GPAMELA_INTER)
      CALL VZERO(XAVTRD,NHMTRD)
      CALL VZERO(YAVTRD,NHMTRD)
      CALL VZERO(ZAVTRD,NHMTRD)
#endif
#if !defined(GPAMELA_INTER)
      CALL VZERO(XINTRD,NHMTRD)
      CALL VZERO(YINTRD,NHMTRD)
      CALL VZERO(ZINTRD,NHMTRD)
#endif
      CALL VZERO(XOUTTRD,NHMTRD)
      CALL VZERO(YOUTTRD,NHMTRD)
      CALL VZERO(ZOUTTRD,NHMTRD)
      CALL VZERO(ERELTRD,NHMTRD)
      CALL VZERO(PATHTRD,NHMTRD)
      CALL VZERO(P0TRD,NHMTRD)
      CALL VZERO(IPARTRD,NHMTRD)
      CALL VZERO(ETRTRD,NHMTRD)
      CALL VZERO(NTRTRD,NHMTRD)
      CALL VZERO(ELOSTRD,NHMTRD)
      CALL VZERO(NUMD  ,NVOL)
C ML:
#if defined(GPAMELA_GARFIELD)
      CALL VZERO(EGARTRD,NHMTRD)
      CALL VZERO(NGARTRD,NHMTRD)
#endif
C END ML.
*
* Starting from the TOP
*
      NV = NVOL
      NVM= NVMAX
      IS   = ISTRD
      ID   = IDTRSI
      CSET = 'TRD '
      IT = -1
*
* Check on the volume level
*
      IF (NV.GT.NVM) THEN
         WRITE(CHMAIL,10000) CSET,CNSED(IS,ID),NVOL,NVMAX,
     +                        IDRUN,IDEVT
         CALL GMAIL(1,0)
         GO TO 10
      ENDIF
      CALL VZERO(VHITS,NH*NHM)
      CALL VZERO(ITRA ,NHM)
      CALL VZERO(NUMBV,NVOL*NHM)
      NHITS = -1
      CALL GPRHIT(CSET,CNSED(IS,ID),IS,ID,NVOL,NH,NHM,1,
     +            IT,NUMD,ITRA,NUMBV,VHITS,NHITS)
*
* If there was a problem in GPRHIT then exit
*
      IF(NHITS.LT.0) THEN
         WRITE(CHMAIL,10200) CSET,CNSED(IS,ID),NHITS,NHM,
     +                        IDRUN,IDEVT
         CALL GMAIL(1,0)
         NTHTRD = -NHITS
         GO TO 10
      ENDIF
*
* >>>>>>>>>>>>>>>>>>>>>> DIGI action
*
*
* Fill the CWN common
*
      NTHTRD = NHITS
      DO I=1,NHITS
         ITRBS(I) = NUMBV((NVTRD-1),I)
*ML:
*         ITRBS(I) = NUMBV((NVTRD-2),I)
*         ITRSO(I) = NUMBV((NVTRD-1),I)
         ITRSI(I) = NUMBV(NVTRD,I)
*END ML.
#if defined(GPAMELA_INTER)
         XAVTRD(I) = VHITS(1,I)
         YAVTRD(I) = VHITS(2,I)
         ZAVTRD(I) = VHITS(3,I)
         XOUTTRD(I) = VHITS(4,I)
         YOUTTRD(I) = VHITS(5,I)
         ZOUTTRD(I) = VHITS(6,I)
         XINTRD(I) = 2*XAVTRD(I) - XOUTTRD(I)
         YINTRD(I) = 2*YAVTRD(I) - YOUTTRD(I)
         ZINTRD(I) = 2*ZAVTRD(I) - ZOUTTRD(I)
#endif
#if !defined(GPAMELA_INTER)
         XINTRD(I) = VHITS(1,I)
         YINTRD(I) = VHITS(2,I)
         ZINTRD(I) = VHITS(3,I)
         XOUTTRD(I) = VHITS(4,I)
         YOUTTRD(I) = VHITS(5,I)
         ZOUTTRD(I) = VHITS(6,I)
         XAVTRD(I) = (XINTRD(I)+XOUTTRD(I))/2.
         YAVTRD(I) = (YINTRD(I)+YOUTTRD(I))/2.
         ZAVTRD(I) = (ZINTRD(I)+ZOUTTRD(I))/2.
#endif
C         ERELTRD(I) = VHITS(7,I)
         ELOSTRD(I) = VHITS(7,I)
         PATHTRD(I) = VHITS(8,I)
         IPARTRD(I) = VHITS(9,I)
         P0TRD(I) = VHITS(10,I)
         ETRTRD(I) = VHITS(11,I)
         NTRTRD(I) = VHITS(12,I)
C ML:
#if defined(GPAMELA_GARFIELD)
         ERELTRD(I) = VHITS(11,I)+VHITS(13,I)
C         EGARTRD(I) = VHITS(11,I)
C         NGARTRD(I) = VHITS(12,I)
         EGARTRD(I) = VHITS(13,I)
         NGARTRD(I) = VHITS(14,I)
C	 PRINT*,'EGARTRD,NGARTRD=',EGARTRD(I),NGARTRD(I),I
C	 PRINT*,'PATHTRD=',VHITS(8,I)
#endif
C END ML.
      ENDDO
*
10000  FORMAT(' GPDTRD: VOLUME level too big: SET=',A4,', DET=',A4,
     +        ',NVOL=',I3,', NVMAX=',I3,', RUN=',I5,', EVT=',I8)
10100  FORMAT(' GPDTRD: MAX number of hits retrived: SET=',A4,
     +        ', DET=',A4,',NHREAD=',I5,', NHMAX=',I5,
     +        ', RUN=',I5,', EVT=',I8)
10200  FORMAT(' GPDTRD: Error in GPRHIT: SET=',A4,
     +        ', DET=',A4,',NHITS=',I5,', NHMAX=',I5,
     +        ', RUN=',I5,', EVT=',I8)
   10 RETURN
      END

*
* $Id$
*
* $Log$
*
*CMZ :  2.01/00 06/03/2000  13.07.03  by  Francesco Cafagna
*CMZ :  2.00/00 03/03/2000  15.39.06  by  Francesco Cafagna
*CMZ :  1.02/00 22/10/99  11.10.56  by  Francesco Cafagna
*CMZ :  1.01/00 21/05/96  08.53.57  by  Francesco Cafagna
*-- Author :    Paolo (The Magic) Papini   23/04/96
#if defined(GPAMELA_PAOLO)
      SUBROUTINE GPSPEHD(NHIT,NPLANE,XI,YI,ZI,XO,YO,ZO,PATH,DE,LKDN)
#endif
#if !defined(GPAMELA_PAOLO)
      SUBROUTINE GPSPEHD(NHIT,NUMV,NLEV,XI,YI,ZI,XO,YO,ZO,PATH,DE,
     +                   LKDN)
#endif
************************************************************************
*                                                                      *
* To perform hit/digit conversion for spectrometer.                    *
* This routine fills the LKD1,LKD2,LKD3,LKD4 array                     *
* and it up-date LKND as total number of digit                         *
*                                                                      *
* Variables definition:                                                *
* IN:                                                                  *
*     NHIT - hit number                                                *
*     NPLANE - plane number                                            *
*     XI,YI,ZI,XO,YO,ZO - input and output hit coordinates             *
*     PATH,DE - hit path lenght and dE/dx                              *
*                                                                      *
* OUT:                                                                 *
*     LKDN - total number of digit                                     *
*                                                                      *
* Called by: GPDSPE                                                    *
* Author: Paolo (The Magic) Papini, 23/04/96 15.45.26                  *
*                                                                      *
************************************************************************
#include "gcunit.inc"
#include "gpphit.inc"
#include "gppdigi.inc"
      PARAMETER (NH=NHSPE,NHM=NHMSPE,NVOL=4)
#include "gpspe.inc"
#include "gpsed.inc"
#include "gpgeo.inc"
#include "gpdspe.inc"
*
* Data block for digitalization
*
      INTEGER NHIT,NPLANE,LKDN,NSIL,NSTRIP,NADC,NEWD
      REAL XSIL,YSIL,XBORD,YBORD
      REAL XI,YI,XO,YO,PATH,DE,CH_DIG(2048)
      REAL RR(3),BB(3)
#if !defined(GPAMELA_PAOLO)
      INTEGER LNAM,LNUM
      DIMENSION NUMV(NLEV),LNAM(NVOL),LNUM(NVOL)
      REAL XYZISI(3),XYZOSI(3),XYZIMA(3),XYZOMA(3),XYZMO(3),XYZSO(3)
#endif
*
      BB(1)=0.
      BB(2)=0.
      BB(3)=0.
#if defined(GPAMELA_MAGN)
      RR(1)=(XI+XO)/2.
      RR(2)=(YI+YO)/2.
      RR(3)=(ZI+ZO)/2.
      CALL GUFLD(RR,BB)
#endif
      NSEPX=1+INT(ABS(XO-XI)/STEPX)
      NSEPY=1+INT(ABS(YO-YI)/STEPY)
      NSEPZ=1+INT(ABS(ZO-ZI)/STEPZ)
#if defined(GPAMELA_PAOLO)
C*
C* X-view digitalization
C*
C      NSIL=INT(((XI+XO)/2.+3.*TSPA(1))/(2.*TSPA(1)))+1
C* go way if no in the silicon
C      IF(NSIL.LT.1.OR.NSIL.GT.3) GOTO 10
C* n.division of hit path
C      NSEP=MAX0(NSEPX,NSEPZ)
C* energy loss in each path division
C      DDE=DE/FLOAT(NSEP)
C* XI-ccor. in the silicon
C      XSIL_I=MOD(XI+3.*TSPA(1),2.*TSPA(1))
C* XO-coor. in the silicon
C      XSIL_O=MOD(XO+3.*TSPA(1),2.*TSPA(1))
C* x-coor. of sensitive edge
C      XBORD=(2.*TSPA(1)-NXSTR*WXSTR)/2.
C* XI of the strip
C      NSTR_I=INT((XSIL_I-XBORD)/WXSTR)+1
C* XO of the strip
C      NSTR_O=INT((XSIL_O-XBORD)/WXSTR)+1
C      NSTR_MIN=MIN0(NSTR_I,NSTR_O)-10
C* minimum strip to be calculated
C      IF(NSTR_MIN.LT.1) NSTR_MIN=1
C      NSTR_MAX=MAX0(NSTR_I,NSTR_O)+10
C* maximum strip to be calculated
C      IF(NSTR_MAX.GT.NXSTR) NSTR_MAX=NXSTR
C+SELF
#endif
#if !defined(GPAMELA_PAOLO)
*
* Fill up the GCVOLU common block
*
*      CALL GFPATH (ISSPE,IDTSPA,NUMV,NLEV,LNAM,LNUM)
c      LNAM(1) =4HPAME
c      LNAM(2) =4HSPEB
      LNAM(1) =4HTRPB
      LNAM(2) =4HTRPL
      LNAM(3) =4HTRSL
      LNAM(4) =4HTSPA
      CALL GLVOLU (NLEV,LNAM,NUMV,IER)
*
* X-view digitalization
*
      NSIL=NUMV(NLEV-1)
* go way if no in the silicon
      IF(NSIL.LT.1.OR.NSIL.GT.3) GOTO 10
*
* Calculate the stripes
*
      NPLANE = NUMV(NLEV-3)
* n.division of hit path
      NSEP=MAX0(NSEPX,NSEPZ)
* energy loss in each path division
      DDE=DE/FLOAT(NSEP)
* trasform coordinates from MARS to silicon center
      XYZIMA(1) = XI
      XYZIMA(2) = YI
      XYZIMA(3) = ZI
      CALL GMTOD(XYZIMA,XYZISI,1)
      XYZOMA(1) = XO
      XYZOMA(2) = YO
      XYZOMA(3) = ZO
      CALL GMTOD(XYZOMA,XYZOSI,1)
* xy-coor. of sensitive edge
      XBORD=(2.*TSPA(1)-NXSTR*WXSTR)/2.
      YBORD=(2.*TSPA(2)-NYSTR*WYSTR)/2.
* xyz-coord. of the paddle origin in MARS
      CALL VZERO(XYZSO,3)
      CALL GDTOM(XYZSO,XYZMO,1)
* Move origin of coordinates to the paddle edge, a guard zone added
      XYZISI(1) = XYZISI(1) + (TSPA(1) - XBORD)
      XYZISI(2) = XYZISI(2) + (TSPA(2) - YBORD)
*
      XYZOSI(1) = XYZOSI(1) + (TSPA(1) - XBORD)
      XYZOSI(2) = XYZOSI(2) + (TSPA(2) - YBORD)
* Calculated the strip number now
      NSTR_I=INT(XYZISI(1)/WXSTR)+1
      NSTR_O=INT(XYZOSI(1)/WXSTR)+1
      NSTR_MIN=MIN0(NSTR_I,NSTR_O)-10
* minimum strip to be calculated
      IF(NSTR_MIN.LT.1) NSTR_MIN=1
      NSTR_MAX=MAX0(NSTR_I,NSTR_O)+10
* maximum strip to be calculated
      IF(NSTR_MAX.GT.NXSTR) NSTR_MAX=NXSTR
#endif
C      PRINT *,'X DIGIT, N.HIT:',NHIT
C      PRINT *,'NSTR_MIN,NSTR_MAX,NSEP',NSTR_MIN,NSTR_MAX,NSEP

* loop on the strip (for the diffusion of Q)
      DO IS=NSTR_MIN,NSTR_MAX
* x-center of the strip IS
         XSTR=XBORD+(IS-0.5)*WXSTR+(2*NSIL-5)*TSPA(1)
C+SELF,IF=PAOLO
C* z-center of the strip
C         ZSTR=ZSPEC+(3.5-NPLANE)*2.*MGPL(3)+(3-NPLANE)*2.*TRPB(3)+
C     +   2.*TRCP(3)+2.*TRRP(3)+2.*TSKP(3)
C+SELF
#if !defined(GPAMELA_PAOLO)
*         XSTR=XYZMO(1)
* Z-coord. of the implanted strip. The upper is the Y view
         ZSTR=XYZMO(3)-TSPA(3)
#endif
* magnetic field effect
         XI=XI-ABS(ZI-ZSTR)*0.2475*BB(2)/15.
         XO=XO-ABS(ZO-ZSTR)*0.2475*BB(2)/15.
*
C       PRINT *,ZSPEC,NPLANE,MGPL(3),TRPB(3),TRCP(3),TRRP(3),TSKP(3)
* charge definition for the strip IS
         CH_DIG(IS)=0.
* loop on the hit path division
         DO IH=1,NSEP
* x-coor. hit division
            XH=XI+(IH-0.5)*(XO-XI)/FLOAT(NSEP)
* Z-coor. hit division
            ZH=ZI+(IH-0.5)*(ZO-ZI)/FLOAT(NSEP)
            IX=1+INT(ABS(XH-XSTR)/STEPX)
            IZ=1+INT(ABS(ZH-ZSTR)/STEPZ)
C        PRINT *,'IX,IZ',IX,IZ,XH,XSTR,ZH,ZSTR
C        PRINT *,IS,IH,IX,IZ,CHARX(IX,IZ)
            IF(IX.LE.NPCHXY.AND.IZ.LE.NPCHZ) THEN
               IF(MOD(IS,2).EQ.1) THEN
                  CH_DIG(IS)=CH_DIG(IS)+DDE*CHARX(IX,IZ)
               ELSE
                  CH_DIG(IS)=CH_DIG(IS)+DDE*CHARX_I(IX,IZ)
               ENDIF
            ENDIF
         ENDDO
      END DO
* loop for C-coupling
      DO IS=NSTR_MIN,NSTR_MAX
* X-view has double strip (ISR is the read strip)
         ISR=INT((IS+1)/2)
         CHARGE=0.
         DO ISSR=ISR-2,ISR+2,1
            IF(2*ISSR-2.GE.NSTR_MIN.AND.2*ISSR.LE.NSTR_MAX) CHARGE=
     +      CHARGE+CCX(1+IABS(ISSR-ISR))* (CH_DIG(2*ISSR-1)+CH_DIG(2*
     +      ISSR)/2+CH_DIG(2*ISSR-2)/2)
         ENDDO
C       CHARGE=CH_DIG(IS)
*
* digitaz record
         NEWD=1
* X-view has double strip (ISR is the read strip)
         IF(LKDN.NE.0) THEN
            DO I=1,LKDN
               IF(NPLANE.EQ.LKD1(I).AND.NSIL.EQ.LKD2(I)
     +         .AND.ISR.EQ.LKD3(I)) THEN
                  NEWD=0
                  RLKD4(I)=RLKD4(I)+CHARGE
               ENDIF
            ENDDO
         ENDIF
         IF(NEWD.EQ.1) THEN
            LKDN=LKDN+1
            IF (LKDN.GT.NDMSPE) THEN
               WRITE(10000,CHMAIL) LKDN
               CALL GMAIL(1,0)
               GO TO 30
            ENDIF
            LKD1(LKDN)=NPLANE
            LKD2(LKDN)=NSIL
            LKD3(LKDN)=ISR
            RLKD4(LKDN)=CHARGE
            LKDH(LKDN)=NHIT
         ENDIF
      ENDDO
   10 CONTINUE
*
* Y-view digitalization
*
      NSEP=MAX0(NSEPY,NSEPZ)
      DDE=DE/NSEP
C+SELF,IF=PAOLO
C      NSIL=INT(((YI+YO)/2.+2.*TSPA(2))/(2.*TSPA(2)))+4
C      IF(NSIL.LT.4.OR.NSIL.GT.5) GOTO 20
C      YSIL_I=MOD(YI+2.*TSPA(2),2.*TSPA(2))
C      YSIL_O=MOD(YO+2.*TSPA(2),2.*TSPA(2))
C      YBORD=(2.*TSPA(2)-NYSTR*WYSTR)/2.
C      NSTR_I=INT((YSIL_I-YBORD)/WYSTR)+1
C      NSTR_O=INT((YSIL_O-YBORD)/WYSTR)+1
C      NSTR_MIN=MIN0(NSTR_I,NSTR_O)-5
C      IF(NSTR_MIN.LT.1) NSTR_MIN=1
C      NSTR_MAX=MAX0(NSTR_I,NSTR_O)+5
C      IF(NSTR_MAX.GT.NYSTR) NSTR_MAX=NYSTR
C+SELF.
#if !defined(GPAMELA_PAOLO)
      NSIL = 5 - (NUMV(NLEV)-1)
      IF(NSIL.LT.4.OR.NSIL.GT.5) GOTO 20
* Calculate the strip number now
      NSTR_I=INT((XYZISI(2))/WYSTR)+1
      NSTR_O=INT((XYZOSI(2))/WYSTR)+1
      NSTR_MIN=MIN0(NSTR_I,NSTR_O)-5
* minimum strip to be calculated
      IF(NSTR_MIN.LT.1) NSTR_MIN=1
      NSTR_MAX=MAX0(NSTR_I,NSTR_O)+5
* maximum strip to be calculated
      IF(NSTR_MAX.GT.NYSTR) NSTR_MAX=NYSTR
#endif
      DO IS=NSTR_MIN,NSTR_MAX
         YSTR=YBORD+(IS-0.5)*WYSTR+(NSIL-5)*2.*TSPA(2)
C+SELF,IF=PAOLO
C         ZSTR=ZSPEC+(3.5-NPLANE)*2.*MGPL(3)+(3-NPLANE)*2.*TRPB(3)+
C     +   2.*TRCP(3)+2.*TRRP(3)+2.*TSKP(3)+2.*TSPA(3)
C+SELF
#if !defined(GPAMELA_PAOLO)
*         YSTR=XYZMO(2)
* Z-coord. of the implanted strip. The lower is the X view
         ZSTR=XYZMO(3) + TSPA(3)
#endif
* magnetic field effect
         XI=XI+ABS(ZI-ZSTR)*0.04716*BB(2)/15.
         XO=XO+ABS(ZO-ZSTR)*0.04716*BB(2)/15.
*
         CH_DIG(IS)=0.
         DO IH=1,NSEP
            YH=YI+(IH-0.5)*(YO-YI)/NSEP
            ZH=ZI+(IH-0.5)*(ZO-ZI)/NSEP
            IY=1+INT(ABS(YH-YSTR)/STEPY)
            IZ=1+INT(ABS(ZH-ZSTR)/STEPZ)
C        PRINT *,IS,IH,IY,IZ,CHARY(IY,IZ)
            IF(IY.LE.NPCHXY.AND.IZ.LE.NPCHZ) CH_DIG(IS)=CH_DIG(IS)+DDE*
     +      CHARY(IY,IZ)
         ENDDO
      ENDDO
      DO IS=NSTR_MIN,NSTR_MAX
         CHARGE=0.
         DO ISS=IS-2,IS+2,1
            IF(ISS.GE.NSTR_MIN.AND.ISS.LE.NSTR_MAX) CHARGE=
     +      CHARGE+CCY(1+IABS(ISS-IS))*CH_DIG(ISS)
         ENDDO
*
* digitaz record
         NEWD=1
* the Y view paddles are connected
         IF(NSIL.EQ.5) NSIL=4
         IF(LKDN.NE.0) THEN
            DO I=1,LKDN
               IF(NPLANE.EQ.LKD1(I).AND.NSIL.EQ.LKD2(I)
     +         .AND.IS.EQ.LKD3(I)) THEN
                  NEWD=0
                  RLKD4(I)=RLKD4(I)+CHARGE
               ENDIF
            ENDDO
         ENDIF
         IF(NEWD.EQ.1) THEN
            LKDN=LKDN+1
            IF (LKDN.GT.NDMSPE) THEN
               WRITE(CHMAIL,10000) LKDN
               CALL GMAIL(1,0)
               GO TO 30
            ENDIF
            LKD1(LKDN)=NPLANE
            LKD2(LKDN)=NSIL
            LKD3(LKDN)=IS
            RLKD4(LKDN)=CHARGE
            LKDH(LKDN)=NHIT
         ENDIF
      ENDDO
   20 CONTINUE
*
10000 FORMAT(' GPSPEHD: too much digitalization= ',I5)
   30 RETURN
      END
